




/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/* CDCK01 Project - 09/30/2020-09/29/2023 */
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/* This SAS program is to aggregate the child/case-level NCANDS Child Files into reporting counties (the residential county of a victim child at the time of reporting).
   Visit "https://www.ndacan.acf.hhs.gov/datasets/datasets-list-ncands-child-file.cfm" to download NCANDS Child Files.
   This program produces the per-county number of screened-in reports (unique counts per child per year)
      for total and by child race/ethnicity, child sex, maltreatment type, reporter type, and substantiation status.
   Child race/ethnicity includes (1) non-Hispanic/Latino White alone, (2) Black alone, (3) Asian alone, (4) American Indian or Alaska Native alone,
      (5) Native Hawaiian or Other Pacific Islander alone, (6) Two or More Races, and (7) Hispanic or Latino including all races.
      Racial groups other than White are categorized while including both Hispanic/Latino and non-Hispanic/Lation children to be consistent with Census data (ACS).
   Child sex includes male and female.
   Maltreatment type includes neglect, physical abuse, sexual abuse, and emotional abuse.
   Reporter type is categorized into professional and nonprofessional reporters.
      Professional reporters include social services, medical, mental health, legal/law enforcement/criminal justice, education, child day care, & foster care personnel.
      Nonprofessional reporters include alleged victim, parent, other relative, friends/neighbor, alleged perpetrator, anonymous reporter, other, and unknown/missing reporters.
   Substantiation cases include "substantiated", "indicated", and "reason to suspect" cases. */
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/* Counties in 50 US States and DC, 2009-2018 */
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/* Hyunil Kim, 02/01/2021 */
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/

ods html newfile=proc path="E:\SASWork\Output";
libname a "Z:\NCANDS\Child";
libname b "Z:\CDCK01\Data_County\CAN";




/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Checking Variable Names between Yearly Files ************************************************************************************************/
/********************************* Checking Variable Names between Yearly Files ************************************************************************************************/
/********************************* Checking Variable Names between Yearly Files ************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*
proc contents data=A.cf2002v5 noprint out=V2002(keep=name);run;data V2002;set V2002;name=upcase(name);V2002=name;run;
proc contents data=A.cf2003v6 noprint out=V2003(keep=name);run;data V2003;set V2003;name=upcase(name);V2003=name;run;
proc contents data=A.cf2004v4 noprint out=V2004(keep=name);run;data V2004;set V2004;name=upcase(name);V2004=name;run;
proc contents data=A.cf2005v6 noprint out=V2005(keep=name);run;data V2005;set V2005;name=upcase(name);V2005=name;run;
proc contents data=A.cf2006v5 noprint out=V2006(keep=name);run;data V2006;set V2006;name=upcase(name);V2006=name;run;
proc contents data=A.cf2007v6 noprint out=V2007(keep=name);run;data V2007;set V2007;name=upcase(name);V2007=name;run;
proc contents data=A.cf2008v5 noprint out=V2008(keep=name);run;data V2008;set V2008;name=upcase(name);V2008=name;run;
proc contents data=A.cf2009v6 noprint out=V2009(keep=name);run;data V2009;set V2009;name=upcase(name);V2009=name;run;
proc contents data=A.cf2010v5 noprint out=V2010(keep=name);run;data V2010;set V2010;name=upcase(name);V2010=name;run;
proc contents data=A.cf2011v5 noprint out=V2011(keep=name);run;data V2011;set V2011;name=upcase(name);V2011=name;run;
proc contents data=A.cf2012v5 noprint out=V2012(keep=name);run;data V2012;set V2012;name=upcase(name);V2012=name;run;
proc contents data=A.cf2013v5 noprint out=V2013(keep=name);run;data V2013;set V2013;name=upcase(name);V2013=name;run;
proc contents data=A.cf2014v4 noprint out=V2014(keep=name);run;data V2014;set V2014;name=upcase(name);V2014=name;run;
proc contents data=A.cf2015v4 noprint out=V2015(keep=name);run;data V2015;set V2015;name=upcase(name);V2015=name;run;
proc contents data=A.cf2016v3 noprint out=V2016(keep=name);run;data V2016;set V2016;name=upcase(name);V2016=name;run;
proc contents data=A.cf2017v3 noprint out=V2017(keep=name);run;data V2017;set V2017;name=upcase(name);V2017=name;run;
proc contents data=A.cf2018v2 noprint out=V2018(keep=name);run;data V2018;set V2018;name=upcase(name);V2018=name;run;
proc contents data=A.cf2019v1 noprint out=V2019(keep=name);run;data V2019;set V2019;name=upcase(name);V2019=name;run;
proc sort data=V2002;by name;run;
proc sort data=V2003;by name;run;
proc sort data=V2004;by name;run;
proc sort data=V2005;by name;run;
proc sort data=V2006;by name;run;
proc sort data=V2007;by name;run;
proc sort data=V2008;by name;run;
proc sort data=V2009;by name;run;
proc sort data=V2010;by name;run;
proc sort data=V2011;by name;run;
proc sort data=V2012;by name;run;
proc sort data=V2013;by name;run;
proc sort data=V2014;by name;run;
proc sort data=V2015;by name;run;
proc sort data=V2016;by name;run;
proc sort data=V2017;by name;run;
proc sort data=V2018;by name;run;
proc sort data=V2019;by name;run;
data Var;merge V2002 V2003 V2004 V2005 V2006 V2007 V2008 V2009 V2010 V2011 V2012 V2013 V2014 V2015 V2016 V2017 V2018 V2019;by name;run;
proc print data=Var;run;
/*
NOTE: All study variables are consistently present in all yearly Child Files - GOOD!!!
*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Importing Macro *****************************************************************************************************************************/
/********************************* Importing Macro *****************************************************************************************************************************/
/********************************* Importing Macro *****************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
%macro DATAIN;
if ChRacAI^=1 then ChRacAI=0; /*Child Race American Indian or Alaska Native*/
if ChRacAs^=1 then ChRacAs=0; /*Child Race Asian*/
if ChRacBl^=1 then ChRacBl=0; /*Child Race Black or African American*/
if ChRacNH^=1 then ChRacNH=0; /*Child Race Native Hawaiian or Other Pacific Islander*/
if ChRacWh^=1 then ChRacWh=0; /*Child Race White*/
if ChRacUd^=1 then ChRacUd=0; /*Child Race Unable to Determine*/
if CEthn  ^=1 then CEthn  =0; /*Child Ethnicity Hispanic or Latino*/
/***/
rpt0=1;                                                                                        /*1=screened-in report*/
neg0=0;if ChMal1=2|ChMal2=2|ChMal3=2|ChMal4=2|ChMal1=3|ChMal2=3|ChMal3=3|ChMal4=3 then neg0=1; /*2=Neglect or Deprivation of Necessities; 3=Medical neglect*/
phy0=0;if ChMal1=1|ChMal2=1|ChMal3=1|ChMal4=1                                     then phy0=1; /*1=Physical Abuse*/
sex0=0;if ChMal1=4|ChMal2=4|ChMal3=4|ChMal4=4                                     then sex0=1; /*4=Sexual Abuse*/
emo0=0;if ChMal1=5|ChMal2=5|ChMal3=5|ChMal4=5                                     then emo0=1; /*5=Psychological or Emotional Maltreatment*/
noa0=0;if ChMal1=6                                                                then noa0=1; /*6=No Alleged Maltreatment*/
vic0=0;if RptVictim=1                                                             then vic0=1; /*1="Substantiated" or "Indicated" or "Reason to Suspect" or "Child Died" (Mortality cases will be deleted later)*/
PrY0=0;if 7>=RptSrc>=1                                                            then PrY0=1; /*1=social services, medical, mental health, legal/law enforcement/criminal justice, education, child day care, & foster care personnel*/
PrN0=0;if PrY0=0                                                                  then PrN0=1; /*1=alleged victim, parent, other relative, friends/neighbor, alleged perpetrator, anonymous reporter, other, and unknown/missing*/
w0  =0;if ChRacAI+ChRacAs+ChRacBl+ChRacNH+ChRacWh+ChRacUd+CEthn=1 & ChRacWh=1     then w0  =1; /*Child Race White*/
b0  =0;if ChRacAI+ChRacAs+ChRacBl+ChRacNH+ChRacWh+ChRacUd      =1 & ChRacBl=1     then b0  =1; /*Child Race Black or African American*/
a0  =0;if ChRacAI+ChRacAs+ChRacBl+ChRacNH+ChRacWh+ChRacUd      =1 & ChRacAs=1     then a0  =1; /*Child Race Asian*/
i0  =0;if ChRacAI+ChRacAs+ChRacBl+ChRacNH+ChRacWh+ChRacUd      =1 & ChRacAI=1     then i0  =1; /*Child Race American Indian or Alaska Native*/
p0  =0;if ChRacAI+ChRacAs+ChRacBl+ChRacNH+ChRacWh+ChRacUd      =1 & ChRacNH=1     then p0  =1; /*Child Race Native Hawaiian or Other Pacific Islander*/
u0  =0;if ChRacAI+ChRacAs+ChRacBl+ChRacNH+ChRacWh+ChRacUd      >1                 then u0  =1; /*Child Race Two or More Races*/
h0  =0;if CEthn=1                                                                 then h0  =1; /*Child Ethnicity Hispanic or Latino*/
/***/
race=7;
if w0=1 then race=6;
if b0=1 then race=5;
if a0=1 then race=4;
if i0=1 then race=3;
if p0=1 then race=2;
if h0=1 then race=1;
/***/
if '01OCT1994'd<=rptdt<='30SEP1995'd then fyear=1995;
if '01OCT1995'd<=rptdt<='30SEP1996'd then fyear=1996;
if '01OCT1996'd<=rptdt<='30SEP1997'd then fyear=1997;
if '01OCT1997'd<=rptdt<='30SEP1998'd then fyear=1998;
if '01OCT1998'd<=rptdt<='30SEP1999'd then fyear=1999;
if '01OCT1999'd<=rptdt<='30SEP2000'd then fyear=2000;
if '01OCT2000'd<=rptdt<='30SEP2001'd then fyear=2001;
if '01OCT2001'd<=rptdt<='30SEP2002'd then fyear=2002;
if '01OCT2002'd<=rptdt<='30SEP2003'd then fyear=2003;
if '01OCT2003'd<=rptdt<='30SEP2004'd then fyear=2004;
if '01OCT2004'd<=rptdt<='30SEP2005'd then fyear=2005;
if '01OCT2005'd<=rptdt<='30SEP2006'd then fyear=2006;
if '01OCT2006'd<=rptdt<='30SEP2007'd then fyear=2007;
if '01OCT2007'd<=rptdt<='30SEP2008'd then fyear=2008;
if '01OCT2008'd<=rptdt<='30SEP2009'd then fyear=2009;
if '01OCT2009'd<=rptdt<='30SEP2010'd then fyear=2010;
if '01OCT2010'd<=rptdt<='30SEP2011'd then fyear=2011;
if '01OCT2011'd<=rptdt<='30SEP2012'd then fyear=2012;
if '01OCT2012'd<=rptdt<='30SEP2013'd then fyear=2013;
if '01OCT2013'd<=rptdt<='30SEP2014'd then fyear=2014;
if '01OCT2014'd<=rptdt<='30SEP2015'd then fyear=2015;
if '01OCT2015'd<=rptdt<='30SEP2016'd then fyear=2016;
if '01OCT2016'd<=rptdt<='30SEP2017'd then fyear=2017;
if '01OCT2017'd<=rptdt<='30SEP2018'd then fyear=2018;
if '01OCT2018'd<=rptdt<='30SEP2019'd then fyear=2019;
/***/
ChSex2=put(ChSex,$1.);
race2=put(race,$1.);
ChID2="              ";
ChID2=StaTerr||ChID;
ChID3=ChID2||ChSex2||race2;
RptID2=ChID3||RptID;
/***/
label
SubYr="Submission fiscal year"
fyear="fiscal year based on report date(RptDt)"
StaTerr="State or Territory"
RptFIPS="State/County FIPS code"
ChID="Child ID"
ChID2="staterr||Chid"
ChID3="ChID2||chsex||race"
RptID="Report ID"
RptID2="ChID3||Rptid"
RptDt="Report data"
RptVictim="1=Substantiated or Indicated or MalDeath"
MalDeath="Maltreatment death,1=yes"
rpt0="Report dummy,1=yes"
neg0="Neglect dummy,1=yes"
phy0="Physical abuse dummy,1=yes"
sex0="Sexual abuse dummy,1=yes"
emo0="Emotional abuse dummy,1=yes"
noa0="No alleged maltreatment dummy,1=yes"
w0="1=Child Race White Alone,Not Hispanic"
b0="1=Child Race Black Alone,including Hispanic"
a0="1=Child Race Asian"
i0="1=Child Race American Indian or Alaska Native"
p0="1=Child Race Native Hawaiian or Other Pacific Islander"
u0="1=Child Race Two or More Races"
h0="1=Child Race Hispanic,including all racial groups"
PrY0="Report Source:1=professional,0=non-professional"
PrN0="Report Source:1=non-professional;0=professional"
vic0="Victim(substantiated or indicated) dummy,1=yes"
;
keep
SubYr fyear StaTerr RptFIPS ChID ChID2 ChID3 RptID RptID2 RptDt rpt0 neg0 phy0 sex0 emo0 noa0 vic0 PrY0 PrN0 MalDeath w0 b0 a0 i0 p0 u0 h0 ChAge ChSex
;
%mend DATAIN;





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Importing Data ******************************************************************************************************************************/
/********************************* Importing Data ******************************************************************************************************************************/
/********************************* Importing Data ******************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
DATA A2002;SET A.cf2002v5; %DATAIN;RUN; /*N=2843201*/
DATA A2003;SET A.cf2003v6; %DATAIN;RUN; /*N=3092437*/
DATA A2004;SET A.cf2004v4; %DATAIN;RUN; /*N=3148424*/
DATA A2005;SET A.cf2005v6; %DATAIN;RUN; /*N=3453095*/
DATA A2006;SET A.cf2006v5; %DATAIN;RUN; /*N=3464694*/
DATA A2007;SET A.cf2007v6; %DATAIN;RUN; /*N=3323128*/
DATA A2008;SET A.cf2008v5; %DATAIN;RUN; /*N=3624032*/
DATA A2009;SET A.cf2009v6; %DATAIN;RUN; /*N=3582703*/
DATA A2010;SET A.cf2010v5; %DATAIN;RUN; /*N=3556648*/
DATA A2011;SET A.cf2011v5; %DATAIN;RUN; /*N=3655951*/
DATA A2012;SET A.cf2012v5; %DATAIN;RUN; /*N=3846933*/
DATA A2013;SET A.cf2013v5; %DATAIN;RUN; /*N=3863014*/
DATA A2014;SET A.cf2014v4; %DATAIN;RUN; /*N=3958493*/
DATA A2015;SET A.cf2015v4; %DATAIN;RUN; /*N=4063137*/
DATA A2016;SET A.cf2016v3; %DATAIN;RUN; /*N=4186257*/
DATA A2017;SET A.cf2017v3; %DATAIN;RUN; /*N=4279060*/
DATA A2018;SET A.cf2018v2; %DATAIN;RUN; /*N=4333627*/
DATA A2019;SET A.cf2019v1; %DATAIN;RUN; /*N=4255946*/
DATA A;SET A2002 A2003 A2004 A2005 A2006 A2007 A2008 A2009 A2010 A2011 A2012 A2013 A2014 A2015 A2016 A2017 A2018 A2019;
if StaTerr="PR"|fyear<2009 then delete;RUN; /*N=42817410*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Checking Missing State-Year *****************************************************************************************************************/
/********************************* Checking Missing State-Year *****************************************************************************************************************/
/********************************* Checking Missing State-Year *****************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*
proc freq data=A;tables staterr*subyr/nopercent norow nocol;run;
proc freq data=A;tables staterr*fyear/nopercent norow nocol;run;
*/
/*
ND 2009, OR 2009-2011 are missing state years (no data submission to NCANDS)
!!!!! Solution: delete missing state years !!!!!
*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Lagged Data Sumission Problem ***************************************************************************************************************/
/********************************* Lagged Data Sumission Problem ***************************************************************************************************************/
/********************************* Lagged Data Sumission Problem ***************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*
proc freq data=A;tables subyr;where fyear=2019;run;
proc freq data=A;tables subyr;where fyear=2018;run;
proc freq data=A;tables subyr;where fyear=2017;run;
proc freq data=A;tables subyr;where fyear=2016;run;
proc freq data=A;tables subyr;where fyear=2015;run;
proc freq data=A;tables subyr;where fyear=2014;run;
*/
/*
Cases reported in 2019: # cases in Child File 2019 = 3630254
Cases reported in 2018: # cases in Child File 2018 = 3717344 (85.91%); # cases in Child File 2019 = 609880 (14.09%)
Cases reported in 2017: # cases in Child File 2017 = 3667640 (85.93%); # cases in Child File 2018 = 600633 (14.07%); # cases in Child File  2019      =  65 (0.00%)
Cases reported in 2016: # cases in Child File 2016 = 3581257 (85.80%); # cases in Child File 2017 = 592380 (14.19%); # cases in Child Files 2018-2019 =  91 (0.00%)
Cases reported in 2015: # cases in Child File 2015 = 3435979 (85.03%); # cases in Child File 2016 = 604903 (14.97%); # cases in Child Files 2017-2019 = 124 (0.00%)
Cases reported in 2014: # cases in Child File 2014 = 3382106 (84.99%); # cases in Child File 2015 = 597437 (15.01%); # cases in Child Files 2016-2018 =  96 (0.00%)
***
Among cases reported in a year, about 85% are submitted in that year's Child File and about 15% are submitted in the next year's Child File.
The most recent Child File (i.e., Child File 2019) is not useable to count cases in that year because about 15% of cases will be reported in the next year's Child File.
!!!!! Solution: delete 2019 data !!!!!
*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Deleting Missing State-Year & 2019 Data *****************************************************************************************************/
/********************************* Deleting Missing State-Year & 2019 Data *****************************************************************************************************/
/********************************* Deleting Missing State-Year & 2019 Data *****************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
data B;set A;if (StaTerr="ND" & fyear<2010)|(StaTerr="OR" & fyear<2012)|fyear=2019 then delete;run; /*N=39176847*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Deleting Fatal Cases ************************************************************************************************************************/
/********************************* Deleting Fatal Cases ************************************************************************************************************************/
/********************************* Deleting Fatal Cases ************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*
State ID AND County ID of fatal cases are suppressed with 00000. So, they cannot be used for county-level analysis.
!!!!! Solution: delete fatal cases !!!!!
*/
data C;set B;if MalDeath=1 then delete;run; /*N=39163390*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Deleting Duplicate Records ******************************************************************************************************************/
/********************************* Deleting Duplicate Records ******************************************************************************************************************/
/********************************* Deleting Duplicate Records ******************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*
When duplicate records (multiple RptID/ChID pairs) exist, keep the last records (=highest SubYr or highest RptDt) because last should be most complete.
*/
proc sort data=C;by RptID2 SubYr RptDt;run; /*RptID2="StaTerr||ChID||ChSex||race||Rptid"-see MACRO*/
data D;set C;by RptID2;if last.RptID2;run; /*N=39140837*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Deleting Cases with Out of Range Child Age **************************************************************************************************/
/********************************* Deleting Cases with Out of Range Child Age **************************************************************************************************/
/********************************* Deleting Cases with Out of Range Child Age **************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*
proc freq data=D;tables ChAge;run;
*/
/*
Cases with child age>17--ChAge =18-23:  47247 cases (0.12%)
Unborn cases           --ChAge =77   :  42376 cases (0.11%)
unknown/missing cases  --ChAge>=99   : 205325 cases (0.52%)
***
Total cases with out of range ChAge  : 294948 cases (0.75%)
*/
data E;set D;if chage>17 then delete;run; /*N=38845889*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Deleting Cases with Missing County **********************************************************************************************************/
/********************************* Deleting Cases with Missing County **********************************************************************************************************/
/********************************* Deleting Cases with Missing County **********************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
data F;set E;if substr(RptFIPS,3,5)="999" then delete;run; /*N=38732261 (113628[0.29%] deleted)*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Creating Child Age Category *****************************************************************************************************************/
/********************************* Creating Child Age Category *****************************************************************************************************************/
/********************************* Creating Child Age Category *****************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*
Age1: age 0-5, Age2: age 6-11, Age3: age 12-17
*/
data F;set F;
Age1=0;if    ChAge<6  then Age1=1;
Age2=0;if  5<ChAge<12 then Age2=1;
Age3=0;if 11<ChAge<18 then Age3=1;
run; /*N=38732261*/






/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Creating Outcome Specific Data **************************************************************************************************************/
/********************************* Creating Outcome Specific Data **************************************************************************************************************/
/********************************* Creating Outcome Specific Data **************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
data rpt01;set F;if rpt0=1;run; /*N=38732261*/
data neg01;set F;if neg0=1;run; /*N=24659224*/
data phy01;set F;if phy0=1;run; /*N= 8578255*/
data sex01;set F;if sex0=1;run; /*N= 2803425*/
data emo01;set F;if emo0=1;run; /*N= 2831366*/
data noa01;set F;if noa0=1;run; /*N= 3936580*/
data vic01;set F;if vic0=1;run; /*N= 7057223*/
data rPR01;set F;if PrY0=1;run; /*N=22838080*/
data rNP01;set F;if PrN0=1;run; /*N=15894181*/






/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Converting Duplicate Count into Unique Count ************************************************************************************************/
/********************************* Converting Duplicate Count into Unique Count ************************************************************************************************/
/********************************* Converting Duplicate Count into Unique Count ************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
data rpt01;set rpt01;ChIDYr=ChID3||fyear;run; /*N=38732261*/
data neg01;set neg01;ChIDYr=ChID3||fyear;run; /*N=24659224*/
data phy01;set phy01;ChIDYr=ChID3||fyear;run; /*N= 8578255*/
data sex01;set sex01;ChIDYr=ChID3||fyear;run; /*N= 2803425*/
data emo01;set emo01;ChIDYr=ChID3||fyear;run; /*N= 2831366*/
data noa01;set noa01;ChIDYr=ChID3||fyear;run; /*N= 3936580*/
data vic01;set vic01;ChIDYr=ChID3||fyear;run; /*N= 7057223*/
data rPR01;set rPR01;ChIDYr=ChID3||fyear;run; /*N=22838080*/
data rNP01;set rNP01;ChIDYr=ChID3||fyear;run; /*N=15894181*/
/***/
proc sort data=rpt01;by ChIDYr RptDt;run;
proc sort data=neg01;by ChIDYr RptDt;run;
proc sort data=phy01;by ChIDYr RptDt;run;
proc sort data=sex01;by ChIDYr RptDt;run;
proc sort data=emo01;by ChIDYr RptDt;run;
proc sort data=noa01;by ChIDYr RptDt;run;
proc sort data=vic01;by ChIDYr RptDt;run;
proc sort data=rPR01;by ChIDYr RptDt;run;
proc sort data=rNP01;by ChIDYr RptDt;run;
/***/
data rpt02;set rpt01;by ChIDYr;if first.ChIDYr;run; /*N=32089416*/
data neg02;set neg01;by ChIDYr;if first.ChIDYr;run; /*N=21009657*/
data phy02;set phy01;by ChIDYr;if first.ChIDYr;run; /*N= 7939773*/
data sex02;set sex01;by ChIDYr;if first.ChIDYr;run; /*N= 2657472*/
data emo02;set emo01;by ChIDYr;if first.ChIDYr;run; /*N= 2639424*/
data noa02;set noa01;by ChIDYr;if first.ChIDYr;run; /*N= 3613177*/
data vic02;set vic01;by ChIDYr;if first.ChIDYr;run; /*N= 6569533*/
data rPR02;set rPR01;by ChIDYr;if first.ChIDYr;run; /*N=20096899*/
data rNP02;set rNP01;by ChIDYr;if first.ChIDYr;run; /*N=14106986*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Cleaning Up County FIPS *********************************************************************************************************************/
/********************************* Cleaning Up County FIPS *********************************************************************************************************************/
/********************************* Cleaning Up County FIPS *********************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
data rpt02;set rpt02;if substr(RptFIPS,3,5)="000" then RptFIPS=substr(RptFIPS,1,2)||"999";XX999=0;if substr(RptFIPS,3,5)="999" then XX999=1;run;
data neg02;set neg02;if substr(RptFIPS,3,5)="000" then RptFIPS=substr(RptFIPS,1,2)||"999";XX999=0;if substr(RptFIPS,3,5)="999" then XX999=1;run;
data phy02;set phy02;if substr(RptFIPS,3,5)="000" then RptFIPS=substr(RptFIPS,1,2)||"999";XX999=0;if substr(RptFIPS,3,5)="999" then XX999=1;run;
data sex02;set sex02;if substr(RptFIPS,3,5)="000" then RptFIPS=substr(RptFIPS,1,2)||"999";XX999=0;if substr(RptFIPS,3,5)="999" then XX999=1;run;
data emo02;set emo02;if substr(RptFIPS,3,5)="000" then RptFIPS=substr(RptFIPS,1,2)||"999";XX999=0;if substr(RptFIPS,3,5)="999" then XX999=1;run;
data noa02;set noa02;if substr(RptFIPS,3,5)="000" then RptFIPS=substr(RptFIPS,1,2)||"999";XX999=0;if substr(RptFIPS,3,5)="999" then XX999=1;run;
data vic02;set vic02;if substr(RptFIPS,3,5)="000" then RptFIPS=substr(RptFIPS,1,2)||"999";XX999=0;if substr(RptFIPS,3,5)="999" then XX999=1;run;
data rPR02;set rPR02;if substr(RptFIPS,3,5)="000" then RptFIPS=substr(RptFIPS,1,2)||"999";XX999=0;if substr(RptFIPS,3,5)="999" then XX999=1;run;
data rNP02;set rNP02;if substr(RptFIPS,3,5)="000" then RptFIPS=substr(RptFIPS,1,2)||"999";XX999=0;if substr(RptFIPS,3,5)="999" then XX999=1;run;
proc freq data=rpt02;tables XX999;run; /*Total: 32089416 cases; XX999=1: 5751376 cases (17.92%)*/
proc freq data=neg02;tables XX999;run; /*Total: 21009657 cases; XX999=1: 3653254 cases (17.39%)*/
proc freq data=phy02;tables XX999;run; /*Total:  7939773 cases; XX999=1: 1459247 cases (18.38%)*/
proc freq data=sex02;tables XX999;run; /*Total:  2657472 cases; XX999=1:  563901 cases (21.22%)*/
proc freq data=emo02;tables XX999;run; /*Total:  2639424 cases; XX999=1:  461246 cases (17.48%)*/
proc freq data=noa02;tables XX999;run; /*Total:  3613177 cases; XX999=1:  418100 cases (11.57%)*/
proc freq data=vic02;tables XX999;run; /*Total:  6569533 cases; XX999=1: 1225640 cases (18.66%)*/
proc freq data=rPR02;tables XX999;run; /*Total: 20096899 cases; XX999=1: 3357786 cases (16.71%)*/
proc freq data=rNP02;tables XX999;run; /*Total: 14106986 cases; XX999=1: 2754429 cases (19.53%)*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Aggregating Data ****************************************************************************************************************************/
/********************************* Aggregating Data ****************************************************************************************************************************/
/********************************* Aggregating Data ****************************************************************************************************************************/
/********************************* Aggregating Data ****************************************************************************************************************************/
/********************************* Aggregating Data ****************************************************************************************************************************/
/********************************* Aggregating Data ****************************************************************************************************************************/
/********************************* Aggregating Data ****************************************************************************************************************************/
/********************************* Aggregating Data ****************************************************************************************************************************/
/********************************* Aggregating Data ****************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Creating Dummies to Aggregate ***************************************************************************************************************/
/********************************* Creating Dummies to Aggregate ***************************************************************************************************************/
/********************************* Creating Dummies to Aggregate ***************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
data rpt03;set rpt02;RptT=rpt0;RptW=w0;RptB=b0;RptA=a0;RptI=i0;RptP=p0;RptU=u0;RptH=h0;RptM=0;if ChSex=1 then RptM=1;RptF=0;if ChSex=2 then RptF=1;Rpt1=Age1;Rpt2=Age2;Rpt3=Age3;run;/*N=32089416*/
data neg03;set neg02;NegT=neg0;NegW=w0;NegB=b0;NegA=a0;NegI=i0;NegP=p0;NegU=u0;NegH=h0;NegM=0;if ChSex=1 then NegM=1;NegF=0;if ChSex=2 then NegF=1;Neg1=Age1;Neg2=Age2;Neg3=Age3;run;/*N=21009657*/
data phy03;set phy02;PhyT=phy0;PhyW=w0;PhyB=b0;PhyA=a0;PhyI=i0;PhyP=p0;PhyU=u0;PhyH=h0;PhyM=0;if ChSex=1 then PhyM=1;PhyF=0;if ChSex=2 then PhyF=1;Phy1=Age1;Phy2=Age2;Phy3=Age3;run;/*N= 7939773*/
data sex03;set sex02;SexT=sex0;SexW=w0;SexB=b0;SexA=a0;SexI=i0;SexP=p0;SexU=u0;SexH=h0;SexM=0;if ChSex=1 then SexM=1;SexF=0;if ChSex=2 then SexF=1;Sex1=Age1;Sex2=Age2;Sex3=Age3;run;/*N= 2657472*/
data emo03;set emo02;EmoT=emo0;EmoW=w0;EmoB=b0;EmoA=a0;EmoI=i0;EmoP=p0;EmoU=u0;EmoH=h0;EmoM=0;if ChSex=1 then EmoM=1;EmoF=0;if ChSex=2 then EmoF=1;Emo1=Age1;Emo2=Age2;Emo3=Age3;run;/*N= 2639424*/
data noa03;set noa02;NoaT=noa0;NoaW=w0;NoaB=b0;NoaA=a0;NoaI=i0;NoaP=p0;NoaU=u0;NoaH=h0;NoaM=0;if ChSex=1 then NoaM=1;NoaF=0;if ChSex=2 then NoaF=1;Noa1=Age1;Noa2=Age2;Noa3=Age3;run;/*N= 3613177*/
data vic03;set vic02;VicT=vic0;VicW=w0;VicB=b0;VicA=a0;VicI=i0;VicP=p0;VicU=u0;VicH=h0;VicM=0;if ChSex=1 then VicM=1;VicF=0;if ChSex=2 then VicF=1;Vic1=Age1;Vic2=Age2;Vic3=Age3;run;/*N= 6569533*/
data rPR03;set rPR02;RprT=PrY0;RprW=w0;RprB=b0;RprA=a0;RprI=i0;RprP=p0;RprU=u0;RprH=h0;RprM=0;if ChSex=1 then RprM=1;RprF=0;if ChSex=2 then RprF=1;Rpr1=Age1;Rpr2=Age2;Rpr3=Age3;run;/*N=20096899*/
data rNP03;set rNP02;RnpT=PrN0;RnpW=w0;RnpB=b0;RnpA=a0;RnpI=i0;RnpP=p0;RnpU=u0;RnpH=h0;RnpM=0;if ChSex=1 then RnpM=1;RnpF=0;if ChSex=2 then RnpF=1;Rnp1=Age1;Rnp2=Age2;Rnp3=Age3;run;/*N=14106986*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Checking Missing Child Sex ******************************************************************************************************************/
/********************************* Checking Missing Child Sex ******************************************************************************************************************/
/********************************* Checking Missing Child Sex ******************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*
proc freq data=rpt03;tables ChSex/missing;run;
*/
/*
Unknown/Missing (9) or (.):   218496 children ( 0.67%)
Male            (1)       : 15965948 children (49.75%)
Female          (2)       : 15908063 children (49.57%)
***
!!!!! Solution: missing child sex will be excluded while aggregating data based on the above dummies -- NO ACTION NEEDED !!!!!
*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Aggregating Data into Counties **************************************************************************************************************/
/********************************* Aggregating Data into Counties **************************************************************************************************************/
/********************************* Aggregating Data into Counties **************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
proc sort data=rpt03;by fyear RptFIPS;run; /*N=32089416*/
proc sort data=neg03;by fyear RptFIPS;run; /*N=21009657*/
proc sort data=phy03;by fyear RptFIPS;run; /*N= 7939773*/
proc sort data=sex03;by fyear RptFIPS;run; /*N= 2657472*/
proc sort data=emo03;by fyear RptFIPS;run; /*N= 2639424*/
proc sort data=noa03;by fyear RptFIPS;run; /*N= 3613177*/
proc sort data=vic03;by fyear RptFIPS;run; /*N= 6569533*/
proc sort data=rPR03;by fyear RptFIPS;run; /*N=20096899*/
proc sort data=rNP03;by fyear RptFIPS;run; /*N=14106986*/
/***/
proc summary data=rpt03 nway;class fyear RptFIPS;var RptT RptW RptB RptA RptI RptP RptU RptH RptM RptF Rpt1 Rpt2 Rpt3;output out=rpt04 sum=;run; /*N=8508*/
proc summary data=neg03 nway;class fyear RptFIPS;var NegT NegW NegB NegA NegI NegP NegU NegH NegM NegF Neg1 Neg2 Neg3;output out=neg04 sum=;run; /*N=8506*/
proc summary data=phy03 nway;class fyear RptFIPS;var PhyT PhyW PhyB PhyA PhyI PhyP PhyU PhyH PhyM PhyF Phy1 Phy2 Phy3;output out=phy04 sum=;run; /*N=8502*/
proc summary data=sex03 nway;class fyear RptFIPS;var SexT SexW SexB SexA SexI SexP SexU SexH SexM SexF Sex1 Sex2 Sex3;output out=sex04 sum=;run; /*N=8490*/
proc summary data=emo03 nway;class fyear RptFIPS;var EmoT EmoW EmoB EmoA EmoI EmoP EmoU EmoH EmoM EmoF Emo1 Emo2 Emo3;output out=emo04 sum=;run; /*N=7664*/
proc summary data=noa03 nway;class fyear RptFIPS;var NoaT NoaW NoaB NoaA NoaI NoaP NoaU NoaH NoaM NoaF Noa1 Noa2 Noa3;output out=Noa04 sum=;run; /*N=3721 -- only 22 states report this*/
proc summary data=vic03 nway;class fyear RptFIPS;var VicT VicW VicB VicA VicI VicP VicU VicH VicM VicF Vic1 Vic2 Vic3;output out=vic04 sum=;run; /*N=8504*/
proc summary data=rPR03 nway;class fyear RptFIPS;var RprT RprW RprB RprA RprI RprP RprU RprH RprM RprF Rpr1 Rpr2 Rpr3;output out=rPR04 sum=;run; /*N=8477*/
proc summary data=rNP03 nway;class fyear RptFIPS;var RnpT RnpW RnpB RnpA RnpI RnpP RnpU RnpH RnpM RnpF Rnp1 Rnp2 Rnp3;output out=rNP04 sum=;run; /*N=8508*/
/* !!!!! WARNING WARNING WARNING !!!!!
   Only 21 states and DC have data for children reported with no alleged maltreatment (perhaps mostly siblings in the same household of children reported with an allegation).
   One should exclude 29 states from analysis for children reported with no alleged maltreatment (NOA).*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Checking Identified Counties and Suppressed Counties ****************************************************************************************/
/********************************* Checking Identified Counties and Suppressed Counties ****************************************************************************************/
/********************************* Checking Identified Counties and Suppressed Counties ****************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*
proc freq data=rpt04;tables fyear;run;
proc freq data=rpt04;tables fyear;where substr(RptFIPS,3,5)^="999";run;
proc freq data=rpt04;tables fyear;where substr(RptFIPS,3,5) ="999";run;
*/
/*
   NCANDS suppressed county IDs of cases < 1,000 in annual Child Files by replacing the last three digits of county FIPS (XXXXX) with "000" (i.e., XX000).
   As the first two digits of county FIPS is State FIPS, states of cases with suppressed county IDs are identifiable.
   This study treats "XX000" as combined counties. For example, in 2018, 2247 counties were combined into 47 groups (i.e., combined counties).
   Since most suppressed counties are low-populated rural counties, this study lost a large portion of the variation between rural counties.
   However, this study lost no records due to suppressed county IDs. It is also expected that combining low-populated counties would increase the reliability of report counts per area.
   Census data and other data will be combined in the same manner (this is explained in the SAS program merging data).
   Counties which are identified in some (not all) years are further aggregated into combined counties (see below) because those counties affect the longitudinal change of combined counties.
*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Merging Tables ******************************************************************************************************************************/
/********************************* Merging Tables ******************************************************************************************************************************/
/********************************* Merging Tables ******************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
proc sort data=rpt04;by fyear rptfips;run;
proc sort data=neg04;by fyear rptfips;run;
proc sort data=phy04;by fyear rptfips;run;
proc sort data=sex04;by fyear rptfips;run;
proc sort data=emo04;by fyear rptfips;run;
proc sort data=noa04;by fyear rptfips;run;
proc sort data=vic04;by fyear rptfips;run;
proc sort data=rPR04;by fyear rptfips;run;
proc sort data=rNP04;by fyear rptfips;run;
/***/
data CAN01;merge rpt04 neg04 phy04 sex04 emo04 noa04 vic04 rPR04 rNP04;by fyear rptfips;run; /*N=8508*/
/***/
data CAN02;retain fyear StateFIPS CountyFIPS;set CAN01;
array change _numeric_;do over change;if change=. then change=0;end;
CountyFIPS=RptFIPS*1;StateFIPS=INT(CountyFIPS/1000);
keep fyear CountyFIPS StateFIPS RptT RptW RptB RptA RptI RptP RptU RptH RptM RptF Rpt1 Rpt2 Rpt3 NegT PhyT SexT EmoT NoaT VicT RprT RnpT;
label
fyear="fiscal year based on report date (RptDt)"
CountyFIPS="County FIPS code"
StateFIPS="State FIPS code"
RptT="# (per County/Year) children with a maltreatment report"
RptW="# (per County/Year) non-Hispanic White alone children with a maltreatment report"
RptB="# (per County/Year) Black alone children with a maltreatment report"
RptA="# (per County/Year) Asian alone children with a maltreatment report"
RptI="# (per County/Year) AI/AN alone children with a maltreatment report"
RptP="# (per County/Year) NH/PI alone children with a maltreatment report"
RptU="# (per County/Year) two+ races children with a maltreatment report"
RptH="# (per County/Year) Hispanic children with a maltreatment report"
RptM="# (per County/Year) Male children with a maltreatment report"
RptF="# (per County/Year) Female children with a maltreatment report"
Rpt1="# (per County/Year) children aged 0-5 with a maltreatment report"
Rpt2="# (per County/Year) children aged 6-11 with a maltreatment report"
Rpt3="# (per County/Year) children aged 12-17 with a maltreatment report"
NegT="# (per County/Year) children with a neglect report"
PhyT="# (per County/Year) children with a physical abuse report"
SexT="# (per County/Year) children with a sexual abuse report"
EmoT="# (per County/Year) children with a emotional abuse report"
NoaT="# (per County/Year) children with a 'no-alleged-maltreatment' report"
VicT="# (per County/Year) children with a substantiated maltreatment report"
RprT="# (per County/Year) children with a professional-source maltreatment report"
RnpT="# (per County/Year) children with a nonprofessional-source maltreatment report"
;run; /*N=8508*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* County-Level Over-Time Stability Check -- Unstable Counties will go into combined counties (XX999) ******************************************/
/********************************* County-Level Over-Time Stability Check -- Unstable Counties will go into combined counties (XX999) ******************************************/
/********************************* County-Level Over-Time Stability Check -- Unstable Counties will go into combined counties (XX999) ******************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*
Creating a frequency table (numbers of reported children per county) for an eyeball check
*/
data C09;set CAN02;C09=RptT;if fyear=2009;keep CountyFIPS C09;run;
data C10;set CAN02;C10=RptT;if fyear=2010;keep CountyFIPS C10;run;
data C11;set CAN02;C11=RptT;if fyear=2011;keep CountyFIPS C11;run;
data C12;set CAN02;C12=RptT;if fyear=2012;keep CountyFIPS C12;run;
data C13;set CAN02;C13=RptT;if fyear=2013;keep CountyFIPS C13;run;
data C14;set CAN02;C14=RptT;if fyear=2014;keep CountyFIPS C14;run;
data C15;set CAN02;C15=RptT;if fyear=2015;keep CountyFIPS C15;run;
data C16;set CAN02;C16=RptT;if fyear=2016;keep CountyFIPS C16;run;
data C17;set CAN02;C17=RptT;if fyear=2017;keep CountyFIPS C17;run;
data C18;set CAN02;C18=RptT;if fyear=2018;keep CountyFIPS C18;run;
proc sort data=C09;by CountyFIPS;run;
proc sort data=C10;by CountyFIPS;run;
proc sort data=C11;by CountyFIPS;run;
proc sort data=C12;by CountyFIPS;run;
proc sort data=C13;by CountyFIPS;run;
proc sort data=C14;by CountyFIPS;run;
proc sort data=C15;by CountyFIPS;run;
proc sort data=C16;by CountyFIPS;run;
proc sort data=C17;by CountyFIPS;run;
proc sort data=C18;by CountyFIPS;run;
data Cnty;merge C09 C10 C11 C12 C13 C14 C15 C16 C17 C18;by CountyFIPS;run;
/* proc print data=Cnty;var CountyFIPS C09 C10 C11 C12 C13 C14 C15 C16 C17 C18;run; */
/*
Findings of the eyeball check (NOTE: North Dakota 2009 and Oregon 2009-2011 have been already excluded above--missing state years):
    (1) Three states showed suspected data entry errors of county IDs in early years
            Georgia      (FIPS=13) 2009-2011
            Pennsylvania (FIPS=42) 2009-2014
            Tennessee    (FIPS=47) 2009
!!!!!!! SOLUTION: DELETE THESE STATE YEARS !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    (2) Counties identified in some but not all years during the study period (2009-2018) affect the longitudinal change of combined counties.
        Further, counties with less than 500 reported children in any year are mostly unreliable in longitudinal frequencies.
!!!!!!! SOLUTION: COMBINE COUNTIES SUPPRESSED OR WITH LESS THAN 500 REPORTED CHILDREN IN ANY YEAR INTO COMBINED COUNTIES (XX999) !!!!!!!!!!!!!
    (3) Two combined counties (10999 and 25999) have no count or very low counts of reported children.
!!!!!!! SOLUTION: DELETE THESE COMBINED COUNTIES !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Deleting State-Years with Suspected County ID Entry Errors & Combined Counties with Very Low Counts *****************************************/
/********************************* Deleting State-Years with Suspected County ID Entry Errors & Combined Counties with Very Low Counts *****************************************/
/********************************* Deleting State-Years with Suspected County ID Entry Errors & Combined Counties with Very Low Counts *****************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/***/
/* Deleting State-Years with Suspected County ID Entry Errors */
data CAN03;set CAN02;
if (StateFIPS=13 & fyear<2012)|(StateFIPS=38 & fyear=2009)|(StateFIPS=41 & fyear<2012)|(StateFIPS=42 & fyear<2015)|(StateFIPS=47 & fyear=2009) then delete;
run; /*N=8354*/
/***/
/*proc means data=CAN02 sum;var RptT;run;*/                               /*32089416 reported children (unique count)*/
/*proc freq data=CAN02;tables fyear;where mod(CountyFIPS,1000)^=999;run;*//*# identified = 8047*/
/*proc freq data=CAN02;tables fyear;where mod(CountyFIPS,1000) =999;run;*//*# combined   =  461*/
/*proc freq data=CAN02;tables fyear;                                run;*//*# total      = 8508*/
/***/
/*proc means data=CAN03 sum;var RptT;run;*/                               /*31702456 reported children (unique count)*/
/*proc freq data=CAN03;tables fyear;where mod(CountyFIPS,1000)^=999;run;*//*# identified = 7903*/
/*proc freq data=CAN03;tables fyear;where mod(CountyFIPS,1000) =999;run;*//*# combined   =  451*/
/*proc freq data=CAN03;tables fyear;                                run;*//*# total      = 8354*/
/***/
/* Delaware and Massachusetts provide no data for suppressed counties -- i.e., no combined counties for these states */
data CAN04;set CAN03;
if CountyFIPS=10999|CountyFIPS=25999 then delete; /* Already not in data -- no change */
run; /*N=8354*/
/***/
/*proc means data=CAN04 sum;var RptT;run;*/                               /*31702456 reported children (unique count)*/
/*proc freq data=CAN04;tables fyear;where mod(CountyFIPS,1000)^=999;run;*//*# identified = 7903*/
/*proc freq data=CAN04;tables fyear;where mod(CountyFIPS,1000) =999;run;*//*# combined   =  451*/
/*proc freq data=CAN04;tables fyear;                                run;*//*# total      = 8354*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Combining Unstable Counties (n=418) into Combined Counties (XX999) **************************************************************************/
/********************************* Combining Unstable Counties (n=418) into Combined Counties (XX999) **************************************************************************/
/********************************* Combining Unstable Counties (n=418) into Combined Counties (XX999) **************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
data CAN05;set CAN04;
if CountyFIPS in (
 1003  1009  1015  1043  1055  1069  1077  1081  1095  1101  1103  1117  1121  2050  2090  2110  2122  4007  4017  4023  5005  5063  5091  5111  5123  5125  5129  5131  6041  6055
 6057  6103  6115  8035  8101  9005  9007  9999 10999 12003 12051 12075 12087 12121 13009 13031 13039 13047 13069 13103 13113 13127 13143 13153 13175 13213 13255 13275 13279 13305
15001 16005 16019 16055 16083 17027 17029 17037 17049 17055 17057 17073 17093 17107 17117 17121 17127 17137 17159 17177 17195 18011 18017 18021 18023 18027 18029 18031 18033 18037
18041 18051 18055 18059 18063 18065 18069 18071 18077 18079 18083 18085 18093 18099 18103 18107 18109 18113 18119 18133 18135 18137 18143 18145 18151 18169 18173 18175 18179 19045
19057 19103 19127 19179 19187 20045 20155 20169 21009 21019 21021 21025 21027 21029 21037 21043 21047 21049 21071 21073 21081 21095 21107 21109 21113 21121 21135 21137 21143 21145
21161 21163 21173 21179 21193 21205 21209 21211 21217 21235 22005 22015 22057 22097 22105 22109 23001 23003 23013 23025 24013 24015 24017 24027 24045 25999 26009 26027 26031 26033
26035 26037 26041 26057 26103 26105 26107 26127 26133 26151 27109 27145 27163 28035 28067 28073 28081 28087 28109 28113 28115 28151 29023 29027 29031 29037 29043 29051 29091 29105
29109 29113 29145 29159 29165 29187 29201 29213 30031 30049 30093 31019 31111 31131 31153 31157 33001 33005 33019 34005 34015 34019 34021 34027 34031 34033 34037 34039 35009 35015
35017 35025 35031 35035 35061 36003 36025 36033 36077 36099 37003 37031 37061 37065 37083 37087 37093 37099 37117 37127 37135 37153 37157 37167 37171 37181 37193 37195 38015 38101
39003 39007 39015 39029 39045 39101 39103 39141 39145 39155 39171 39173 40013 40017 40019 40021 40037 40047 40071 40079 40111 40119 40121 40123 40125 40131 40135 40145 40147 41009
41011 41033 41041 41045 41053 41059 41071 42029 42079 42095 42129 45013 45021 45025 45029 45031 45043 45047 45055 45057 45059 45073 45075 45077 45085 46103 47003 47005 47013 47015
47019 47029 47031 47033 47035 47043 47045 47047 47049 47053 47059 47063 47071 47073 47075 47089 47095 47099 47107 47109 47113 47115 47117 47119 47123 47131 47145 47147 47167 47177
47181 47187 48013 48021 48213 48221 48257 48291 49005 49045 51041 51067 51069 51155 51161 51177 51179 51195 51510 51590 51650 51680 51740 51760 53003 53007 53015 53025 53043 53057
53063 54005 54019 54025 54029 54033 54037 54043 54045 54047 54049 54051 54053 54059 54067 54069 54077 54079 54083 54097 54099 54109 55039 55059 55073 56005 56021 56025)
then CountyFIPS=StateFIPS*1000+999;run; /*N=8354*/
/***/
proc sort data=CAN05;by fyear CountyFIPS;run;
proc summary data=CAN05 nway;class fyear CountyFIPS;
var RptT RptW RptB RptA RptI RptP RptU RptH RptM RptF Rpt1 Rpt2 Rpt3 NegT PhyT SexT EmoT NoaT VicT RprT RnpT;output out=CAN06 sum=;run; /*N=6153*/
/***/
data CAN07;retain fyear StateFIPS CountyFIPS;set CAN06;
StateFIPS=INT(CountyFIPS/1000);
label StateFIPS="State FIPS code";
drop _TYPE_ _FREQ_;
run; /*N=6153*/
/*proc means data=CAN05 sum;var RptT;run;*//* 31702456 --i.e., this aggregation deletes no record */





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Permanent Data ******************************************************************************************************************************/
/********************************* Permanent Data ******************************************************************************************************************************/
/********************************* Permanent Data ******************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
data b.CAN;set CAN07;StateYear=StateFIPS*10000+fyear;CountyYear=CountyFIPS*10000+fyear;run;
proc contents data=b.CAN varnum;run;





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Sample Size and Data Coverage ***************************************************************************************************************/
/********************************* Sample Size and Data Coverage ***************************************************************************************************************/
/********************************* Sample Size and Data Coverage ***************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*


Initial Data: Reported children (duplicate counts) in 50 States and DC from 2009 to 2018 while excluding missing state years (ND 2009 and OR 2009-2011)
# of reported children (duplicate counts--i.e., a child is counted as many as reported)
-----------------------------------------------------------------
                           # excluded    # remained    % excluded
Initial data                               39176847
Reports of fatal cases          13457      39163390         0.03%
Duplicate records               22553      39140837         0.06%
Child age>17 cases              47247      39093590         0.12%
Unborn child cases              42376      39051214         0.11%
Missing child age cases        205325      38845889         0.52%
Missing County                 113628      38732261         0.29%
-----------------------------------------------------------------


Duplicate Counts --> Unique Counts
--------------------------------------------------------
                          # of reported children
Duplicate counts          38732261
Unique counts per year    32089416
--------------------------------------------------------


# of reported children (unique count) for sex-specific data
-------------------------------------------
                          n         %
Unknown/Missing      218496     0.67%
Male               15965948    49.75%
Female             15908063    49.57%
-------------------------------------------


# of reported children (unique count) excluded due to County ID issues and longitudinal reliability
-------------------------------------------------------------------------------------------
                                                     # excluded    # remained    % excluded
# reported (unique count)                                            32089416
State-years with suspected County ID entry errors        386960      31702456        1.206%
RI and MA provide no data for suppressed counties             0      31702456        0.000% (nothing to exclude as already not in data)
-------------------------------------------------------------------------------------------
Note: 
All DE counties were identified.
State-years with suspected County ID entry errors: Georgia(FIPS=13) 2009-2011, Pennsylvania(FIPS=42) 2009-2014, Tennessee(FIPS=47) 2009



   -------------------------------------------------------------------------------------------------------------------------
   Year                                2009    2010    2011    2012    2013    2014    2015    2016    2017    2018    Total
   -------------------------------------------------------------------------------------------------------------------------
   Total US counties                   3143    3143    3143    3143    3143    3142    3142    3142    3142    3142    31425
   -------------------------------------------------------------------------------------------------------------------------
   # US counties in final data         2726    2874    2874    3069    3069    3068    3135    3135    3135    3135    30220
   -------------------------------------------------------------------------------------------------------------------------
   # identified counties (FIPS=XXXXX)   518     534     534     581     581     581     592     592     592     592     5697
   -------------------------------------------------------------------------------------------------------------------------
   # combined counties   (FIPS=XX999)    42      44      44      46      46      46      47      47      47      47      456
        # suppressed counties          2208    2340    2340    2488    2488    2487    2543    2543    2543    2543    24523
   -------------------------------------------------------------------------------------------------------------------------
Missing State-Years (no data submission):
   All ND (38) counties in 2009: 53 counties * 1 year = 53 county-years
   All OR (41) counties in 2009-2011: 36 counties * 3 years = 108 county-years
Missing County-Years (no data submission):
   3 MA counties (25007 25015 25019) in 2009-2018: 3 counties * 10 years = 30 county-years
   4 RI counties (44001 44003 44005 44009) in 2009-2018: 4 counties * 10 years = 40 county-years
State-years with suspected County ID entry errors:
   All GA (13) counties in 2009-2011: 159 counties * 3 years = 477 county-years
   All PA (42) counties in 2009-2014: 67 counties * 6 years = 402 county-years
   All TN (47) counties in 2009: 95 counties * 1 year = 95 county-years	

US Child Population (50 States and DC from 2009-2018): 738,349,172
The number of children in final data from 2009-2018  : 708,813,686

The final data covered 98.78% of reported children, 96.17% of US counties (county-years, precisely), and 96.00% of US children (child population in 2009-2018).
*/
