




/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/* CDCK01 Project - 09/30/2020-09/29/2023 */
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*
   This SAS program is to import Spatial (latitude and longitude) Data.
   Census Gazetteer Files: https://www.census.gov/geographies/reference-files/time-series/geo/gazetteer-files.html
   Latitude and longitude coordinates are required for spatial modeling (mostly for assessing and addressing spatial autocorrelation).
*/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/* Counties in 50 US States and DC, 2009-2018 */
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/* Hyunil Kim, 01/06/2021 */
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/





ods html newfile=proc path="E:\SASWork\Output"; /* SAS output option */
libname a "Z:\CDCK01\Data_County\Spatial";      /* Telling SAS where to load/save SAS data */





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/* Importing Gazetteer Files ***************************************************************************************************************************************************/
/* Importing Gazetteer Files ***************************************************************************************************************************************************/
/* Importing Gazetteer Files ***************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
data GAZ2010;infile "Z:\CDCK01\Data_County\Spatial\RAW\2010_Gaz_counties_national.txt" dlm='09'x dsd lrecl=2000 truncover firstobs=2;length USPS $2 NAME $50;input USPS $ GEOID ANSICODE NAME $ POP10 HU10 ALAND AWATER ALAND_SQMI AWATER_SQMI INTPTLAT INTPTLONG;run; /*N=3221, 12 variables*/
data GAZ2012;infile "Z:\CDCK01\Data_County\Spatial\RAW\2012_Gaz_counties_national.txt" dlm='09'x dsd lrecl=2000 truncover firstobs=2;length USPS $2 NAME $50;input USPS $ GEOID ANSICODE NAME $            ALAND AWATER ALAND_SQMI AWATER_SQMI INTPTLAT INTPTLONG;run; /*N=3221, 10 variables*/
data GAZ2013;infile "Z:\CDCK01\Data_County\Spatial\RAW\2013_Gaz_counties_national.txt" dlm='09'x dsd lrecl=2000 truncover firstobs=2;length USPS $2 NAME $50;input USPS $ GEOID ANSICODE NAME $            ALAND AWATER ALAND_SQMI AWATER_SQMI INTPTLAT INTPTLONG;run; /*N=3221, 10 variables*/
data GAZ2014;infile "Z:\CDCK01\Data_County\Spatial\RAW\2014_Gaz_counties_national.txt" dlm='09'x dsd lrecl=2000 truncover firstobs=2;length USPS $2 NAME $50;input USPS $ GEOID ANSICODE NAME $            ALAND AWATER ALAND_SQMI AWATER_SQMI INTPTLAT INTPTLONG;run; /*N=3220, 10 variables*/
data GAZ2015;infile "Z:\CDCK01\Data_County\Spatial\RAW\2015_Gaz_counties_national.txt" dlm='09'x dsd lrecl=2000 truncover firstobs=2;length USPS $2 NAME $50;input USPS $ GEOID ANSICODE NAME $            ALAND AWATER ALAND_SQMI AWATER_SQMI INTPTLAT INTPTLONG;run; /*N=3220, 10 variables*/
data GAZ2016;infile "Z:\CDCK01\Data_County\Spatial\RAW\2016_Gaz_counties_national.txt" dlm='09'x dsd lrecl=2000 truncover firstobs=2;length USPS $2 NAME $50;input USPS $ GEOID ANSICODE NAME $            ALAND AWATER ALAND_SQMI AWATER_SQMI INTPTLAT INTPTLONG;run; /*N=3220, 10 variables*/
data GAZ2017;infile "Z:\CDCK01\Data_County\Spatial\RAW\2017_Gaz_counties_national.txt" dlm='09'x dsd lrecl=2000 truncover firstobs=2;length USPS $2 NAME $50;input USPS $ GEOID ANSICODE NAME $            ALAND AWATER ALAND_SQMI AWATER_SQMI INTPTLAT INTPTLONG;run; /*N=3220, 10 variables*/
data GAZ2018;infile "Z:\CDCK01\Data_County\Spatial\RAW\2018_Gaz_counties_national.txt" dlm='09'x dsd lrecl=2000 truncover firstobs=2;length USPS $2 NAME $50;input USPS $ GEOID ANSICODE NAME $            ALAND AWATER ALAND_SQMI AWATER_SQMI INTPTLAT INTPTLONG;run; /*N=3220, 10 variables*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/* Changing Variable Names & Keeping Necessary Variables ***********************************************************************************************************************/
/* Changing Variable Names & Keeping Necessary Variables ***********************************************************************************************************************/
/* Changing Variable Names & Keeping Necessary Variables ***********************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/* 2009 and 2011 data are not available. 2010 data are used for these years. */
data GAZ2009a;set GAZ2010(rename=(GEOID=CountyFIPS INTPTLAT=Latitude INTPTLONG=Longitude));Year=2009;keep CountyFIPS Year Latitude Longitude;run;/*N=3221, 4 variables*/
data GAZ2010a;set GAZ2010(rename=(GEOID=CountyFIPS INTPTLAT=Latitude INTPTLONG=Longitude));Year=2010;keep CountyFIPS Year Latitude Longitude;run;/*N=3221, 4 variables*/
data GAZ2011a;set GAZ2010(rename=(GEOID=CountyFIPS INTPTLAT=Latitude INTPTLONG=Longitude));Year=2011;keep CountyFIPS Year Latitude Longitude;run;/*N=3221, 4 variables*/
data GAZ2012a;set GAZ2012(rename=(GEOID=CountyFIPS INTPTLAT=Latitude INTPTLONG=Longitude));Year=2012;keep CountyFIPS Year Latitude Longitude;run;/*N=3221, 4 variables*/
data GAZ2013a;set GAZ2013(rename=(GEOID=CountyFIPS INTPTLAT=Latitude INTPTLONG=Longitude));Year=2013;keep CountyFIPS Year Latitude Longitude;run;/*N=3221, 4 variables*/
data GAZ2014a;set GAZ2014(rename=(GEOID=CountyFIPS INTPTLAT=Latitude INTPTLONG=Longitude));Year=2014;keep CountyFIPS Year Latitude Longitude;run;/*N=3220, 4 variables*/
data GAZ2015a;set GAZ2015(rename=(GEOID=CountyFIPS INTPTLAT=Latitude INTPTLONG=Longitude));Year=2015;keep CountyFIPS Year Latitude Longitude;run;/*N=3220, 4 variables*/
data GAZ2016a;set GAZ2016(rename=(GEOID=CountyFIPS INTPTLAT=Latitude INTPTLONG=Longitude));Year=2016;keep CountyFIPS Year Latitude Longitude;run;/*N=3220, 4 variables*/
data GAZ2017a;set GAZ2017(rename=(GEOID=CountyFIPS INTPTLAT=Latitude INTPTLONG=Longitude));Year=2017;keep CountyFIPS Year Latitude Longitude;run;/*N=3220, 4 variables*/
data GAZ2018a;set GAZ2018(rename=(GEOID=CountyFIPS INTPTLAT=Latitude INTPTLONG=Longitude));Year=2018;keep CountyFIPS Year Latitude Longitude;run;/*N=3220, 4 variables*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/* Making Longitudinal Data and Saving Permanent Data **************************************************************************************************************************/
/* Making Longitudinal Data and Saving Permanent Data **************************************************************************************************************************/
/* Making Longitudinal Data and Saving Permanent Data **************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
data a.GAZ; set GAZ2009a GAZ2010a GAZ2011a GAZ2012a GAZ2013a GAZ2014a GAZ2015a GAZ2016a GAZ2017a GAZ2018a;
label
CountyFIPS="County FIPS Code"
Year="Calendar Year"
Latitude="Latitude"
Longitude="Longitude";
run;
proc contents data=a.GAZ varnum;run;
