




/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/* CDCK01 Project - 09/30/2020-09/29/2023 */
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/* 
   This SAS program is to import County-level food insecurity data (Source: https://www.feedingamerica.org/research/map-the-meal-gap/by-county) and manage the data.
   Technical briefs (https://www.feedingamerica.org/research/map-the-meal-gap/how-we-got-the-map-data)
   Disability rates were available since 2012 (ACS 2012). For 2009-2011 fooe insecurity estimates, 2011 disability rates were used.
*/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/* Counties in 50 US States and DC, 2009-2018 */
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/* Hyunil Kim, 03/30/2021 */
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/





ods html newfile=proc path="E:\SASWork\Output"; /* SAS output option */
libname a "Z:\CDCK01\Data_County\Food";         /* Telling SAS where to load/save SAS data */





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/* Importing & Managing CDC US Opioid Dispensing Rate Data *********************************************************************************************************************/
/* Importing & Managing CDC US Opioid Dispensing Rate Data *********************************************************************************************************************/
/* Importing & Managing CDC US Opioid Dispensing Rate Data *********************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/

/* Importing */;
proc import datafile= "Z:\CDCK01\Data_County\Food\Raw\DI_Work.xlsx" out=Food2009 dbms=xlsx replace;sheet="2009";getnames=yes;run;
proc import datafile= "Z:\CDCK01\Data_County\Food\Raw\DI_Work.xlsx" out=Food2010 dbms=xlsx replace;sheet="2010";getnames=yes;run;
proc import datafile= "Z:\CDCK01\Data_County\Food\Raw\DI_Work.xlsx" out=Food2011 dbms=xlsx replace;sheet="2011";getnames=yes;run;
proc import datafile= "Z:\CDCK01\Data_County\Food\Raw\DI_Work.xlsx" out=Food2012 dbms=xlsx replace;sheet="2012";getnames=yes;run;
proc import datafile= "Z:\CDCK01\Data_County\Food\Raw\DI_Work.xlsx" out=Food2013 dbms=xlsx replace;sheet="2013";getnames=yes;run;
proc import datafile= "Z:\CDCK01\Data_County\Food\Raw\DI_Work.xlsx" out=Food2014 dbms=xlsx replace;sheet="2014";getnames=yes;run;
proc import datafile= "Z:\CDCK01\Data_County\Food\Raw\DI_Work.xlsx" out=Food2015 dbms=xlsx replace;sheet="2015";getnames=yes;run;
proc import datafile= "Z:\CDCK01\Data_County\Food\Raw\DI_Work.xlsx" out=Food2016 dbms=xlsx replace;sheet="2016";getnames=yes;run;
proc import datafile= "Z:\CDCK01\Data_County\Food\Raw\DI_Work.xlsx" out=Food2017 dbms=xlsx replace;sheet="2017";getnames=yes;run;
proc import datafile= "Z:\CDCK01\Data_County\Food\Raw\DI_Work.xlsx" out=Food2018 dbms=xlsx replace;sheet="2018";getnames=yes;run;
proc import datafile= "Z:\CDCK01\Data_County\Food\Raw\DI_Work.xlsx" out=Food2019 dbms=xlsx replace;sheet="2019";getnames=yes;run;

/***/;
%macro MC1;
CountyFIPS=FIPS;
CountyYear=CountyFIPS*10000+Year;
FoodInsP=percent_food_insecure+0;
FoodInsN=input(number_food_insecure,comma16.);
TPop=input(total_population,comma16.);
Unemploy=unemployment_rate+0;
Poverty=percent_poor+0;
Black=percent_black+0;
Hispanic=percent_hispanic+0;
Income=input(median_income,comma16.);
Homeowner=percent_homeowners+0;
Disability=percent_disabled+0;
label
Year="Calendar year"
CountyFIPS="County FIPS code"
CountyYear="CntyFIPS & Year (CCCCCYYYY)"
FoodInsP="% persons experienced food insecurity at some point during the year"
FoodInsN="# persons experienced food insecurity at some point during the year"
TPop="Total population"
Unemploy="% unemployed civilian in labor force(16+)"
Poverty="% persons below poverty"
Black="% Black alone among persons"
Hispanic="% Hispanic/Latino among persons"
Income="Median Household Income"
Homeowner="% owner-occupied housing units"
Disability="% civilian noninstitutionalized persons w/ disability"
;
drop 
fips state percent_food_insecure number_food_insecure total_population unemployment_rate 
percent_poor percent_black percent_hispanic median_income percent_homeowners percent_disabled
;
%mend MC1;
data Food2009;set Food2009;Year=2009;%MC1;run;
data Food2010;set Food2010;Year=2010;%MC1;run;
data Food2011;set Food2011;Year=2011;%MC1;run;
data Food2012;set Food2012;Year=2012;%MC1;run;
data Food2013;set Food2013;Year=2013;%MC1;run;
data Food2014;set Food2014;Year=2014;%MC1;run;
data Food2015;set Food2015;Year=2015;%MC1;run;
data Food2016;set Food2016;Year=2016;%MC1;run;
data Food2017;set Food2017;Year=2017;%MC1;run;
data Food2018;set Food2018;Year=2018;%MC1;run;
data Food2019;set Food2019;Year=2019;%MC1;run;

/* Creating long-form data, Labeling variables, & saving a permanent data */;
data a.Food;
retain Year;
set Food2009 Food2010 Food2011 Food2012 Food2013 Food2014 Food2015 Food2016 Food2017 Food2018 Food2019;
run;
proc contents data=a.Food varnum;run;


