




ods html newfile=proc path="E:\SASWork\Output";
libname a "Z:\ICE_CM\ICE_Community_Arrest";
libname b "Z:\CDCK01\Data_County\Census";
libname c "Z:\CDCK01\Data_County";





/*
Research Questions:  

Is the proportion of foreign-born residents associated with the rates of negative child outcomes (i.e., child maltreatment, child disability and low birth weight) at the county-level in the US? 
Hypothesis: Counties with higher proportions of foreign-born residents have lower rates of negative child outcomes 

Is the proportion of Latino residents associated with the rates of negative child outcomes at the county level in the US? 
Hypothesis: Counties with higher proportions of Latino residents have lower rates of negative child outcomes 

Is the ICE arrest rate associated with the rates of child outcomes?  
Hypothesis: Counties with higher rates of ICE arrests have higher rates of negative child outcomes  

Do these relationships differ by race/ethnicity?  
Hypothesis: The associations between the proportion of foreign-born residents and the rates of negative child outcomes differ by racial/ethnic groups (i.e., Latino, Black, and White).  
Hypothesis: The associations between the proportion of Latino residents and the rates of negative child outcomes differ by racial/ethnic groups (i.e., Latino, Black, and White).  
Hypothesis: The associations between the rate of ICE arrests and the rates of negative child outcomes differ by racial/ethnic groups (i.e., Latino, Black, and White) 

Do these relationships change by time?  
Hypothesis: The associations between the proportion of foreign-born residents and the rates of negative child outcomes differ by time. 
Hypothesis: The associations between the proportion of Latino residents and the rates of negative child outcomes differ by time. 
Hypothesis: The associations between the rate of ICE arrests and the rates of negative child outcomes differ by time. 
*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Importing ICE Arrest Data *******************************************************************************************************************/
/********************************* Importing ICE Arrest Data *******************************************************************************************************************/
/********************************* Importing ICE Arrest Data *******************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/* ICE_Arrest_Comm_All = All ICE arrest including community arrests and custodial arrests
   ICE_Arrest_Comm_No  = ICE custodial arrests: ICE assumed custody from another law enforcement agency)
   ICE_Arrest_Comm_Yes = ICE community arrests: individual was located out in the community and was picked up directly by ICE. 
   ALL = all years (2015-2018) */
PROC IMPORT DATAFILE="Z:\ICE_CM\ICE_Community_Arrest\ICE_Arrest_Comm_All_Fiscal_2015.xlsx" OUT=ICEArr_2015   DBMS=xlsx REPLACE;GETNAMES=YES;RUN;
PROC IMPORT DATAFILE="Z:\ICE_CM\ICE_Community_Arrest\ICE_Arrest_Comm_All_Fiscal_2016.xlsx" OUT=ICEArr_2016   DBMS=xlsx REPLACE;GETNAMES=YES;RUN;
PROC IMPORT DATAFILE="Z:\ICE_CM\ICE_Community_Arrest\ICE_Arrest_Comm_All_Fiscal_2017.xlsx" OUT=ICEArr_2017   DBMS=xlsx REPLACE;GETNAMES=YES;RUN;
PROC IMPORT DATAFILE="Z:\ICE_CM\ICE_Community_Arrest\ICE_Arrest_Comm_All_Fiscal_2018.xlsx" OUT=ICEArr_2018   DBMS=xlsx REPLACE;GETNAMES=YES;RUN;
PROC IMPORT DATAFILE="Z:\ICE_CM\ICE_Community_Arrest\ICE_Arrest_Comm_All_Fiscal_ALL.xlsx"  OUT=ICEArr_ALL    DBMS=xlsx REPLACE;GETNAMES=YES;RUN;
PROC IMPORT DATAFILE="Z:\ICE_CM\ICE_Community_Arrest\ICE_Arrest_Comm_No_Fiscal_2015.xlsx"  OUT=ICEArrNC_2015 DBMS=xlsx REPLACE;GETNAMES=YES;RUN;
PROC IMPORT DATAFILE="Z:\ICE_CM\ICE_Community_Arrest\ICE_Arrest_Comm_No_Fiscal_2016.xlsx"  OUT=ICEArrNC_2016 DBMS=xlsx REPLACE;GETNAMES=YES;RUN;
PROC IMPORT DATAFILE="Z:\ICE_CM\ICE_Community_Arrest\ICE_Arrest_Comm_No_Fiscal_2017.xlsx"  OUT=ICEArrNC_2017 DBMS=xlsx REPLACE;GETNAMES=YES;RUN;
PROC IMPORT DATAFILE="Z:\ICE_CM\ICE_Community_Arrest\ICE_Arrest_Comm_No_Fiscal_2018.xlsx"  OUT=ICEArrNC_2018 DBMS=xlsx REPLACE;GETNAMES=YES;RUN;
PROC IMPORT DATAFILE="Z:\ICE_CM\ICE_Community_Arrest\ICE_Arrest_Comm_No_Fiscal_ALL.xlsx"   OUT=ICEArrNC_ALL  DBMS=xlsx REPLACE;GETNAMES=YES;RUN;
PROC IMPORT DATAFILE="Z:\ICE_CM\ICE_Community_Arrest\ICE_Arrest_Comm_Yes_Fiscal_2015.xlsx" OUT=ICEArrYC_2015 DBMS=xlsx REPLACE;GETNAMES=YES;RUN;
PROC IMPORT DATAFILE="Z:\ICE_CM\ICE_Community_Arrest\ICE_Arrest_Comm_Yes_Fiscal_2016.xlsx" OUT=ICEArrYC_2016 DBMS=xlsx REPLACE;GETNAMES=YES;RUN;
PROC IMPORT DATAFILE="Z:\ICE_CM\ICE_Community_Arrest\ICE_Arrest_Comm_Yes_Fiscal_2017.xlsx" OUT=ICEArrYC_2017 DBMS=xlsx REPLACE;GETNAMES=YES;RUN;
PROC IMPORT DATAFILE="Z:\ICE_CM\ICE_Community_Arrest\ICE_Arrest_Comm_Yes_Fiscal_2018.xlsx" OUT=ICEArrYC_2018 DBMS=xlsx REPLACE;GETNAMES=YES;RUN;
PROC IMPORT DATAFILE="Z:\ICE_CM\ICE_Community_Arrest\ICE_Arrest_Comm_Yes_Fiscal_ALL.xlsx"  OUT=ICEArrYC_ALL  DBMS=xlsx REPLACE;GETNAMES=YES;RUN;





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Renaming Variable, Creating Longitudinal Data, & Merging Data *******************************************************************************/
/********************************* Renaming Variable, Creating Longitudinal Data, & Merging Data *******************************************************************************/
/********************************* Renaming Variable, Creating Longitudinal Data, & Merging Data *******************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/* All Arrests */
data ICEArr_2015a;set ICEArr_2015(rename=(ICEArrComm_All_2015=ICEArr));Year=2015;run;
data ICEArr_2016a;set ICEArr_2016(rename=(ICEArrComm_All_2016=ICEArr));Year=2016;run;
data ICEArr_2017a;set ICEArr_2017(rename=(ICEArrComm_All_2017=ICEArr));Year=2017;run;
data ICEArr_2018a;set ICEArr_2018(rename=(ICEArrComm_All_2018=ICEArr));Year=2018;run;
data ICEArr;set ICEArr_2015a ICEArr_2016a ICEArr_2017a ICEArr_2018a;label ICEArr="# ICE arrests (custodial + community arrests) per county";run; /*N=5960, 3 variables*/
/* Custodial (No Community) Arrests */
data ICEArrNC_2015a;set ICEArrNC_2015(rename=(ICECommArr_No_2015=ICEArrNC));Year=2015;run;
data ICEArrNC_2016a;set ICEArrNC_2016(rename=(ICECommArr_No_2016=ICEArrNC));Year=2016;run;
data ICEArrNC_2017a;set ICEArrNC_2017(rename=(ICECommArr_No_2017=ICEArrNC));Year=2017;run;
data ICEArrNC_2018a;set ICEArrNC_2018(rename=(ICECommArr_No_2018=ICEArrNC));Year=2018;run;
data ICEArrNC;set ICEArrNC_2015a ICEArrNC_2016a ICEArrNC_2017a ICEArrNC_2018a;label ICEArrNC="# ICE custodial arrests per county";run; /*N=5612, 3 variables*/
/* Community (Yes Community) Arrests */
data ICEArrYC_2015a;set ICEArrYC_2015(rename=(ICECommArr_Yes_2015=ICEArrYC));Year=2015;run;
data ICEArrYC_2016a;set ICEArrYC_2016(rename=(ICECommArr_Yes_2016=ICEArrYC));Year=2016;run;
data ICEArrYC_2017a;set ICEArrYC_2017(rename=(ICECommArr_Yes_2017=ICEArrYC));Year=2017;run;
data ICEArrYC_2018a;set ICEArrYC_2018(rename=(ICECommArr_Yes_2018=ICEArrYC));Year=2018;run;
data ICEArrYC;set ICEArrYC_2015a ICEArrYC_2016a ICEArrYC_2017a ICEArrYC_2018a;label ICEArrYC="# ICE community arrests per county";run; /*N=2530, 3 variables*/
/* Sorting data for merging */
proc sort data=ICEArr  ;by Year CountyName;run;
proc sort data=ICEArrNC;by Year CountyName;run;
proc sort data=ICEArrYC;by Year CountyName;run;
/* Merging data */
data ICE01;merge ICEArr ICEArrNC ICEArrYC;by Year CountyName;run;
data ICE02;set ICE01;
if CountyName="Do?a Ana County, NM" then CountyName="DOñA ANA COUNTY, NM";
if CountyName="Humbolt County, CA"  then CountyName="Humboldt County, CA";
array change _numeric_;do over change;if change=. then change=0;end;
CountyName=upcase(trim(CountyName));
run;





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Assigning FIPS Codes ************************************************************************************************************************/
/********************************* Assigning FIPS Codes ************************************************************************************************************************/
/********************************* Assigning FIPS Codes ************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/* Getting County FIPS Code from Census Data */
data acs2015;set b.acs20112015;CountyFIPS=FIPS+0;Year=2015;CountyName=upcase(trim(scan(NAME,1,','))||", "||trim(STUSAB));keep CountyFIPS Year NAME STUSAB CountyName;run;
data acs2016;set b.acs20122016;CountyFIPS=FIPS+0;Year=2016;CountyName=upcase(trim(scan(NAME,1,','))||", "||trim(STUSAB));keep CountyFIPS Year NAME STUSAB CountyName;run;
data acs2017;set b.acs20132017;CountyFIPS=FIPS+0;Year=2017;CountyName=upcase(trim(scan(NAME,1,','))||", "||trim(STUSAB));keep CountyFIPS Year NAME STUSAB CountyName;run;
data acs2018;set b.acs20142018;CountyFIPS=FIPS+0;Year=2018;CountyName=upcase(trim(scan(NAME,1,','))||", "||trim(STUSAB));keep CountyFIPS Year NAME STUSAB CountyName;run;
data acs;set acs2015 acs2016 acs2017 acs2018;run;
/* Merging ICE02 and acs */
proc sort data=ICE02;by Year CountyName;run;
proc sort data=acs  ;by Year CountyName;run;
data ICE03;merge acs ICE02;by Year CountyName;run; /*N=12912, 8 variables*/
/* 1579 arrests (0.33% of all 480,987 ICE arrests) were from 28 county-years in US territories.
     98 arrests (0.02% of all 480,987 ICE arrests) were from  4 unknown county-years.
   ***
   proc means data=ICE03 sum;run;
   proc print data=ICE03;where CountyFIPS=.;run;
   ***
   SOLUTION: delete records of these 32 county-years */
data ICE04;set ICE03;
if CountyFIPS^=.;
array change _numeric_;do over change;if change=. then change=0;end;
keep CountyFIPS Year ICEArr ICEArrNC ICEArrYC;
run; /*N=12880, 5 variables*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Creating Keys to Aggregate ICE Data Counties Suppressed and Combined in CAN Data ************************************************************/
/********************************* Creating Keys to Aggregate ICE Data Counties Suppressed and Combined in CAN Data ************************************************************/
/********************************* Creating Keys to Aggregate ICE Data Counties Suppressed and Combined in CAN Data ************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/***/
/* CountyKey -- to aggregate counties in ICE data that are suppressed and combined in CAN data (ie, CountyFIPS=XX999). */
proc summary data=c.cdck01county_census2 nway;class CountyFIPS;var RptT;output out=CountyKey sum=;run;                  /* 6153 county-years --> 639 counties (identified & combined)  */
data CountyKey;set CountyKey;if mod(CountyFIPS,1000)^=999;CountyFlag=1;keep CountyFIPS CountyFlag;run; /* 592 identified counties (47 combinecd counties are deleted) */
proc sort data=CountyKey;by CountyFIPS;run;
/***/
/* CountyYrKey -- to exclude county-years in ICE data that are missing in CAN data. */
data CountyYrKey;set c.cdck01county_census2;CountyYrFlag=1;keep CountyYear CountyYrFlag;run;                            /* 6153 county-years */
proc sort data=CountyYrKey;by CountyYear;run;





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Aggregating ICE Data Counties Suppressed and Combined in CAN Data ***************************************************************************/
/********************************* Aggregating ICE Data Counties Suppressed and Combined in CAN Data ***************************************************************************/
/********************************* Aggregating ICE Data Counties Suppressed and Combined in CAN Data ***************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/* Merging with CountyKey to Identify Counties Suppressed and Combined in CAN Data */
proc sort data=ICE04;by CountyFIPS;run;
data ICE05;merge ICE04 CountyKey;by CountyFIPS;run; /*N=12880, 6 variables*/
data ICE06;set ICE05;
if CountyFlag=1 then CountyYear=CountyFIPS*10000+Year;
if CountyFlag=. then CountyYear=INT(CountyFIPS/1000)*10000000+9990000+Year;
run; /*N=12880, 7 variables*/
/* Aggregating ICE Data Counties Suppressed and Combined in CAN data */
proc summary data=ICE06 nway;class CountyYear;var ICEArr ICEArrNC ICEArrYC;output out=ICE07 sum=;run; /*N=2568, 6 variables*/
/* Merging with CountyYrKey to Exclude County-Years in ICE Data Missing in CAN Data */
proc sort data=ICE07;by CountyYear;run;
data ICE08;merge ICE07 CountyYrKey;by CountyYear;run;
/* proc means data=ICE08 n nmiss sum;run;                      *//* 479310 arrests (100.00%) from 2568 County-Years (100.00%) */
/* proc means data=ICE08 n nmiss sum;where CountyYrFlag=.;run; *//*      2 arrests (<0.001%) from   12 County-Years (  0.47%) */
/* proc means data=ICE08 n nmiss sum;where CountyYrFlag=1;run; *//* 479308 arrests (99.999%) from 2556 County-Years ( 99.53%) */
data ICE09;retain ICE_Flag CountyYear ICEArr ICEArrNC ICEArrYC;set ICE08;if CountyYrFlag=1 & ICEArr^=.;ICE_Flag=1;keep ICE_Flag CountyYear ICEArr ICEArrNC ICEArrYC;run;
/*N=2556, 5 variables*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Merging with Main Data **********************************************************************************************************************/
/********************************* Merging with Main Data **********************************************************************************************************************/
/********************************* Merging with Main Data **********************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
data ICE10;set c.cdck01county_census2;if Year>2014;run; /*N=2556, 886 variables*/
proc sort data=ICE09;by CountyYear;run;/*N=2556,   5 variables*/
proc sort data=ICE10;by CountyYear;run;/*N=2556, 886 variables*/
data ICE11;merge ICE10 ICE09;by CountyYear;
ICEArrR=  ICEArr  /PopT*10000;
ICEArrNCR=ICEArrNC/PopT*10000;
ICEArrYCR=ICEArrYC/PopT*10000;
label
ICEArrR  ="# ICE arrests per 10k persons,County"
ICEArrNCR="# ICE non-community arrests per 10k persons,County"
ICEArrYCR="# ICE community arrests per 10k persons,County"
;run; /*N=2556, 893 variables*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Saving Permanent Data (csv) for Analysis by R ***********************************************************************************************/
/********************************* Saving Permanent Data (csv) for Analysis by R ***********************************************************************************************/
/********************************* Saving Permanent Data (csv) for Analysis by R ***********************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
proc contents data=ICE11 varnum;run;
proc export data=ICE11 outfile="Z:\ICE_CM\ICE.csv" dbms=csv replace;run;




