




/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/* CDCK01 Project - 09/30/2020-09/29/2023 */
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/* This SAS program is to merge the following county-level datasets:
   (a)  CAN report rate -- 01 CAN_Input.sas
   (b)  Census (ACS) data -- 02 Census_Input.sas
   (c)  Birth (CDC) data -- 03 BIRTH_Input.sas
   (d)  Opioid prescription data -- 04 Opioid_Input.sas
   (e1) Urban/Rural Code (NCHS) -- 05 NCHS_RUC_Input.sas
   (e2) Urban/Rural Code (USDA) -- 06 USDA_RUC_Input.sas
   (f)  Spatial (latitude and longitude) data -- 07 Spatial_Input.sas
   (g)  Health indicators (CHR) -- 08 CHR_Input.sas
   (h)  Food insecurity -- 09 Food_Input.sas
   (i)  MIECHV provision -- 10 MHV_Input.sas
   (i)  NHVRC -- 11 NHV_Input.sas

   For the documentation of these datasets, please see the SAS program for the each dataset.

   Limitation: CAN report data are based on fiscal years while other data are based calendar years.

   CAN report data (NCANDS) suppressed County IDs of cases < 1,000 in annual Child Files.
   This suppressed 23143 county-years (FIPS=XXXXX) into 456 combined county-years (FIPS=XX999) from 2009 to 2018.
   Other datasets will be combined the same manner. Then, datasets will be merged.



***************************************************************************************************************
WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING 
WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING 
WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING 
WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING 
WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING 

DO NOT USE 5-YEAR ESTIMATE TEEN BIRTH DATA (i.e., TBTT5r TBTW5r TBTB5r TBTH5r TBTM5r TBTF5r)
While numerators were 5-year sum, denominators were 5-year average for TBTT5r, TBTM5r, TBTF5r, and TBTH5r
For TBTW5r and TBTB5r, numerators were 1-year (for 2016), 2-year (for 2017), and 3-year (for 2018) sum
  while denominators were 5-year average

USE 1-YEAR ESTIMATE BIRTH DATA

WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING 
WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING 
WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING 
WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING 
WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING 
***************************************************************************************************************



/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/* Counties in 50 US States and DC, 2009-2018 */
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/* Hyunil Kim, 02/03/2021 */
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/





ods html newfile=proc path="E:\SASWork\Output";
libname a  "Z:\CDCK01\Data_County\CAN";
libname b  "Z:\CDCK01\Data_County\Census";
libname c  "Z:\CDCK01\Data_County\Birth";
libname d  "Z:\CDCK01\Data_County\Opioid";
libname e1 "Z:\CDCK01\Data_County\NCHS_RUC";
libname e2 "Z:\CDCK01\Data_County\USDA_RUC";
libname f  "Z:\CDCK01\Data_County\Spatial";
libname g  "Z:\CDCK01\Data_County\CHR";
libname h  "Z:\CDCK01\Data_County\Food";
libname i  "Z:\CDCK01\Data_County\MHV";
libname z  "Z:\CDCK01\Data_County";




/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Creating Keys to Combine Other Datasets *****************************************************************************************************/
/********************************* Creating Keys to Combine Other Datasets *****************************************************************************************************/
/********************************* Creating Keys to Combine Other Datasets *****************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/***/
/* CountyKey -- to aggregate counties in other datasets that are suppressed and combined in CAN data (ie, CountyFIPS=XX999). */;
proc summary data=a.CAN nway;class CountyFIPS;var RptT;output out=CountyKey sum=;run;                  /* 6153 county-years --> 639 counties (identified & combined)  */
data CountyKey;set CountyKey;if mod(CountyFIPS,1000)^=999;CountyFlag=1;keep CountyFIPS CountyFlag;run; /* 592 identified counties (47 combinecd counties are deleted) */
proc sort data=CountyKey;by CountyFIPS;run;
/***/
/* CountyYrKey -- to exclude county-years of other datasets that are missing in CAN data. */;
data CountyYrKey;set a.CAN;CountyYrFlag=1;keep CountyYear CountyYrFlag;run;                            
/* 6153 county-years */;
proc sort data=CountyYrKey;by CountyYear;run;




/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* CAN data ************************************************************************************************************************************/
/********************************* CAN data ************************************************************************************************************************************/
/********************************* CAN data ************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/***/;
data CAN;retain StateFIPS CountyFIPS Year StateYear CountyYear CANFlag;set a.CAN(rename=(fyear=Year));CANFlag=1;run; 
/*N=6153, 27 variables*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Census data *********************************************************************************************************************************/
/********************************* Census data *********************************************************************************************************************************/
/********************************* Census data *********************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/***/
/* Importing census data
   Renaming CountyYear
   Renaming CountyFIPS and StateFIPS and converting them into numeric */;
data census1;set b.census(rename=(CntyYear=CountyYear));
/* Renaming CountyFIPS and StateFIPS and converting them into numeric */
CountyFIPS=CntyFIPS+0;StateFIPS=STFIPS+0;
/* Excluding Puerto Rico data */
if StateFIPS^=72;
/* Six counties have a missing Land value in 2009, but a valid Land value in 2010
   proc print data=b.census;var Year CntyFIPS CntyYear Land;where Land=.;run;
   proc print data=b.census;var Year CntyFIPS CntyYear Land;where CntyFIPS in (2105 2195 2198 2230 2275 8014) & Year in (2009 2010);run;
   SOLUTION: replacing missing land values in 2009 with valid land values in 2010 */
if CountyYear=21052009 then Land=7524.9150745100;
if CountyYear=21952009 then Land=3281.9820570597;
if CountyYear=21982009 then Land=3922.8728225768;
if CountyYear=22302009 then Land= 452.3247891496;
if CountyYear=22752009 then Land=2541.4833057142;
if CountyYear=80142009 then Land=  33.0339507365;
/* CountyFIPS=35039 has missing values for many variables in 2018, but valid values for those variables in 2017
   proc print data=b.census;where CountyFIPS=35039 & Year in (2017 2018);run;
   SOLUTION: replacing missing values in 2018 with valid values in 2017 for CountyFIPS=35039 */
FamHHT_Lag  =lag(FamHHT  );if CountyFIPS=35039 & FamHHT  =. then FamHHT  =FamHHT_lag  ;
FamHHW_Lag  =lag(FamHHW  );if CountyFIPS=35039 & FamHHW  =. then FamHHW  =FamHHW_lag  ;
FamHHB_Lag  =lag(FamHHB  );if CountyFIPS=35039 & FamHHB  =. then FamHHB  =FamHHB_lag  ;
FamHHA_Lag  =lag(FamHHA  );if CountyFIPS=35039 & FamHHA  =. then FamHHA  =FamHHA_lag  ;
FamHHN_Lag  =lag(FamHHN  );if CountyFIPS=35039 & FamHHN  =. then FamHHN  =FamHHN_lag  ;
FamHHP_Lag  =lag(FamHHP  );if CountyFIPS=35039 & FamHHP  =. then FamHHP  =FamHHP_lag  ;
FamHHM_Lag  =lag(FamHHM  );if CountyFIPS=35039 & FamHHM  =. then FamHHM  =FamHHM_lag  ;
FamHHH_Lag  =lag(FamHHH  );if CountyFIPS=35039 & FamHHH  =. then FamHHH  =FamHHH_lag  ;
SingleNT_Lag=lag(SingleNT);if CountyFIPS=35039 & SingleNT=. then SingleNT=SingleNT_lag;
SingleNW_Lag=lag(SingleNW);if CountyFIPS=35039 & SingleNW=. then SingleNW=SingleNW_lag;
SingleNB_Lag=lag(SingleNB);if CountyFIPS=35039 & SingleNB=. then SingleNB=SingleNB_lag;
SingleNA_Lag=lag(SingleNA);if CountyFIPS=35039 & SingleNA=. then SingleNA=SingleNA_lag;
SingleNN_Lag=lag(SingleNN);if CountyFIPS=35039 & SingleNN=. then SingleNN=SingleNN_lag;
SingleNP_Lag=lag(SingleNP);if CountyFIPS=35039 & SingleNP=. then SingleNP=SingleNP_lag;
SingleNM_Lag=lag(SingleNM);if CountyFIPS=35039 & SingleNM=. then SingleNM=SingleNM_lag;
SingleNH_Lag=lag(SingleNH);if CountyFIPS=35039 & SingleNH=. then SingleNH=SingleNH_lag;
SingleT_Lag =lag(SingleT );if CountyFIPS=35039 & SingleT =. then SingleT =SingleT_lag ;
SingleW_Lag =lag(SingleW );if CountyFIPS=35039 & SingleW =. then SingleW =SingleW_lag ;
SingleB_Lag =lag(SingleB );if CountyFIPS=35039 & SingleB =. then SingleB =SingleB_lag ;
SingleA_Lag =lag(SingleA );if CountyFIPS=35039 & SingleA =. then SingleA =SingleA_lag ;
SingleN_Lag =lag(SingleN );if CountyFIPS=35039 & SingleN =. then SingleN =SingleN_lag ;
SingleP_Lag =lag(SingleP );if CountyFIPS=35039 & SingleP =. then SingleP =SingleP_lag ;
SingleM_Lag =lag(SingleM );if CountyFIPS=35039 & SingleM =. then SingleM =SingleM_lag ;
SingleH_Lag =lag(SingleH );if CountyFIPS=35039 & SingleH =. then SingleH =SingleH_lag ;
FHeadNT_Lag =lag(FHeadNT );if CountyFIPS=35039 & FHeadNT =. then FHeadNT =FHeadNT_lag ;
FHeadNW_Lag =lag(FHeadNW );if CountyFIPS=35039 & FHeadNW =. then FHeadNW =FHeadNW_lag ;
FHeadNB_Lag =lag(FHeadNB );if CountyFIPS=35039 & FHeadNB =. then FHeadNB =FHeadNB_lag ;
FHeadNA_Lag =lag(FHeadNA );if CountyFIPS=35039 & FHeadNA =. then FHeadNA =FHeadNA_lag ;
FHeadNN_Lag =lag(FHeadNN );if CountyFIPS=35039 & FHeadNN =. then FHeadNN =FHeadNN_lag ;
FHeadNP_Lag =lag(FHeadNP );if CountyFIPS=35039 & FHeadNP =. then FHeadNP =FHeadNP_lag ;
FHeadNM_Lag =lag(FHeadNM );if CountyFIPS=35039 & FHeadNM =. then FHeadNM =FHeadNM_lag ;
FHeadNH_Lag =lag(FHeadNH );if CountyFIPS=35039 & FHeadNH =. then FHeadNH =FHeadNH_lag ;
FHeadT_Lag  =lag(FHeadT  );if CountyFIPS=35039 & FHeadT  =. then FHeadT  =FHeadT_lag  ;
FHeadW_Lag  =lag(FHeadW  );if CountyFIPS=35039 & FHeadW  =. then FHeadW  =FHeadW_lag  ;
FHeadB_Lag  =lag(FHeadB  );if CountyFIPS=35039 & FHeadB  =. then FHeadB  =FHeadB_lag  ;
FHeadA_Lag  =lag(FHeadA  );if CountyFIPS=35039 & FHeadA  =. then FHeadA  =FHeadA_lag  ;
FHeadN_Lag  =lag(FHeadN  );if CountyFIPS=35039 & FHeadN  =. then FHeadN  =FHeadN_lag  ;
FHeadP_Lag  =lag(FHeadP  );if CountyFIPS=35039 & FHeadP  =. then FHeadP  =FHeadP_lag  ;
FHeadM_Lag  =lag(FHeadM  );if CountyFIPS=35039 & FHeadM  =. then FHeadM  =FHeadM_lag  ;
FHeadH_Lag  =lag(FHeadH  );if CountyFIPS=35039 & FHeadH  =. then FHeadH  =FHeadH_lag  ;
LaborT_Lag  =lag(LaborT  );if CountyFIPS=35039 & LaborT  =. then LaborT  =LaborT_lag  ;
LaborW_Lag  =lag(LaborW  );if CountyFIPS=35039 & LaborW  =. then LaborW  =LaborW_lag  ;
LaborB_Lag  =lag(LaborB  );if CountyFIPS=35039 & LaborB  =. then LaborB  =LaborB_lag  ;
LaborA_Lag  =lag(LaborA  );if CountyFIPS=35039 & LaborA  =. then LaborA  =LaborA_lag  ;
LaborN_Lag  =lag(LaborN  );if CountyFIPS=35039 & LaborN  =. then LaborN  =LaborN_lag  ;
LaborP_Lag  =lag(LaborP  );if CountyFIPS=35039 & LaborP  =. then LaborP  =LaborP_lag  ;
LaborM_Lag  =lag(LaborM  );if CountyFIPS=35039 & LaborM  =. then LaborM  =LaborM_lag  ;
LaborH_Lag  =lag(LaborH  );if CountyFIPS=35039 & LaborH  =. then LaborH  =LaborH_lag  ;
UnempNT_Lag =lag(UnempNT );if CountyFIPS=35039 & UnempNT =. then UnempNT =UnempNT_lag ;
UnempNW_Lag =lag(UnempNW );if CountyFIPS=35039 & UnempNW =. then UnempNW =UnempNW_lag ;
UnempNB_Lag =lag(UnempNB );if CountyFIPS=35039 & UnempNB =. then UnempNB =UnempNB_lag ;
UnempNA_Lag =lag(UnempNA );if CountyFIPS=35039 & UnempNA =. then UnempNA =UnempNA_lag ;
UnempNN_Lag =lag(UnempNN );if CountyFIPS=35039 & UnempNN =. then UnempNN =UnempNN_lag ;
UnempNP_Lag =lag(UnempNP );if CountyFIPS=35039 & UnempNP =. then UnempNP =UnempNP_lag ;
UnempNM_Lag =lag(UnempNM );if CountyFIPS=35039 & UnempNM =. then UnempNM =UnempNM_lag ;
UnempNH_Lag =lag(UnempNH );if CountyFIPS=35039 & UnempNH =. then UnempNH =UnempNH_lag ;
UnempT_Lag  =lag(UnempT  );if CountyFIPS=35039 & UnempT  =. then UnempT  =UnempT_lag  ;
UnempW_Lag  =lag(UnempW  );if CountyFIPS=35039 & UnempW  =. then UnempW  =UnempW_lag  ;
UnempB_Lag  =lag(UnempB  );if CountyFIPS=35039 & UnempB  =. then UnempB  =UnempB_lag  ;
UnempA_Lag  =lag(UnempA  );if CountyFIPS=35039 & UnempA  =. then UnempA  =UnempA_lag  ;
UnempN_Lag  =lag(UnempN  );if CountyFIPS=35039 & UnempN  =. then UnempN  =UnempN_lag  ;
UnempP_Lag  =lag(UnempP  );if CountyFIPS=35039 & UnempP  =. then UnempP  =UnempP_lag  ;
UnempM_Lag  =lag(UnempM  );if CountyFIPS=35039 & UnempM  =. then UnempM  =UnempM_lag  ;
UnempH_Lag  =lag(UnempH  );if CountyFIPS=35039 & UnempH  =. then UnempH  =UnempH_lag  ;
PovPT_Lag   =lag(PovPT   );if CountyFIPS=35039 & PovPT   =. then PovPT   =PovPT_lag   ;
PovPW_Lag   =lag(PovPW   );if CountyFIPS=35039 & PovPW   =. then PovPW   =PovPW_lag   ;
PovPB_Lag   =lag(PovPB   );if CountyFIPS=35039 & PovPB   =. then PovPB   =PovPB_lag   ;
PovPA_Lag   =lag(PovPA   );if CountyFIPS=35039 & PovPA   =. then PovPA   =PovPA_lag   ;
PovPN_Lag   =lag(PovPN   );if CountyFIPS=35039 & PovPN   =. then PovPN   =PovPN_lag   ;
PovPP_Lag   =lag(PovPP   );if CountyFIPS=35039 & PovPP   =. then PovPP   =PovPP_lag   ;
PovPM_Lag   =lag(PovPM   );if CountyFIPS=35039 & PovPM   =. then PovPM   =PovPM_lag   ;
PovPH_Lag   =lag(PovPH   );if CountyFIPS=35039 & PovPH   =. then PovPH   =PovPH_lag   ;
PovNT_Lag   =lag(PovNT   );if CountyFIPS=35039 & PovNT   =. then PovNT   =PovNT_lag   ;
PovNW_Lag   =lag(PovNW   );if CountyFIPS=35039 & PovNW   =. then PovNW   =PovNW_lag   ;
PovNB_Lag   =lag(PovNB   );if CountyFIPS=35039 & PovNB   =. then PovNB   =PovNB_lag   ;
PovNA_Lag   =lag(PovNA   );if CountyFIPS=35039 & PovNA   =. then PovNA   =PovNA_lag   ;
PovNN_Lag   =lag(PovNN   );if CountyFIPS=35039 & PovNN   =. then PovNN   =PovNN_lag   ;
PovNP_Lag   =lag(PovNP   );if CountyFIPS=35039 & PovNP   =. then PovNP   =PovNP_lag   ;
PovNM_Lag   =lag(PovNM   );if CountyFIPS=35039 & PovNM   =. then PovNM   =PovNM_lag   ;
PovNH_Lag   =lag(PovNH   );if CountyFIPS=35039 & PovNH   =. then PovNH   =PovNH_lag   ;
PovT_Lag    =lag(PovT    );if CountyFIPS=35039 & PovT    =. then PovT    =PovT_lag    ;
PovW_Lag    =lag(PovW    );if CountyFIPS=35039 & PovW    =. then PovW    =PovW_lag    ;
PovB_Lag    =lag(PovB    );if CountyFIPS=35039 & PovB    =. then PovB    =PovB_lag    ;
PovA_Lag    =lag(PovA    );if CountyFIPS=35039 & PovA    =. then PovA    =PovA_lag    ;
PovN_Lag    =lag(PovN    );if CountyFIPS=35039 & PovN    =. then PovN    =PovN_lag    ;
PovP_Lag    =lag(PovP    );if CountyFIPS=35039 & PovP    =. then PovP    =PovP_lag    ;
PovM_Lag    =lag(PovM    );if CountyFIPS=35039 & PovM    =. then PovM    =PovM_lag    ;
PovH_Lag    =lag(PovH    );if CountyFIPS=35039 & PovH    =. then PovH    =PovH_lag    ;
CPovPT_Lag  =lag(CPovPT  );if CountyFIPS=35039 & CPovPT  =. then CPovPT  =CPovPT_lag  ;
CPovNT_Lag  =lag(CPovNT  );if CountyFIPS=35039 & CPovNT  =. then CPovNT  =CPovNT_lag  ;
CPovPW_Lag  =lag(CPovPW  );if CountyFIPS=35039 & CPovPW  =. then CPovPW  =CPovPW_lag  ;
CPovPB_Lag  =lag(CPovPB  );if CountyFIPS=35039 & CPovPB  =. then CPovPB  =CPovPB_lag  ;
CPovPA_Lag  =lag(CPovPA  );if CountyFIPS=35039 & CPovPA  =. then CPovPA  =CPovPA_lag  ;
CPovPN_Lag  =lag(CPovPN  );if CountyFIPS=35039 & CPovPN  =. then CPovPN  =CPovPN_lag  ;
CPovPP_Lag  =lag(CPovPP  );if CountyFIPS=35039 & CPovPP  =. then CPovPP  =CPovPP_lag  ;
CPovPM_Lag  =lag(CPovPM  );if CountyFIPS=35039 & CPovPM  =. then CPovPM  =CPovPM_lag  ;
CPovPH_Lag  =lag(CPovPH  );if CountyFIPS=35039 & CPovPH  =. then CPovPH  =CPovPH_lag  ;
CPovNW_Lag  =lag(CPovNW  );if CountyFIPS=35039 & CPovNW  =. then CPovNW  =CPovNW_lag  ;
CPovNB_Lag  =lag(CPovNB  );if CountyFIPS=35039 & CPovNB  =. then CPovNB  =CPovNB_lag  ;
CPovNA_Lag  =lag(CPovNA  );if CountyFIPS=35039 & CPovNA  =. then CPovNA  =CPovNA_lag  ;
CPovNN_Lag  =lag(CPovNN  );if CountyFIPS=35039 & CPovNN  =. then CPovNN  =CPovNN_lag  ;
CPovNP_Lag  =lag(CPovNP  );if CountyFIPS=35039 & CPovNP  =. then CPovNP  =CPovNP_lag  ;
CPovNM_Lag  =lag(CPovNM  );if CountyFIPS=35039 & CPovNM  =. then CPovNM  =CPovNM_lag  ;
CPovNH_Lag  =lag(CPovNH  );if CountyFIPS=35039 & CPovNH  =. then CPovNH  =CPovNH_lag  ;
CPovT_Lag   =lag(CPovT   );if CountyFIPS=35039 & CPovT   =. then CPovT   =CPovT_lag   ;
CPovW_Lag   =lag(CPovW   );if CountyFIPS=35039 & CPovW   =. then CPovW   =CPovW_lag   ;
CPovB_Lag   =lag(CPovB   );if CountyFIPS=35039 & CPovB   =. then CPovB   =CPovB_lag   ;
CPovA_Lag   =lag(CPovA   );if CountyFIPS=35039 & CPovA   =. then CPovA   =CPovA_lag   ;
CPovN_Lag   =lag(CPovN   );if CountyFIPS=35039 & CPovN   =. then CPovN   =CPovN_lag   ;
CPovP_Lag   =lag(CPovP   );if CountyFIPS=35039 & CPovP   =. then CPovP   =CPovP_lag   ;
CPovM_Lag   =lag(CPovM   );if CountyFIPS=35039 & CPovM   =. then CPovM   =CPovM_lag   ;
CPovH_Lag   =lag(CPovH   );if CountyFIPS=35039 & CPovH   =. then CPovH   =CPovH_lag   ;
P00PT_Lag   =lag(P00PT   );if CountyFIPS=35039 & P00PT   =. then P00PT   =P00PT_lag   ;
P50NT_Lag   =lag(P50NT   );if CountyFIPS=35039 & P50NT   =. then P50NT   =P50NT_lag   ;
P150NT_Lag  =lag(P150NT  );if CountyFIPS=35039 & P150NT  =. then P150NT  =P150NT_lag  ;
Pov50T_Lag  =lag(Pov50T  );if CountyFIPS=35039 & Pov50T  =. then Pov50T  =Pov50T_lag  ;
Pov150T_Lag =lag(Pov150T );if CountyFIPS=35039 & Pov150T =. then Pov150T =Pov150T_lag ;
CPovP1_Lag  =lag(CPovP1  );if CountyFIPS=35039 & CPovP1  =. then CPovP1  =CPovP1_lag  ;
CPovP2_Lag  =lag(CPovP2  );if CountyFIPS=35039 & CPovP2  =. then CPovP2  =CPovP2_lag  ;
CPovP3_Lag  =lag(CPovP3  );if CountyFIPS=35039 & CPovP3  =. then CPovP3  =CPovP3_lag  ;
CPovN1_Lag  =lag(CPovN1  );if CountyFIPS=35039 & CPovN1  =. then CPovN1  =CPovN1_lag  ;
CPovN2_Lag  =lag(CPovN2  );if CountyFIPS=35039 & CPovN2  =. then CPovN2  =CPovN2_lag  ;
CPovN3_Lag  =lag(CPovN3  );if CountyFIPS=35039 & CPovN3  =. then CPovN3  =CPovN3_lag  ;
CPov1_Lag   =lag(CPov1   );if CountyFIPS=35039 & CPov1   =. then CPov1   =CPov1_lag   ;
CPov2_Lag   =lag(CPov2   );if CountyFIPS=35039 & CPov2   =. then CPov2   =CPov2_lag   ;
CPov3_Lag   =lag(CPov3   );if CountyFIPS=35039 & CPov3   =. then CPov3   =CPov3_lag   ;
CP00PT_Lag  =lag(CP00PT  );if CountyFIPS=35039 & CP00PT  =. then CP00PT  =CP00PT_lag  ;
CP50NT_Lag  =lag(CP50NT  );if CountyFIPS=35039 & CP50NT  =. then CP50NT  =CP50NT_lag  ;
CP100NT_Lag =lag(CP100NT );if CountyFIPS=35039 & CP100NT =. then CP100NT =CP100NT_lag ;
CP125NT_Lag =lag(CP125NT );if CountyFIPS=35039 & CP125NT =. then CP125NT =CP125NT_lag ;
CP150NT_Lag =lag(CP150NT );if CountyFIPS=35039 & CP150NT =. then CP150NT =CP150NT_lag ;
CP175NT_Lag =lag(CP175NT );if CountyFIPS=35039 & CP175NT =. then CP175NT =CP175NT_lag ;
CP185NT_Lag =lag(CP185NT );if CountyFIPS=35039 & CP185NT =. then CP185NT =CP185NT_lag ;
CP200NT_Lag =lag(CP200NT );if CountyFIPS=35039 & CP200NT =. then CP200NT =CP200NT_lag ;
CPov50T_Lag =lag(CPov50T );if CountyFIPS=35039 & CPov50T =. then CPov50T =CPov50T_lag ;
CPov100T_Lag=lag(CPov100T);if CountyFIPS=35039 & CPov100T=. then CPov100T=CPov100T_lag;
CPov125T_Lag=lag(CPov125T);if CountyFIPS=35039 & CPov125T=. then CPov125T=CPov125T_lag;
CPov150T_Lag=lag(CPov150T);if CountyFIPS=35039 & CPov150T=. then CPov150T=CPov150T_lag;
CPov175T_Lag=lag(CPov175T);if CountyFIPS=35039 & CPov175T=. then CPov175T=CPov175T_lag;
CPov185T_Lag=lag(CPov185T);if CountyFIPS=35039 & CPov185T=. then CPov185T=CPov185T_lag;
CPov200T_Lag=lag(CPov200T);if CountyFIPS=35039 & CPov200T=. then CPov200T=CPov200T_lag;
CP00P1_Lag  =lag(CP00P1  );if CountyFIPS=35039 & CP00P1  =. then CP00P1  =CP00P1_lag  ;
CP00P2_Lag  =lag(CP00P2  );if CountyFIPS=35039 & CP00P2  =. then CP00P2  =CP00P2_lag  ;
CP00P3_Lag  =lag(CP00P3  );if CountyFIPS=35039 & CP00P3  =. then CP00P3  =CP00P3_lag  ;
CP50N1_Lag  =lag(CP50N1  );if CountyFIPS=35039 & CP50N1  =. then CP50N1  =CP50N1_lag  ;
CP50N2_Lag  =lag(CP50N2  );if CountyFIPS=35039 & CP50N2  =. then CP50N2  =CP50N2_lag  ;
CP50N3_Lag  =lag(CP50N3  );if CountyFIPS=35039 & CP50N3  =. then CP50N3  =CP50N3_lag  ;
CP100N1_Lag =lag(CP100N1 );if CountyFIPS=35039 & CP100N1 =. then CP100N1 =CP100N1_lag ;
CP100N2_Lag =lag(CP100N2 );if CountyFIPS=35039 & CP100N2 =. then CP100N2 =CP100N2_lag ;
CP100N3_Lag =lag(CP100N3 );if CountyFIPS=35039 & CP100N3 =. then CP100N3 =CP100N3_lag ;
CP125N1_Lag =lag(CP125N1 );if CountyFIPS=35039 & CP125N1 =. then CP125N1 =CP125N1_lag ;
CP125N2_Lag =lag(CP125N2 );if CountyFIPS=35039 & CP125N2 =. then CP125N2 =CP125N2_lag ;
CP125N3_Lag =lag(CP125N3 );if CountyFIPS=35039 & CP125N3 =. then CP125N3 =CP125N3_lag ;
CP150N1_Lag =lag(CP150N1 );if CountyFIPS=35039 & CP150N1 =. then CP150N1 =CP150N1_lag ;
CP150N2_Lag =lag(CP150N2 );if CountyFIPS=35039 & CP150N2 =. then CP150N2 =CP150N2_lag ;
CP150N3_Lag =lag(CP150N3 );if CountyFIPS=35039 & CP150N3 =. then CP150N3 =CP150N3_lag ;
CP175N1_Lag =lag(CP175N1 );if CountyFIPS=35039 & CP175N1 =. then CP175N1 =CP175N1_lag ;
CP175N2_Lag =lag(CP175N2 );if CountyFIPS=35039 & CP175N2 =. then CP175N2 =CP175N2_lag ;
CP175N3_Lag =lag(CP175N3 );if CountyFIPS=35039 & CP175N3 =. then CP175N3 =CP175N3_lag ;
CP185N1_Lag =lag(CP185N1 );if CountyFIPS=35039 & CP185N1 =. then CP185N1 =CP185N1_lag ;
CP185N2_Lag =lag(CP185N2 );if CountyFIPS=35039 & CP185N2 =. then CP185N2 =CP185N2_lag ;
CP185N3_Lag =lag(CP185N3 );if CountyFIPS=35039 & CP185N3 =. then CP185N3 =CP185N3_lag ;
CP200N1_Lag =lag(CP200N1 );if CountyFIPS=35039 & CP200N1 =. then CP200N1 =CP200N1_lag ;
CP200N2_Lag =lag(CP200N2 );if CountyFIPS=35039 & CP200N2 =. then CP200N2 =CP200N2_lag ;
CP200N3_Lag =lag(CP200N3 );if CountyFIPS=35039 & CP200N3 =. then CP200N3 =CP200N3_lag ;
CPov501_Lag =lag(CPov501 );if CountyFIPS=35039 & CPov501 =. then CPov501 =CPov501_lag ;
CPov502_Lag =lag(CPov502 );if CountyFIPS=35039 & CPov502 =. then CPov502 =CPov502_lag ;
CPov503_Lag =lag(CPov503 );if CountyFIPS=35039 & CPov503 =. then CPov503 =CPov503_lag ;
CPov1001_Lag=lag(CPov1001);if CountyFIPS=35039 & CPov1001=. then CPov1001=CPov1001_lag;
CPov1002_Lag=lag(CPov1002);if CountyFIPS=35039 & CPov1002=. then CPov1002=CPov1002_lag;
CPov1003_Lag=lag(CPov1003);if CountyFIPS=35039 & CPov1003=. then CPov1003=CPov1003_lag;
CPov1251_Lag=lag(CPov1251);if CountyFIPS=35039 & CPov1251=. then CPov1251=CPov1251_lag;
CPov1252_Lag=lag(CPov1252);if CountyFIPS=35039 & CPov1252=. then CPov1252=CPov1252_lag;
CPov1253_Lag=lag(CPov1253);if CountyFIPS=35039 & CPov1253=. then CPov1253=CPov1253_lag;
CPov1501_Lag=lag(CPov1501);if CountyFIPS=35039 & CPov1501=. then CPov1501=CPov1501_lag;
CPov1502_Lag=lag(CPov1502);if CountyFIPS=35039 & CPov1502=. then CPov1502=CPov1502_lag;
CPov1503_Lag=lag(CPov1503);if CountyFIPS=35039 & CPov1503=. then CPov1503=CPov1503_lag;
CPov1751_Lag=lag(CPov1751);if CountyFIPS=35039 & CPov1751=. then CPov1751=CPov1751_lag;
CPov1752_Lag=lag(CPov1752);if CountyFIPS=35039 & CPov1752=. then CPov1752=CPov1752_lag;
CPov1753_Lag=lag(CPov1753);if CountyFIPS=35039 & CPov1753=. then CPov1753=CPov1753_lag;
CPov1851_Lag=lag(CPov1851);if CountyFIPS=35039 & CPov1851=. then CPov1851=CPov1851_lag;
CPov1852_Lag=lag(CPov1852);if CountyFIPS=35039 & CPov1852=. then CPov1852=CPov1852_lag;
CPov1853_Lag=lag(CPov1853);if CountyFIPS=35039 & CPov1853=. then CPov1853=CPov1853_lag;
CPov2001_Lag=lag(CPov2001);if CountyFIPS=35039 & CPov2001=. then CPov2001=CPov2001_lag;
CPov2002_Lag=lag(CPov2002);if CountyFIPS=35039 & CPov2002=. then CPov2002=CPov2002_lag;
CPov2003_Lag=lag(CPov2003);if CountyFIPS=35039 & CPov2003=. then CPov2003=CPov2003_lag;
RPovPT_Lag  =lag(RPovPT  );if CountyFIPS=35039 & RPovPT  =. then RPovPT  =RPovPT_lag  ;
RPovPW_Lag  =lag(RPovPW  );if CountyFIPS=35039 & RPovPW  =. then RPovPW  =RPovPW_lag  ;
RPovPB_Lag  =lag(RPovPB  );if CountyFIPS=35039 & RPovPB  =. then RPovPB  =RPovPB_lag  ;
RPovPA_Lag  =lag(RPovPA  );if CountyFIPS=35039 & RPovPA  =. then RPovPA  =RPovPA_lag  ;
RPovPN_Lag  =lag(RPovPN  );if CountyFIPS=35039 & RPovPN  =. then RPovPN  =RPovPN_lag  ;
RPovPP_Lag  =lag(RPovPP  );if CountyFIPS=35039 & RPovPP  =. then RPovPP  =RPovPP_lag  ;
RPovPM_Lag  =lag(RPovPM  );if CountyFIPS=35039 & RPovPM  =. then RPovPM  =RPovPM_lag  ;
RPovPH_Lag  =lag(RPovPH  );if CountyFIPS=35039 & RPovPH  =. then RPovPH  =RPovPH_lag  ;
RPovNT_Lag  =lag(RPovNT  );if CountyFIPS=35039 & RPovNT  =. then RPovNT  =RPovNT_lag  ;
RPovNW_Lag  =lag(RPovNW  );if CountyFIPS=35039 & RPovNW  =. then RPovNW  =RPovNW_lag  ;
RPovNB_Lag  =lag(RPovNB  );if CountyFIPS=35039 & RPovNB  =. then RPovNB  =RPovNB_lag  ;
RPovNA_Lag  =lag(RPovNA  );if CountyFIPS=35039 & RPovNA  =. then RPovNA  =RPovNA_lag  ;
RPovNN_Lag  =lag(RPovNN  );if CountyFIPS=35039 & RPovNN  =. then RPovNN  =RPovNN_lag  ;
RPovNP_Lag  =lag(RPovNP  );if CountyFIPS=35039 & RPovNP  =. then RPovNP  =RPovNP_lag  ;
RPovNM_Lag  =lag(RPovNM  );if CountyFIPS=35039 & RPovNM  =. then RPovNM  =RPovNM_lag  ;
RPovNH_Lag  =lag(RPovNH  );if CountyFIPS=35039 & RPovNH  =. then RPovNH  =RPovNH_lag  ;
RPovT_Lag   =lag(RPovT   );if CountyFIPS=35039 & RPovT   =. then RPovT   =RPovT_lag   ;
RPovW_Lag   =lag(RPovW   );if CountyFIPS=35039 & RPovW   =. then RPovW   =RPovW_lag   ;
RPovB_Lag   =lag(RPovB   );if CountyFIPS=35039 & RPovB   =. then RPovB   =RPovB_lag   ;
RPovA_Lag   =lag(RPovA   );if CountyFIPS=35039 & RPovA   =. then RPovA   =RPovA_lag   ;
RPovN_Lag   =lag(RPovN   );if CountyFIPS=35039 & RPovN   =. then RPovN   =RPovN_lag   ;
RPovP_Lag   =lag(RPovP   );if CountyFIPS=35039 & RPovP   =. then RPovP   =RPovP_lag   ;
RPovM_Lag   =lag(RPovM   );if CountyFIPS=35039 & RPovM   =. then RPovM   =RPovM_lag   ;
RPovH_Lag   =lag(RPovH   );if CountyFIPS=35039 & RPovH   =. then RPovH   =RPovH_lag   ;
PubAsPT_Lag =lag(PubAsPT );if CountyFIPS=35039 & PubAsPT =. then PubAsPT =PubAsPT_lag ;
PubAsNT_Lag =lag(PubAsNT );if CountyFIPS=35039 & PubAsNT =. then PubAsNT =PubAsNT_lag ;
PubAsT_Lag  =lag(PubAsT  );if CountyFIPS=35039 & PubAsT  =. then PubAsT  =PubAsT_lag  ;
WelfarPT_Lag=lag(WelfarPT);if CountyFIPS=35039 & WelfarPT=. then WelfarPT=WelfarPT_lag;
WelfarNT_Lag=lag(WelfarNT);if CountyFIPS=35039 & WelfarNT=. then WelfarNT=WelfarNT_lag;
WelfarT_Lag =lag(WelfarT );if CountyFIPS=35039 & WelfarT =. then WelfarT =WelfarT_lag ;
IncomeT_Lag =lag(IncomeT );if CountyFIPS=35039 & IncomeT =. then IncomeT =IncomeT_lag ;
IncomeW_Lag =lag(IncomeW );if CountyFIPS=35039 & IncomeW =. then IncomeW =IncomeW_lag ;
IncomeB_Lag =lag(IncomeB );if CountyFIPS=35039 & IncomeB =. then IncomeB =IncomeB_lag ;
IncomeA_Lag =lag(IncomeA );if CountyFIPS=35039 & IncomeA =. then IncomeA =IncomeA_lag ;
IncomeN_Lag =lag(IncomeN );if CountyFIPS=35039 & IncomeN =. then IncomeN =IncomeN_lag ;
IncomeP_Lag =lag(IncomeP );if CountyFIPS=35039 & IncomeP =. then IncomeP =IncomeP_lag ;
IncomeM_Lag =lag(IncomeM );if CountyFIPS=35039 & IncomeM =. then IncomeM =IncomeM_lag ;
IncomeH_Lag =lag(IncomeH );if CountyFIPS=35039 & IncomeH =. then IncomeH =IncomeH_lag ;
GiniT_Lag   =lag(GiniT   );if CountyFIPS=35039 & GiniT   =. then GiniT   =GiniT_lag   ;
OCostPT_Lag =lag(OCostPT );if CountyFIPS=35039 & OCostPT =. then OCostPT =OCostPT_lag ;
OCostMPT_Lag=lag(OCostMPT);if CountyFIPS=35039 & OCostMPT=. then OCostMPT=OCostMPT_lag;
OCostNPT_Lag=lag(OCostNPT);if CountyFIPS=35039 & OCostNPT=. then OCostNPT=OCostNPT_lag;
MRentPT_Lag =lag(MRentPT );if CountyFIPS=35039 & MRentPT =. then MRentPT =MRentPT_lag ;
MovePT_Lag  =lag(MovePT  );if CountyFIPS=35039 & MovePT  =. then MovePT  =MovePT_lag  ;
MovePW_Lag  =lag(MovePW  );if CountyFIPS=35039 & MovePW  =. then MovePW  =MovePW_lag  ;
MovePB_Lag  =lag(MovePB  );if CountyFIPS=35039 & MovePB  =. then MovePB  =MovePB_lag  ;
MovePA_Lag  =lag(MovePA  );if CountyFIPS=35039 & MovePA  =. then MovePA  =MovePA_lag  ;
MovePN_Lag  =lag(MovePN  );if CountyFIPS=35039 & MovePN  =. then MovePN  =MovePN_lag  ;
MovePP_Lag  =lag(MovePP  );if CountyFIPS=35039 & MovePP  =. then MovePP  =MovePP_lag  ;
MovePM_Lag  =lag(MovePM  );if CountyFIPS=35039 & MovePM  =. then MovePM  =MovePM_lag  ;
MovePH_Lag  =lag(MovePH  );if CountyFIPS=35039 & MovePH  =. then MovePH  =MovePH_lag  ;
MoveNT_Lag  =lag(MoveNT  );if CountyFIPS=35039 & MoveNT  =. then MoveNT  =MoveNT_lag  ;
MoveNW_Lag  =lag(MoveNW  );if CountyFIPS=35039 & MoveNW  =. then MoveNW  =MoveNW_lag  ;
MoveNB_Lag  =lag(MoveNB  );if CountyFIPS=35039 & MoveNB  =. then MoveNB  =MoveNB_lag  ;
MoveNA_Lag  =lag(MoveNA  );if CountyFIPS=35039 & MoveNA  =. then MoveNA  =MoveNA_lag  ;
MoveNN_Lag  =lag(MoveNN  );if CountyFIPS=35039 & MoveNN  =. then MoveNN  =MoveNN_lag  ;
MoveNP_Lag  =lag(MoveNP  );if CountyFIPS=35039 & MoveNP  =. then MoveNP  =MoveNP_lag  ;
MoveNM_Lag  =lag(MoveNM  );if CountyFIPS=35039 & MoveNM  =. then MoveNM  =MoveNM_lag  ;
MoveNH_Lag  =lag(MoveNH  );if CountyFIPS=35039 & MoveNH  =. then MoveNH  =MoveNH_lag  ;
MoveT_Lag   =lag(MoveT   );if CountyFIPS=35039 & MoveT   =. then MoveT   =MoveT_lag   ;
MoveW_Lag   =lag(MoveW   );if CountyFIPS=35039 & MoveW   =. then MoveW   =MoveW_lag   ;
MoveB_Lag   =lag(MoveB   );if CountyFIPS=35039 & MoveB   =. then MoveB   =MoveB_lag   ;
MoveA_Lag   =lag(MoveA   );if CountyFIPS=35039 & MoveA   =. then MoveA   =MoveA_lag   ;
MoveN_Lag   =lag(MoveN   );if CountyFIPS=35039 & MoveN   =. then MoveN   =MoveN_lag   ;
MoveP_Lag   =lag(MoveP   );if CountyFIPS=35039 & MoveP   =. then MoveP   =MoveP_lag   ;
MoveM_Lag   =lag(MoveM   );if CountyFIPS=35039 & MoveM   =. then MoveM   =MoveM_lag   ;
MoveH_Lag   =lag(MoveH   );if CountyFIPS=35039 & MoveH   =. then MoveH   =MoveH_lag   ;
drop CntyFIPS STFIPS FamHHT_Lag FamHHW_Lag FamHHB_Lag FamHHA_Lag FamHHN_Lag FamHHP_Lag FamHHM_Lag FamHHH_Lag SingleNT_Lag SingleNW_Lag SingleNB_Lag SingleNA_Lag SingleNN_Lag
SingleNP_Lag SingleNM_Lag SingleNH_Lag SingleT_Lag SingleW_Lag SingleB_Lag SingleA_Lag SingleN_Lag SingleP_Lag SingleM_Lag SingleH_Lag FHeadNT_Lag FHeadNW_Lag FHeadNB_Lag
FHeadNA_Lag FHeadNN_Lag FHeadNP_Lag FHeadNM_Lag FHeadNH_Lag FHeadT_Lag FHeadW_Lag FHeadB_Lag FHeadA_Lag FHeadN_Lag FHeadP_Lag FHeadM_Lag FHeadH_Lag LaborT_Lag LaborW_Lag
LaborB_Lag LaborA_Lag LaborN_Lag LaborP_Lag LaborM_Lag LaborH_Lag UnempNT_Lag UnempNW_Lag UnempNB_Lag UnempNA_Lag UnempNN_Lag UnempNP_Lag UnempNM_Lag UnempNH_Lag UnempT_Lag
UnempW_Lag UnempB_Lag UnempA_Lag UnempN_Lag UnempP_Lag UnempM_Lag UnempH_Lag PovPT_Lag PovPW_Lag PovPB_Lag PovPA_Lag PovPN_Lag PovPP_Lag PovPM_Lag PovPH_Lag PovNT_Lag PovNW_Lag
PovNB_Lag PovNA_Lag PovNN_Lag PovNP_Lag PovNM_Lag PovNH_Lag PovT_Lag PovW_Lag PovB_Lag PovA_Lag PovN_Lag PovP_Lag PovM_Lag PovH_Lag CPovPT_Lag CPovNT_Lag CPovPW_Lag CPovPB_Lag
CPovPA_Lag CPovPN_Lag CPovPP_Lag CPovPM_Lag CPovPH_Lag CPovNW_Lag CPovNB_Lag CPovNA_Lag CPovNN_Lag CPovNP_Lag CPovNM_Lag CPovNH_Lag CPovT_Lag CPovW_Lag CPovB_Lag CPovA_Lag
CPovN_Lag CPovP_Lag CPovM_Lag CPovH_Lag P00PT_Lag P50NT_Lag P150NT_Lag Pov50T_Lag Pov150T_Lag CPovP1_Lag CPovP2_Lag CPovP3_Lag CPovN1_Lag CPovN2_Lag CPovN3_Lag CPov1_Lag
CPov2_Lag CPov3_Lag CP00PT_Lag CP50NT_Lag CP100NT_Lag CP125NT_Lag CP150NT_Lag CP175NT_Lag CP185NT_Lag CP200NT_Lag CPov50T_Lag CPov100T_Lag CPov125T_Lag CPov150T_Lag CPov175T_Lag
CPov185T_Lag CPov200T_Lag CP00P1_Lag CP00P2_Lag CP00P3_Lag CP50N1_Lag CP50N2_Lag CP50N3_Lag CP100N1_Lag CP100N2_Lag CP100N3_Lag CP125N1_Lag CP125N2_Lag CP125N3_Lag CP150N1_Lag
CP150N2_Lag CP150N3_Lag CP175N1_Lag CP175N2_Lag CP175N3_Lag CP185N1_Lag CP185N2_Lag CP185N3_Lag CP200N1_Lag CP200N2_Lag CP200N3_Lag CPov501_Lag CPov502_Lag CPov503_Lag
CPov1001_Lag CPov1002_Lag CPov1003_Lag CPov1251_Lag CPov1252_Lag CPov1253_Lag CPov1501_Lag CPov1502_Lag CPov1503_Lag CPov1751_Lag CPov1752_Lag CPov1753_Lag CPov1851_Lag
CPov1852_Lag CPov1853_Lag CPov2001_Lag CPov2002_Lag CPov2003_Lag RPovPT_Lag RPovPW_Lag RPovPB_Lag RPovPA_Lag RPovPN_Lag RPovPP_Lag RPovPM_Lag RPovPH_Lag RPovNT_Lag RPovNW_Lag
RPovNB_Lag RPovNA_Lag RPovNN_Lag RPovNP_Lag RPovNM_Lag RPovNH_Lag RPovT_Lag RPovW_Lag RPovB_Lag RPovA_Lag RPovN_Lag RPovP_Lag RPovM_Lag RPovH_Lag PubAsPT_Lag PubAsNT_Lag
PubAsT_Lag WelfarPT_Lag WelfarNT_Lag WelfarT_Lag IncomeT_Lag IncomeW_Lag IncomeB_Lag IncomeA_Lag IncomeN_Lag IncomeP_Lag IncomeM_Lag IncomeH_Lag GiniT_Lag OCostPT_Lag
OCostMPT_Lag OCostNPT_Lag MRentPT_Lag MovePT_Lag MovePW_Lag MovePB_Lag MovePA_Lag MovePN_Lag MovePP_Lag MovePM_Lag MovePH_Lag MoveNT_Lag MoveNW_Lag MoveNB_Lag MoveNA_Lag
MoveNN_Lag MoveNP_Lag MoveNM_Lag MoveNH_Lag MoveT_Lag MoveW_Lag MoveB_Lag MoveA_Lag MoveN_Lag MoveP_Lag MoveM_Lag MoveH_Lag;
run;
/*N=31425; 733 variables*/
/***/
/* Merging with CountyKey to aggregate Census data counties that are suppressed in CAN data */;
proc sort data=census1;by CountyFIPS;run;
/***/
/* Merging census data & CountyKey */;
data census2;merge census1 CountyKey;by CountyFIPS;
/* Replacing CountyFIPS (CCC) in CountyYear (SSCCCYYYY) with 999 to combine census data (i.e., to aggregate counties suppressed in CAN data) */
if CountyFlag=. then CountyYear=StateFIPS*10000000+9990000+Year;
/* Some Census variables are missing in some counties.
   Among these counties, for Census data counties identified in CAN data, these variables are missing.
   For Census data counties suppressed in CAN data,
   if the populations of these counties consist of over 20% of the entire population in a combined county, the variable is missing.
   --e.g., if IncomeTd/RPovPT < 0.8 (i.e., coverage < 80%), then IncomeT would be missing */
IncomeTd =RPovPT       ;if IncomeT =. then IncomeTd =0;if IncomeT =. then IncomeT =0;
IncomeWd =RPovPW       ;if IncomeW =. then IncomeWd =0;if IncomeW =. then IncomeW =0;
IncomeBd =RPovPB       ;if IncomeB =. then IncomeBd =0;if IncomeB =. then IncomeB =0;
IncomeAd =RPovPA       ;if IncomeA =. then IncomeAd =0;if IncomeA =. then IncomeA =0;
IncomeNd =RPovPN       ;if IncomeN =. then IncomeNd =0;if IncomeN =. then IncomeN =0;
IncomePd =RPovPP       ;if IncomeP =. then IncomePd =0;if IncomeP =. then IncomeP =0;
IncomeMd =RPovPM       ;if IncomeM =. then IncomeMd =0;if IncomeM =. then IncomeM =0;
IncomeHd =RPovPH       ;if IncomeH =. then IncomeHd =0;if IncomeH =. then IncomeH =0;
GiniTd   =RPovPT       ;if GiniT   =. then GiniTd   =0;if GiniT   =. then GiniT   =0;
HValueTd =OwnNT        ;if HValueT =. then HValueTd =0;if HValueT =. then HValueT =0;
MCostTd  =OHUnitT      ;if MCostT  =. then MCostTd  =0;if MCostT  =. then MCostT  =0;
OCostDTd =OwnNT        ;if OCostDT =. then OCostDTd =0;if OCostDT =. then OCostDT =0;
OCostMDTd=MrtgNT       ;if OCostMDT=. then OCostMDTd=0;if OCostMDT=. then OCostMDT=0;
OCostNDTd=MrtgPT-MrtgNT;if OCostNDT=. then OCostNDTd=0;if OCostNDT=. then OCostNDT=0;
OCostPTd =OwnNT        ;if OCostPT =. then OCostPTd =0;if OCostPT =. then OCostPT =0;
OCostMPTd=MrtgNT       ;if OCostMPT=. then OCostMPTd=0;if OCostMPT=. then OCostMPT=0;
OCostNPTd=MrtgPT-MrtgNT;if OCostNPT=. then OCostNPTd=0;if OCostNPT=. then OCostNPT=0;
MRentDTd =RentNT       ;if MRentDT =. then MRentDTd =0;if MRentDT =. then MRentDT =0;
MRentPTd =RentNT       ;if MRentPT =. then MRentPTd =0;if MRentPT =. then MRentPT =0;
UrbanPd  =PopT         ;if UrbanP  =. then UrbanPd  =0;if UrbanP  =. then UrbanP  =0;if Urban1N=. then Urban1N=0;if Urban2N=. then Urban2N=0;
/* Weighting median values and Gini index by populations before aggregation; Dropping original variables */
IncomeTw =IncomeT *IncomeTd ;
IncomeWw =IncomeW *IncomeWd ;
IncomeBw =IncomeB *IncomeBd ;
IncomeAw =IncomeA *IncomeAd ;
IncomeNw =IncomeN *IncomeNd ;
IncomePw =IncomeP *IncomePd ;
IncomeMw =IncomeM *IncomeMd ;
IncomeHw =IncomeH *IncomeHd ;
GiniTw   =GiniT   *GiniTd   ;
HValueTw =HValueT *HValueTd ;
MCostTw  =MCostT  *MCostTd  ;
OCostDTw =OCostDT *OCostDTd ;
OCostMDTw=OCostMDT*OCostMDTd;
OCostNDTw=OCostNDT*OCostNDTd;
OCostPTw =OCostPT *OCostPTd ;
OCostMPTw=OCostMPT*OCostMPTd;
OCostNPTw=OCostNPT*OCostNPTd;
MRentDTw =MRentDT *MRentDTd ;
MRentPTw =MRentPT *MRentPTd ;
/* Dropping variables of percentages/rates/ratios (will be re-computed based on frequencies after aggregating counties suppressed in CAN data) */
drop
PopWP PopBP PopAP PopNP PopPP PopMP PopHP CPopWP CPopBP CPopAP CPopNP CPopPP CPopMP CPopHP ChildPT ChildPW ChildPB ChildPA ChildPN ChildPP ChildPM ChildPH CARatioT CARatioW
CARatioB CARatioA CARatioN CARatioP CARatioM CARatioH MFRatioT MFRatioW MFRatioB MFRatioA MFRatioN MFRatioP MFRatioM MFRatioH MalePT MalePW MalePB MalePA MalePN MalePP MalePM
MalePH ElderT ElderW ElderB ElderA ElderN ElderP ElderM ElderH SingleT SingleW SingleB SingleA SingleN SingleP SingleM SingleH FHeadT FHeadW FHeadB FHeadA FHeadN FHeadP FHeadM
FHeadH NoHighT NoHighW NoHighB NoHighA NoHighN NoHighP NoHighM NoHighH UnempT UnempW UnempB UnempA UnempN UnempP UnempM UnempH PovT PovW PovB PovA PovN PovP PovM PovH CPovT
CPovW CPovB CPovA CPovN CPovP CPovM CPovH Pov50T Pov150T CPov1 CPov2 CPov3 CPov50T CPov100T CPov125T CPov150T CPov175T CPov185T CPov200T CPov501 CPov502 CPov503 CPov1001
CPov1002 CPov1003 CPov1251 CPov1252 CPov1253 CPov1501 CPov1502 CPov1503 CPov1751 CPov1752 CPov1753 CPov1851 CPov1852 CPov1853 CPov2001 CPov2002 CPov2003 RPovT RPovW RPovB RPovA
RPovN RPovP RPovM RPovH PubAsT WelfarT SnapT SnapW SnapB SnapA SnapN SnapP SnapM SnapH IncomeT IncomeW IncomeB IncomeA IncomeN IncomeP IncomeM IncomeH GiniT HValueT MCostT
OCostDT OCostMDT OCostNDT OCostPT OCostMPT OCostNPT MRentDT MRentPT MortgT LangAPT LangAPW LangAPB LangAPA LangAPN LangAPP LangAPM LangAPH LangBPT LangBPW LangBPB LangBPA
LangBPN LangBPP LangBPM LangBPH LangCPT OutUsT OutUsW OutUsB OutUsA OutUsN OutUsP OutUsM OutUsH FBornT FBornW FBornB FBornA FBornN FBornP FBornM FBornH NotCtzT NotCtzW NotCtzB
NotCtzA NotCtzN NotCtzP NotCtzM NotCtzH MoveT MoveW MoveB MoveA MoveN MoveP MoveM MoveH VacantT RenterT RenterW RenterB RenterA RenterN RenterP RenterM RenterH CrowdT CrowdW
CrowdB CrowdA CrowdN CrowdP CrowdM CrowdH MobileT MobileW MobileB MobileA MobileN MobileP MobileM MobileH DisablT DisablW DisablB DisablA DisablN DisablP DisablM DisablH
DisablTC DisablWC DisablBC DisablAC DisablNC DisablPC DisablMC DisablHC DisablTM DisablTF DisablTA DisablWA DisablBA DisablAA DisablNA DisablPA DisablMA DisablHA Urban1 Urban2
HInsurT HInsurTM HInsurTF HInsurTA HInsurTAM HInsurTAF HInsurTC HInsurTCM HInsurTCF HInsurW HInsurWA HInsurWC HInsurB HInsurBA HInsurBC HInsurA HInsurAA HInsurAC HInsurN 
HInsurNA HInsurNC HInsurP HInsurPA HInsurPC HInsurM HInsurMA HInsurMC HInsurH HInsurHA HInsurHC Density Year CountyFIPS StateFIPS;
run;
/*N=31425; 494 variables*/
/***/
/* Aggregating counties that are suppressed in CAN data (i.e., CountyYear = SS999YYYY) */;
proc summary data=census2 nway;class CountyYear;var _numeric_;output out=census3 sum=;run; 
/*N=6410; 496 variables*/
/***/
/* Compute percentages/rates/ratios/dollar values - assigning 0 when denominator is 0 */;
data census4;set census3;
if Land         =0 then Density =0;if Land         ^=0 then Density =PopT     /Land               ;label Density="Population Density (per sq. mile)";
if PopT         =0 then PopWP   =0;if PopT         ^=0 then PopWP   =PopW     /PopT           *100;label PopWP ="% Non-Hispanic/Latino White alone among persons";
if PopT         =0 then PopBP   =0;if PopT         ^=0 then PopBP   =PopB     /PopT           *100;label PopBP ="% Black alone among persons";
if PopT         =0 then PopAP   =0;if PopT         ^=0 then PopAP   =PopA     /PopT           *100;label PopAP ="% Asian alone among persons";
if PopT         =0 then PopNP   =0;if PopT         ^=0 then PopNP   =PopN     /PopT           *100;label PopNP ="% American Indian|Alaska Native alone among persons";
if PopT         =0 then PopPP   =0;if PopT         ^=0 then PopPP   =PopP     /PopT           *100;label PopPP ="% Native Hawaiian|Other Pacific Islander alone among persons";
if PopT         =0 then PopMP   =0;if PopT         ^=0 then PopMP   =PopM     /PopT           *100;label PopMP ="% Two|More Races among persons";
if PopT         =0 then PopHP   =0;if PopT         ^=0 then PopHP   =PopH     /PopT           *100;label PopHP ="% Hispanic/Latino among persons";
if CPopT        =0 then CPopWP  =0;if CPopT        ^=0 then CPopWP  =CPopW    /CPopT          *100;label CPopWP="% Non-Hispanic/Latino White alone among children";
if CPopT        =0 then CPopBP  =0;if CPopT        ^=0 then CPopBP  =CPopB    /CPopT          *100;label CPopBP="% Black alone among children";
if CPopT        =0 then CPopAP  =0;if CPopT        ^=0 then CPopAP  =CPopA    /CPopT          *100;label CPopAP="% Asian alone children";
if CPopT        =0 then CPopNP  =0;if CPopT        ^=0 then CPopNP  =CPopN    /CPopT          *100;label CPopNP="% American Indian|Alaska Native alone children";
if CPopT        =0 then CPopPP  =0;if CPopT        ^=0 then CPopPP  =CPopP    /CPopT          *100;label CPopPP="% Native Hawaiian|Other Pacific Islander alone children";
if CPopT        =0 then CPopMP  =0;if CPopT        ^=0 then CPopMP  =CPopM    /CPopT          *100;label CPopMP="% Two|More Races children";
if CPopT        =0 then CPopHP  =0;if CPopT        ^=0 then CPopHP  =CPopH    /CPopT          *100;label CPopHP="% Hispanic/Latino children";
if PopT         =0 then ChildPT =0;if PopT         ^=0 then ChildPT =CPopT    /PopT           *100;label ChildPT="% children among persons,Total";
if PopW         =0 then ChildPW =0;if PopW         ^=0 then ChildPW =CPopW    /PopW           *100;label ChildPW="% children among persons,non-Hispanic/Latino White alone";
if PopB         =0 then ChildPB =0;if PopB         ^=0 then ChildPB =CPopB    /PopB           *100;label ChildPB="% children among persons,Black alone";
if PopA         =0 then ChildPA =0;if PopA         ^=0 then ChildPA =CPopA    /PopA           *100;label ChildPA="% children among persons,Asian alone";
if PopN         =0 then ChildPN =0;if PopN         ^=0 then ChildPN =CPopN    /PopN           *100;label ChildPN="% children among persons,American Indian|Alaska Native alone";
if PopP         =0 then ChildPP =0;if PopP         ^=0 then ChildPP =CPopP    /PopP           *100;label ChildPP="% children among persons,Native Hawaiian|Other Pacific Islander alone";
if PopM         =0 then ChildPM =0;if PopM         ^=0 then ChildPM =CPopM    /PopM           *100;label ChildPM="% children among persons,Two|More Races";
if PopH         =0 then ChildPH =0;if PopH         ^=0 then ChildPH =CPopH    /PopH           *100;label ChildPH="% children among persons,Hispanic/Latino";
if APopT        =0 then CARatioT=0;if APopT        ^=0 then CARatioT=CPop14T  /APopT              ;label CARatioT="(# children<=14yr)/(# adults>=20yr),Total";
if APopW        =0 then CARatioW=0;if APopW        ^=0 then CARatioW=CPop14W  /APopW              ;label CARatioW="(# children<=14yr)/(# adults>=20yr),non-Hispanic/Latino White alone";
if APopB        =0 then CARatioB=0;if APopB        ^=0 then CARatioB=CPop14B  /APopB              ;label CARatioB="(# children<=14yr)/(# adults>=20yr),Black alone";
if APopA        =0 then CARatioA=0;if APopA        ^=0 then CARatioA=CPop14A  /APopA              ;label CARatioA="(# children<=14yr)/(# adults>=20yr),Asian alone";
if APopN        =0 then CARatioN=0;if APopN        ^=0 then CARatioN=CPop14N  /APopN              ;label CARatioN="(# children<=14yr)/(# adults>=20yr),American Indian|Alaska Native alone";
if APopP        =0 then CARatioP=0;if APopP        ^=0 then CARatioP=CPop14P  /APopP              ;label CARatioP="(# children<=14yr)/(# adults>=20yr),Native Hawaiian|Other Pacific Islander alone";
if APopM        =0 then CARatioM=0;if APopM        ^=0 then CARatioM=CPop14M  /APopM              ;label CARatioM="(# children<=14yr)/(# adults>=20yr),Two|More Races";
if APopH        =0 then CARatioH=0;if APopH        ^=0 then CARatioH=CPop14H  /APopH              ;label CARatioH="(# children<=14yr)/(# adults>=20yr),Hispanic/Latino";
if FemaleT+MaleT=0 then MalePT  =0;if FemaleT+MaleT^=0 then MalePT  =MaleT    /(FemaleT+MaleT)*100;label MalePT="% male among persons aged 20-64yr,Total";
if FemaleW+MaleW=0 then MalePW  =0;if FemaleW+MaleW^=0 then MalePW  =MaleW    /(FemaleW+MaleW)*100;label MalePW="% male among persons aged 20-64yr,non-Hispanic/Latino White alone";
if FemaleB+MaleB=0 then MalePB  =0;if FemaleB+MaleB^=0 then MalePB  =MaleB    /(FemaleB+MaleB)*100;label MalePB="% male among persons aged 20-64yr,Black alone";
if FemaleA+MaleA=0 then MalePA  =0;if FemaleA+MaleA^=0 then MalePA  =MaleA    /(FemaleA+MaleA)*100;label MalePA="% male among persons aged 20-64yr,Asian alone";
if FemaleN+MaleN=0 then MalePN  =0;if FemaleN+MaleN^=0 then MalePN  =MaleN    /(FemaleN+MaleN)*100;label MalePN="% male among persons aged 20-64yr,American Indian|Alaska Native alone";
if FemaleP+MaleP=0 then MalePP  =0;if FemaleP+MaleP^=0 then MalePP  =MaleP    /(FemaleP+MaleP)*100;label MalePP="% male among persons aged 20-64yr,Native Hawaiian|Other Pacific Islander alone";
if FemaleM+MaleM=0 then MalePM  =0;if FemaleM+MaleM^=0 then MalePM  =MaleM    /(FemaleM+MaleM)*100;label MalePM="% male among persons aged 20-64yr,Two|More Races";
if FemaleH+MaleH=0 then MalePH  =0;if FemaleH+MaleH^=0 then MalePH  =MaleH    /(FemaleH+MaleH)*100;label MalePH="% male among persons aged 20-64yr,Hispanic/Latino";
if FemaleT      =0 then MFRatioT=0;if FemaleT      ^=0 then MFRatioT=MaleT    /FemaleT            ;label MFRatioT="(# male adults 20-64yr)/(# female adults 20-64yr),Total";
if FemaleW      =0 then MFRatioW=0;if FemaleW      ^=0 then MFRatioW=MaleW    /FemaleW            ;label MFRatioW="(# male adults 20-64yr)/(# female adults 20-64yr),non-Hispanic/Latino White alone";
if FemaleB      =0 then MFRatioB=0;if FemaleB      ^=0 then MFRatioB=MaleB    /FemaleB            ;label MFRatioB="(# male adults 20-64yr)/(# female adults 20-64yr),Black alone";
if FemaleA      =0 then MFRatioA=0;if FemaleA      ^=0 then MFRatioA=MaleA    /FemaleA            ;label MFRatioA="(# male adults 20-64yr)/(# female adults 20-64yr),Asian alone";
if FemaleN      =0 then MFRatioN=0;if FemaleN      ^=0 then MFRatioN=MaleN    /FemaleN            ;label MFRatioN="(# male adults 20-64yr)/(# female adults 20-64yr),American Indian|Alaska Native alone";
if FemaleP      =0 then MFRatioP=0;if FemaleP      ^=0 then MFRatioP=MaleP    /FemaleP            ;label MFRatioP="(# male adults 20-64yr)/(# female adults 20-64yr),Native Hawaiian|Other Pacific Islander alone";
if FemaleM      =0 then MFRatioM=0;if FemaleM      ^=0 then MFRatioM=MaleM    /FemaleM            ;label MFRatioM="(# male adults 20-64yr)/(# female adults 20-64yr),Two|More Races";
if FemaleH      =0 then MFRatioH=0;if FemaleH      ^=0 then MFRatioH=MaleH    /FemaleH            ;label MFRatioH="(# male adults 20-64yr)/(# female adults 20-64yr),Hispanic/Latino";
if PopT         =0 then ElderT  =0;if PopT         ^=0 then ElderT  =EldPopT  /PopT           *100;label ElderT="% elder(>=65yr) persons,Total";
if PopW         =0 then ElderW  =0;if PopW         ^=0 then ElderW  =EldPopW  /PopW           *100;label ElderW="% elder(>=65yr) persons,non-Hispanic/Latino White alone";
if PopB         =0 then ElderB  =0;if PopB         ^=0 then ElderB  =EldPopB  /PopB           *100;label ElderB="% elder(>=65yr) persons,Black alone";
if PopA         =0 then ElderA  =0;if PopA         ^=0 then ElderA  =EldPopA  /PopA           *100;label ElderA="% elder(>=65yr) persons,Asian alone";
if PopN         =0 then ElderN  =0;if PopN         ^=0 then ElderN  =EldPopN  /PopN           *100;label ElderN="% elder(>=65yr) persons,American Indian|Alaska Native alone";
if PopP         =0 then ElderP  =0;if PopP         ^=0 then ElderP  =EldPopP  /PopP           *100;label ElderP="% elder(>=65yr) persons,Native Hawaiian|Other Pacific Islander alone";
if PopM         =0 then ElderM  =0;if PopM         ^=0 then ElderM  =EldPopM  /PopM           *100;label ElderM="% elder(>=65yr) persons,Two|More Races";
if PopH         =0 then ElderH  =0;if PopH         ^=0 then ElderH  =EldPopH  /PopH           *100;label ElderH="% elder(>=65yr) persons,Hispanic/Latino";
if FamHHT       =0 then SingleT =0;if FamHHT       ^=0 then SingleT =SingleNT /FamHHT         *100;label SingleT="% single households w/ children<18yr,Total";
if FamHHW       =0 then SingleW =0;if FamHHW       ^=0 then SingleW =SingleNW /FamHHW         *100;label SingleW="% single households w/ children<18yr,non-Hispanic/Latino White alone";
if FamHHB       =0 then SingleB =0;if FamHHB       ^=0 then SingleB =SingleNB /FamHHB         *100;label SingleB="% single households w/ children<18yr,Black alone";
if FamHHA       =0 then SingleA =0;if FamHHA       ^=0 then SingleA =SingleNA /FamHHA         *100;label SingleA="% single households w/ children<18yr,Asian alone";
if FamHHN       =0 then SingleN =0;if FamHHN       ^=0 then SingleN =SingleNN /FamHHN         *100;label SingleN="% single households w/ children<18yr,American Indian|Alaska Native alone";
if FamHHP       =0 then SingleP =0;if FamHHP       ^=0 then SingleP =SingleNP /FamHHP         *100;label SingleP="% single households w/ children<18yr,Native Hawaiian|Other Pacific Islander alone";
if FamHHM       =0 then SingleM =0;if FamHHM       ^=0 then SingleM =SingleNM /FamHHM         *100;label SingleM="% single households w/ children<18yr,Two|More Races";
if FamHHH       =0 then SingleH =0;if FamHHH       ^=0 then SingleH =SingleNH /FamHHH         *100;label SingleH="% single households w/ children<18yr,Hispanic/Latino";
if FamHHT       =0 then FHeadT  =0;if FamHHT       ^=0 then FHeadT  =FHeadNT  /FamHHT         *100;label FHeadT="% female headed households w/ children<18yr,Total";
if FamHHW       =0 then FHeadW  =0;if FamHHW       ^=0 then FHeadW  =FHeadNW  /FamHHW         *100;label FHeadW="% female headed households w/ children<18yr,non-Hispanic/Latino White alone";
if FamHHB       =0 then FHeadB  =0;if FamHHB       ^=0 then FHeadB  =FHeadNB  /FamHHB         *100;label FHeadB="% female headed households w/ children<18yr,Black alone";
if FamHHA       =0 then FHeadA  =0;if FamHHA       ^=0 then FHeadA  =FHeadNA  /FamHHA         *100;label FHeadA="% female headed households w/ children<18yr,Asian alone";
if FamHHN       =0 then FHeadN  =0;if FamHHN       ^=0 then FHeadN  =FHeadNN  /FamHHN         *100;label FHeadN="% female headed households w/ children<18yr,American Indian|Alaska Native alone";
if FamHHP       =0 then FHeadP  =0;if FamHHP       ^=0 then FHeadP  =FHeadNP  /FamHHP         *100;label FHeadP="% female headed households w/ children<18yr,Native Hawaiian|Other Pacific Islander alone";
if FamHHM       =0 then FHeadM  =0;if FamHHM       ^=0 then FHeadM  =FHeadNM  /FamHHM         *100;label FHeadM="% female headed households w/ children<18yr,Two|More Races";
if FamHHH       =0 then FHeadH  =0;if FamHHH       ^=0 then FHeadH  =FHeadNH  /FamHHH         *100;label FHeadH="% female headed households w/ children<18yr,Hispanic/Latino";
if HSnoPT       =0 then NoHighT =0;if HSnoPT       ^=0 then NoHighT =HSnoNT   /HSnoPT         *100;label NoHighT="% persons>=25yr w/ no high school degree,Total";
if HSnoPW       =0 then NoHighW =0;if HSnoPW       ^=0 then NoHighW =HSnoNW   /HSnoPW         *100;label NoHighW="% persons>=25yr w/ no high school degree,non-Hispanic/Latino White alone";
if HSnoPB       =0 then NoHighB =0;if HSnoPB       ^=0 then NoHighB =HSnoNB   /HSnoPB         *100;label NoHighB="% persons>=25yr w/ no high school degree,Black alone";
if HSnoPA       =0 then NoHighA =0;if HSnoPA       ^=0 then NoHighA =HSnoNA   /HSnoPA         *100;label NoHighA="% persons>=25yr w/ no high school degree,Asian alone";
if HSnoPN       =0 then NoHighN =0;if HSnoPN       ^=0 then NoHighN =HSnoNN   /HSnoPN         *100;label NoHighN="% persons>=25yr w/ no high school degree,American Indian|Alaska Native alone";
if HSnoPP       =0 then NoHighP =0;if HSnoPP       ^=0 then NoHighP =HSnoNP   /HSnoPP         *100;label NoHighP="% persons>=25yr w/ no high school degree,Native Hawaiian|Other Pacific Islander alone";
if HSnoPM       =0 then NoHighM =0;if HSnoPM       ^=0 then NoHighM =HSnoNM   /HSnoPM         *100;label NoHighM="% persons>=25yr w/ no high school degree,Two|More Races";
if HSnoPH       =0 then NoHighH =0;if HSnoPH       ^=0 then NoHighH =HSnoNH   /HSnoPH         *100;label NoHighH="% persons>=25yr w/ no high school degree,Hispanic/Latino";
if LaborT       =0 then UnempT  =0;if LaborT       ^=0 then UnempT  =UnempNT  /LaborT         *100;label UnempT="% unemployed civilian in labor force(16+),Total";
if LaborW       =0 then UnempW  =0;if LaborW       ^=0 then UnempW  =UnempNW  /LaborW         *100;label UnempW="% unemployed civilian in labor force(16+),non-Hispanic/Latino White alone";
if LaborB       =0 then UnempB  =0;if LaborB       ^=0 then UnempB  =UnempNB  /LaborB         *100;label UnempB="% unemployed civilian in labor force(16+),Black alone";
if LaborA       =0 then UnempA  =0;if LaborA       ^=0 then UnempA  =UnempNA  /LaborA         *100;label UnempA="% unemployed civilian in labor force(16+),Asian alone";
if LaborN       =0 then UnempN  =0;if LaborN       ^=0 then UnempN  =UnempNN  /LaborN         *100;label UnempN="% unemployed civilian in labor force(16+),American Indian|Alaska Native alone";
if LaborP       =0 then UnempP  =0;if LaborP       ^=0 then UnempP  =UnempNP  /LaborP         *100;label UnempP="% unemployed civilian in labor force(16+),Native Hawaiian|Other Pacific Islander alone";
if LaborM       =0 then UnempM  =0;if LaborM       ^=0 then UnempM  =UnempNM  /LaborM         *100;label UnempM="% unemployed civilian in labor force(16+),Two|More Races";
if LaborH       =0 then UnempH  =0;if LaborH       ^=0 then UnempH  =UnempNH  /LaborH         *100;label UnempH="% unemployed civilian in labor force(16+),Hispanic/Latino";
if PovPT        =0 then PovT    =0;if PovPT        ^=0 then PovT    =PovNT    /PovPT          *100;label PovT="% persons below poverty,Total";
if PovPW        =0 then PovW    =0;if PovPW        ^=0 then PovW    =PovNW    /PovPW          *100;label PovW="% persons below poverty,non-Hispanic/Latino White alone";
if PovPB        =0 then PovB    =0;if PovPB        ^=0 then PovB    =PovNB    /PovPB          *100;label PovB="% persons below poverty,Black alone";
if PovPA        =0 then PovA    =0;if PovPA        ^=0 then PovA    =PovNA    /PovPA          *100;label PovA="% persons below poverty,Asian alone";
if PovPN        =0 then PovN    =0;if PovPN        ^=0 then PovN    =PovNN    /PovPN          *100;label PovN="% persons below poverty,American Indian|Alaska Native alone";
if PovPP        =0 then PovP    =0;if PovPP        ^=0 then PovP    =PovNP    /PovPP          *100;label PovP="% persons below poverty,Native Hawaiian|Other Pacific Islander alone";
if PovPM        =0 then PovM    =0;if PovPM        ^=0 then PovM    =PovNM    /PovPM          *100;label PovM="% persons below poverty,Two|More Races";
if PovPH        =0 then PovH    =0;if PovPH        ^=0 then PovH    =PovNH    /PovPH          *100;label PovH="% persons below poverty,Hispanic/Latino";
if CPovPT       =0 then CPovT   =0;if CPovPT       ^=0 then CPovT   =CPovNT   /CPovPT         *100;label CPovT="% children below poverty,Total";
if CPovPW       =0 then CPovW   =0;if CPovPW       ^=0 then CPovW   =CPovNW   /CPovPW         *100;label CPovW="% children below poverty,non-Hispanic/Latino White alone";
if CPovPB       =0 then CPovB   =0;if CPovPB       ^=0 then CPovB   =CPovNB   /CPovPB         *100;label CPovB="% children below poverty,Black alone";
if CPovPA       =0 then CPovA   =0;if CPovPA       ^=0 then CPovA   =CPovNA   /CPovPA         *100;label CPovA="% children below poverty,Asian alone";
if CPovPN       =0 then CPovN   =0;if CPovPN       ^=0 then CPovN   =CPovNN   /CPovPN         *100;label CPovN="% children below poverty,American Indian|Alaska Native alone";
if CPovPP       =0 then CPovP   =0;if CPovPP       ^=0 then CPovP   =CPovNP   /CPovPP         *100;label CPovP="% children below poverty,Native Hawaiian|Other Pacific Islander alone";
if CPovPM       =0 then CPovM   =0;if CPovPM       ^=0 then CPovM   =CPovNM   /CPovPM         *100;label CPovM="% children below poverty,Two|More Races";
if CPovPH       =0 then CPovH   =0;if CPovPH       ^=0 then CPovH   =CPovNH   /CPovPH         *100;label CPovH="% children below poverty,Hispanic/Latino";
if RPovPT       =0 then RPovT   =0;if RPovPT       ^=0 then RPovT   =RPovNT   /RPovPT         *100;label RPovT="Relative poverty,% HH<50% US median income,Total";
if RPovPW       =0 then RPovW   =0;if RPovPW       ^=0 then RPovW   =RPovNW   /RPovPW         *100;label RPovW="Relative poverty,% HH<50% US median income,non-Hispanic/Latino White alone";
if RPovPB       =0 then RPovB   =0;if RPovPB       ^=0 then RPovB   =RPovNB   /RPovPB         *100;label RPovB="Relative poverty,% HH<50% US median income,Black alone";
if RPovPA       =0 then RPovA   =0;if RPovPA       ^=0 then RPovA   =RPovNA   /RPovPA         *100;label RPovA="Relative poverty,% HH<50% US median income,Asian alone";
if RPovPN       =0 then RPovN   =0;if RPovPN       ^=0 then RPovN   =RPovNN   /RPovPN         *100;label RPovN="Relative poverty,% HH<50% US median income,American Indian|Alaska Native alone";
if RPovPP       =0 then RPovP   =0;if RPovPP       ^=0 then RPovP   =RPovNP   /RPovPP         *100;label RPovP="Relative poverty,% HH<50% US median income,Native Hawaiian|Other Pacific Islander alone";
if RPovPM       =0 then RPovM   =0;if RPovPM       ^=0 then RPovM   =RPovNM   /RPovPM         *100;label RPovM="Relative poverty,% HH<50% US median income,Two|More Races";
if RPovPH       =0 then RPovH   =0;if RPovPH       ^=0 then RPovH   =RPovNH   /RPovPH         *100;label RPovH="Relative poverty,% HH<50% US median income,Hispanic/Latino";
if P00PT        =0 then Pov50T  =0;if P00PT        ^=0 then Pov50T  =P50NT    /P00PT          *100;label Pov50T  ="% persons<50% FPL,Total";
if P00PT        =0 then Pov150T =0;if P00PT        ^=0 then Pov150T =P150NT   /P00PT          *100;label Pov150T ="% persons<150% FPL,Total";
if CP00PT       =0 then CPov50T =0;if CP00PT       ^=0 then CPov50T =CP50NT   /CP00PT         *100;label CPov50T ="% children<50% FPL,Total";
if CP00PT       =0 then CPov100T=0;if CP00PT       ^=0 then CPov100T=CP100NT  /CP00PT         *100;label CPov100T="% children<100% FPL,Total";
if CP00PT       =0 then CPov125T=0;if CP00PT       ^=0 then CPov125T=CP125NT  /CP00PT         *100;label CPov125T="% children<125% FPL,Total";
if CP00PT       =0 then CPov150T=0;if CP00PT       ^=0 then CPov150T=CP150NT  /CP00PT         *100;label CPov150T="% children<150% FPL,Total";
if CP00PT       =0 then CPov175T=0;if CP00PT       ^=0 then CPov175T=CP175NT  /CP00PT         *100;label CPov175T="% children<175% FPL,Total";
if CP00PT       =0 then CPov185T=0;if CP00PT       ^=0 then CPov185T=CP185NT  /CP00PT         *100;label CPov185T="% children<185% FPL,Total";
if CP00PT       =0 then CPov200T=0;if CP00PT       ^=0 then CPov200T=CP200NT  /CP00PT         *100;label CPov200T="% children<200% FPL,Total";
if CPovP1       =0 then CPov1   =0;if CPovP1       ^=0 then CPov1   =CPovN1   /CPovP1         *100;label CPov1="% children aged 0-5 below poverty,Total";
if CPovP2       =0 then CPov2   =0;if CPovP2       ^=0 then CPov2   =CPovN2   /CPovP2         *100;label CPov2="% children aged 6-11 below poverty,Total";
if CPovP3       =0 then CPov3   =0;if CPovP3       ^=0 then CPov3   =CPovN3   /CPovP3         *100;label CPov3="% children aged 12-17 below poverty,Total";
if CP00P1       =0 then CPov501 =0;if CP00P1       ^=0 then CPov501 =CP50N1   /CP00P1         *100;label CPov501 ="% children aged 0-5   <50% FPL,Total";
if CP00P2       =0 then CPov502 =0;if CP00P2       ^=0 then CPov502 =CP50N2   /CP00P2         *100;label CPov502 ="% children aged 6-11  <50% FPL,Total";
if CP00P3       =0 then CPov503 =0;if CP00P3       ^=0 then CPov503 =CP50N3   /CP00P3         *100;label CPov503 ="% children aged 12-17 <50% FPL,Total";
if CP00P1       =0 then CPov1001=0;if CP00P1       ^=0 then CPov1001=CP100N1  /CP00P1         *100;label CPov1001="% children aged 0-5   <100% FPL,Total";
if CP00P2       =0 then CPov1002=0;if CP00P2       ^=0 then CPov1002=CP100N2  /CP00P2         *100;label CPov1002="% children aged 6-11  <100% FPL,Total";
if CP00P3       =0 then CPov1003=0;if CP00P3       ^=0 then CPov1003=CP100N3  /CP00P3         *100;label CPov1003="% children aged 12-17 <100% FPL,Total";
if CP00P1       =0 then CPov1251=0;if CP00P1       ^=0 then CPov1251=CP125N1  /CP00P1         *100;label CPov1251="% children aged 0-5   <125% FPL,Total";
if CP00P2       =0 then CPov1252=0;if CP00P2       ^=0 then CPov1252=CP125N2  /CP00P2         *100;label CPov1252="% children aged 6-11  <125% FPL,Total";
if CP00P3       =0 then CPov1253=0;if CP00P3       ^=0 then CPov1253=CP125N3  /CP00P3         *100;label CPov1253="% children aged 12-17 <125% FPL,Total";
if CP00P1       =0 then CPov1501=0;if CP00P1       ^=0 then CPov1501=CP150N1  /CP00P1         *100;label CPov1501="% children aged 0-5   <150% FPL,Total";
if CP00P2       =0 then CPov1502=0;if CP00P2       ^=0 then CPov1502=CP150N2  /CP00P2         *100;label CPov1502="% children aged 6-11  <150% FPL,Total";
if CP00P3       =0 then CPov1503=0;if CP00P3       ^=0 then CPov1503=CP150N3  /CP00P3         *100;label CPov1503="% children aged 12-17 <150% FPL,Total";
if CP00P1       =0 then CPov1751=0;if CP00P1       ^=0 then CPov1751=CP175N1  /CP00P1         *100;label CPov1751="% children aged 0-5   <175% FPL,Total";
if CP00P2       =0 then CPov1752=0;if CP00P2       ^=0 then CPov1752=CP175N2  /CP00P2         *100;label CPov1752="% children aged 6-11  <175% FPL,Total";
if CP00P3       =0 then CPov1753=0;if CP00P3       ^=0 then CPov1753=CP175N3  /CP00P3         *100;label CPov1753="% children aged 12-17 <175% FPL,Total";
if CP00P1       =0 then CPov1851=0;if CP00P1       ^=0 then CPov1851=CP185N1  /CP00P1         *100;label CPov1851="% children aged 0-5   <185% FPL,Total";
if CP00P2       =0 then CPov1852=0;if CP00P2       ^=0 then CPov1852=CP185N2  /CP00P2         *100;label CPov1852="% children aged 6-11  <185% FPL,Total";
if CP00P3       =0 then CPov1853=0;if CP00P3       ^=0 then CPov1853=CP185N3  /CP00P3         *100;label CPov1853="% children aged 12-17 <185% FPL,Total";
if CP00P1       =0 then CPov2001=0;if CP00P1       ^=0 then CPov2001=CP200N1  /CP00P1         *100;label CPov2001="% children aged 0-5   <200% FPL,Total";
if CP00P2       =0 then CPov2002=0;if CP00P2       ^=0 then CPov2002=CP200N2  /CP00P2         *100;label CPov2002="% children aged 6-11  <200% FPL,Total";
if CP00P3       =0 then CPov2003=0;if CP00P3       ^=0 then CPov2003=CP200N3  /CP00P3         *100;label CPov2003="% children aged 12-17 <200% FPL,Total";
if PubAsPT      =0 then PubAsT  =0;if PubAsPT      ^=0 then PubAsT  =PubAsNT  /PubAsPT        *100;label PubAsT  ="% households w/ public assistance income (general assistance|TANF),Total";
if WelfarPT     =0 then WelfarT =0;if WelfarPT     ^=0 then WelfarT =WelfarNT /WelfarPT       *100;label WelfarT="% households w/ public assistance income (general assistance|TANF) or food stamps/SNAP,Total";
if SnapPT       =0 then SnapT   =0;if SnapPT       ^=0 then SnapT   =SnapNT   /SnapPT         *100;label SnapT="% households on food stamps/SNAP,Total";
if SnapPW       =0 then SnapW   =0;if SnapPW       ^=0 then SnapW   =SnapNW   /SnapPW         *100;label SnapW="% households on food stamps/SNAP,non-Hispanic/Latino White alone";
if SnapPB       =0 then SnapB   =0;if SnapPB       ^=0 then SnapB   =SnapNB   /SnapPB         *100;label SnapB="% households on food stamps/SNAP,Black alone";
if SnapPA       =0 then SnapA   =0;if SnapPA       ^=0 then SnapA   =SnapNA   /SnapPA         *100;label SnapA="% households on food stamps/SNAP,Asian alone";
if SnapPN       =0 then SnapN   =0;if SnapPN       ^=0 then SnapN   =SnapNN   /SnapPN         *100;label SnapN="% households on food stamps/SNAP,American Indian|Alaska Native alone";
if SnapPP       =0 then SnapP   =0;if SnapPP       ^=0 then SnapP   =SnapNP   /SnapPP         *100;label SnapP="% households on food stamps/SNAP,Native Hawaiian|Other Pacific Islander alone";
if SnapPM       =0 then SnapM   =0;if SnapPM       ^=0 then SnapM   =SnapNM   /SnapPM         *100;label SnapM="% households on food stamps/SNAP,Two|More Races";
if SnapPH       =0 then SnapH   =0;if SnapPH       ^=0 then SnapH   =SnapNH   /SnapPH         *100;label SnapH="% households on food stamps/SNAP,Hispanic/Latino";
if IncomeTd     =0 then IncomeT =0;if IncomeTd     ^=0 then IncomeT =IncomeTw /IncomeTd           ;label IncomeT="Median Household Income(in 2018 inflation-adjusted dollars),Total";
if IncomeWd     =0 then IncomeW =0;if IncomeWd     ^=0 then IncomeW =IncomeWw /IncomeWd           ;label IncomeW="Median Household Income(in 2018 inflation-adjusted dollars),non-Hispanic/Latino White alone";
if IncomeBd     =0 then IncomeB =0;if IncomeBd     ^=0 then IncomeB =IncomeBw /IncomeBd           ;label IncomeB="Median Household Income(in 2018 inflation-adjusted dollars),Black alone";
if IncomeAd     =0 then IncomeA =0;if IncomeAd     ^=0 then IncomeA =IncomeAw /IncomeAd           ;label IncomeA="Median Household Income(in 2018 inflation-adjusted dollars),Asian alone";
if IncomeNd     =0 then IncomeN =0;if IncomeNd     ^=0 then IncomeN =IncomeNw /IncomeNd           ;label IncomeN="Median Household Income(in 2018 inflation-adjusted dollars),American Indian|Alaska Native alone";
if IncomePd     =0 then IncomeP =0;if IncomePd     ^=0 then IncomeP =IncomePw /IncomePd           ;label IncomeP="Median Household Income(in 2018 inflation-adjusted dollars),Native Hawaiian|Other Pacific Islander alone";
if IncomeMd     =0 then IncomeM =0;if IncomeMd     ^=0 then IncomeM =IncomeMw /IncomeMd           ;label IncomeM="Median Household Income(in 2018 inflation-adjusted dollars),Two|More Races";
if IncomeHd     =0 then IncomeH =0;if IncomeHd     ^=0 then IncomeH =IncomeHw /IncomeHd           ;label IncomeH="Median Household Income(in 2018 inflation-adjusted dollars),Hispanic/Latino";
if GiniTd       =0 then GiniT   =0;if GiniTd       ^=0 then GiniT   =GiniTw   /GiniTd             ;label GiniT="Households Gini Index,Total";
if HValueTd     =0 then HValueT =0;if HValueTd     ^=0 then HValueT =HValueTw /HValueTd           ;label HValueT="Owner occupied housing units Median value(in 2018 inflation-adjusted dollars),Total";
if MCostTd      =0 then MCostT  =0;if MCostTd      ^=0 then MCostT  =MCostTw  /MCostTd            ;label MCostT="Median monthly housing costs-occupied housing units(in 2018 inflation-adjusted dollars),Total";
if OCostDTd     =0 then OCostDT =0;if OCostDTd     ^=0 then OCostDT =OCostDTw /OCostDTd           ;label OCostDT="Median monthly owner costs for housing units(in 2018 inflation-adjusted dollars),Total";
if OCostMDTd    =0 then OCostMDT=0;if OCostMDTd    ^=0 then OCostMDT=OCostMDTw/OCostMDTd          ;label OCostMDT="Median monthly owner costs for housing units w/ Mortgage(in 2018 inflation-adjusted dollars),Total";
if OCostNDTd    =0 then OCostNDT=0;if OCostNDTd    ^=0 then OCostNDT=OCostNDTw/OCostNDTd          ;label OCostNDT="Median monthly owner costs for housing units w/o Mortgage(in 2018 inflation-adjusted dollars),Total";
if OCostPTd     =0 then OCostPT =0;if OCostPTd     ^=0 then OCostPT =OCostPTw /OCostPTd           ;label OCostPT="Median monthly owner costs as % HH income,Total";
if OCostMPTd    =0 then OCostMPT=0;if OCostMPTd    ^=0 then OCostMPT=OCostMPTw/OCostMPTd          ;label OCostMPT="Median monthly owner costs as % HH income for housing units w/ Mortgage,Total";
if OCostNPTd    =0 then OCostNPT=0;if OCostNPTd    ^=0 then OCostNPT=OCostNPTw/OCostNPTd          ;label OCostNPT="Median monthly owner costs as % HH income for housing units w/o Mortgage,Total";
if MRentDTd     =0 then MRentDT =0;if MRentDTd     ^=0 then MRentDT =MRentDTw /MRentDTd           ;label MRentDT="median gross rent(in 2018 inflation-adjusted dollars),Total";
if MRentPTd     =0 then MRentPT =0;if MRentPTd     ^=0 then MRentPT =MRentPTw /MRentPTd           ;label MRentPT="median gross rent as % household income,Total";
if LangPT       =0 then LangAPT =0;if LangPT       ^=0 then LangAPT =LangANT  /LangPT         *100;label LangAPT="% persons>=5yr speak other languages,Total";
if LangPW       =0 then LangAPW =0;if LangPW       ^=0 then LangAPW =LangANW  /LangPW         *100;label LangAPW="% persons>=5yr speak other languages,non-Hispanic/Latino White alone";
if LangPB       =0 then LangAPB =0;if LangPB       ^=0 then LangAPB =LangANB  /LangPB         *100;label LangAPB="% persons>=5yr speak other languages,Black alone";
if LangPA       =0 then LangAPA =0;if LangPA       ^=0 then LangAPA =LangANA  /LangPA         *100;label LangAPA="% persons>=5yr speak other languages,Asian alone";
if LangPN       =0 then LangAPN =0;if LangPN       ^=0 then LangAPN =LangANN  /LangPN         *100;label LangAPN="% persons>=5yr speak other languages,American Indian|Alaska Native alone";
if LangPP       =0 then LangAPP =0;if LangPP       ^=0 then LangAPP =LangANP  /LangPP         *100;label LangAPP="% persons>=5yr speak other languages,Native Hawaiian|Other Pacific Islander alone";
if LangPM       =0 then LangAPM =0;if LangPM       ^=0 then LangAPM =LangANM  /LangPM         *100;label LangAPM="% persons>=5yr speak other languages,Two|More Races";
if LangPH       =0 then LangAPH =0;if LangPH       ^=0 then LangAPH =LangANH  /LangPH         *100;label LangAPH="% persons>=5yr speak other languages,Hispanic/Latino";
if LangPT       =0 then LangBPT =0;if LangPT       ^=0 then LangBPT =LangBNT  /LangPT         *100;label LangBPT="% persons>=5yr speak english not very well(=well|not well|not at all),Total";
if LangPW       =0 then LangBPW =0;if LangPW       ^=0 then LangBPW =LangBNW  /LangPW         *100;label LangBPW="% persons>=5yr speak english not very well(=well|not well|not at all),non-Hispanic/Latino White alone";
if LangPB       =0 then LangBPB =0;if LangPB       ^=0 then LangBPB =LangBNB  /LangPB         *100;label LangBPB="% persons>=5yr speak english not very well(=well|not well|not at all),Black alone";
if LangPA       =0 then LangBPA =0;if LangPA       ^=0 then LangBPA =LangBNA  /LangPA         *100;label LangBPA="% persons>=5yr speak english not very well(=well|not well|not at all),Asian alone";
if LangPN       =0 then LangBPN =0;if LangPN       ^=0 then LangBPN =LangBNN  /LangPN         *100;label LangBPN="% persons>=5yr speak english not very well(=well|not well|not at all),American Indian|Alaska Native alone";
if LangPP       =0 then LangBPP =0;if LangPP       ^=0 then LangBPP =LangBNP  /LangPP         *100;label LangBPP="% persons>=5yr speak english not very well(=well|not well|not at all),Native Hawaiian|Other Pacific Islander alone";
if LangPM       =0 then LangBPM =0;if LangPM       ^=0 then LangBPM =LangBNM  /LangPM         *100;label LangBPM="% persons>=5yr speak english not very well(=well|not well|not at all),Two|More Races";
if LangPH       =0 then LangBPH =0;if LangPH       ^=0 then LangBPH =LangBNH  /LangPH         *100;label LangBPH="% persons>=5yr speak english not very well(=well|not well|not at all),Hispanic/Latino";
if LangPT       =0 then LangCPT =0;if LangPT       ^=0 then LangCPT =LangCNT  /LangPT         *100;label LangCPT="% persons>=5yr speak english not well(=not well|not at all),Total";
if NatTPT       =0 then OutUsT  =0;if NatTPT       ^=0 then OutUsT  =NatOST   /NatTPT         *100;label OutUsT="% persons born outside US,Total";
if NatTPW       =0 then OutUsW  =0;if NatTPW       ^=0 then OutUsW  =NatOSW   /NatTPW         *100;label OutUsW="% persons born outside US,non-Hispanic/Latino White alone";
if NatTPB       =0 then OutUsB  =0;if NatTPB       ^=0 then OutUsB  =NatOSB   /NatTPB         *100;label OutUsB="% persons born outside US,Black alone";
if NatTPA       =0 then OutUsA  =0;if NatTPA       ^=0 then OutUsA  =NatOSA   /NatTPA         *100;label OutUsA="% persons born outside US,Asian alone";
if NatTPN       =0 then OutUsN  =0;if NatTPN       ^=0 then OutUsN  =NatOSN   /NatTPN         *100;label OutUsN="% persons born outside US,American Indian|Alaska Native alone";
if NatTPP       =0 then OutUsP  =0;if NatTPP       ^=0 then OutUsP  =NatOSP   /NatTPP         *100;label OutUsP="% persons born outside US,Native Hawaiian|Other Pacific Islander alone";
if NatTPM       =0 then OutUsM  =0;if NatTPM       ^=0 then OutUsM  =NatOSM   /NatTPM         *100;label OutUsM="% persons born outside US,Two|More Races";
if NatTPH       =0 then OutUsH  =0;if NatTPH       ^=0 then OutUsH  =NatOSH   /NatTPH         *100;label OutUsH="% persons born outside US,Hispanic/Latino";
if NatTPT       =0 then FBornT  =0;if NatTPT       ^=0 then FBornT  =NatFBT   /NatTPT         *100;label FBornT="% persons foreign born,Total";
if NatTPW       =0 then FBornW  =0;if NatTPW       ^=0 then FBornW  =NatFBW   /NatTPW         *100;label FBornW="% persons foreign born,non-Hispanic/Latino White alone";
if NatTPB       =0 then FBornB  =0;if NatTPB       ^=0 then FBornB  =NatFBB   /NatTPB         *100;label FBornB="% persons foreign born,Black alone";
if NatTPA       =0 then FBornA  =0;if NatTPA       ^=0 then FBornA  =NatFBA   /NatTPA         *100;label FBornA="% persons foreign born,Asian alone";
if NatTPN       =0 then FBornN  =0;if NatTPN       ^=0 then FBornN  =NatFBN   /NatTPN         *100;label FBornN="% persons foreign born,American Indian|Alaska Native alone";
if NatTPP       =0 then FBornP  =0;if NatTPP       ^=0 then FBornP  =NatFBP   /NatTPP         *100;label FBornP="% persons foreign born,Native Hawaiian|Other Pacific Islander alone";
if NatTPM       =0 then FBornM  =0;if NatTPM       ^=0 then FBornM  =NatFBM   /NatTPM         *100;label FBornM="% persons foreign born,Two|More Races";
if NatTPH       =0 then FBornH  =0;if NatTPH       ^=0 then FBornH  =NatFBH   /NatTPH         *100;label FBornH="% persons foreign born,Hispanic/Latino";
if NatTPT       =0 then NotCtzT =0;if NatTPT       ^=0 then NotCtzT =NatNCT   /NatTPT         *100;label NotCtzT="% persons not a citizen,Total";
if NatTPW       =0 then NotCtzW =0;if NatTPW       ^=0 then NotCtzW =NatNCW   /NatTPW         *100;label NotCtzW="% persons not a citizen,non-Hispanic/Latino White alone";
if NatTPB       =0 then NotCtzB =0;if NatTPB       ^=0 then NotCtzB =NatNCB   /NatTPB         *100;label NotCtzB="% persons not a citizen,Black alone";
if NatTPA       =0 then NotCtzA =0;if NatTPA       ^=0 then NotCtzA =NatNCA   /NatTPA         *100;label NotCtzA="% persons not a citizen,Asian alone";
if NatTPN       =0 then NotCtzN =0;if NatTPN       ^=0 then NotCtzN =NatNCN   /NatTPN         *100;label NotCtzN="% persons not a citizen,American Indian|Alaska Native alone";
if NatTPP       =0 then NotCtzP =0;if NatTPP       ^=0 then NotCtzP =NatNCP   /NatTPP         *100;label NotCtzP="% persons not a citizen,Native Hawaiian|Other Pacific Islander alone";
if NatTPM       =0 then NotCtzM =0;if NatTPM       ^=0 then NotCtzM =NatNCM   /NatTPM         *100;label NotCtzM="% persons not a citizen,Two|More Races";
if NatTPH       =0 then NotCtzH =0;if NatTPH       ^=0 then NotCtzH =NatNCH   /NatTPH         *100;label NotCtzH="% persons not a citizen,Hispanic/Latino";
if MovePT       =0 then MoveT   =0;if MovePT       ^=0 then MoveT   =MoveNT   /MovePT         *100;label MoveT="% persons>=1yr moved in last 1yr,Total";
if MovePW       =0 then MoveW   =0;if MovePW       ^=0 then MoveW   =MoveNW   /MovePW         *100;label MoveW="% persons>=1yr moved in last 1yr,non-Hispanic/Latino White alone";
if MovePB       =0 then MoveB   =0;if MovePB       ^=0 then MoveB   =MoveNB   /MovePB         *100;label MoveB="% persons>=1yr moved in last 1yr,Black alone";
if MovePA       =0 then MoveA   =0;if MovePA       ^=0 then MoveA   =MoveNA   /MovePA         *100;label MoveA="% persons>=1yr moved in last 1yr,Asian alone";
if MovePN       =0 then MoveN   =0;if MovePN       ^=0 then MoveN   =MoveNN   /MovePN         *100;label MoveN="% persons>=1yr moved in last 1yr,American Indian|Alaska Native alone";
if MovePP       =0 then MoveP   =0;if MovePP       ^=0 then MoveP   =MoveNP   /MovePP         *100;label MoveP="% persons>=1yr moved in last 1yr,Native Hawaiian|Other Pacific Islander alone";
if MovePM       =0 then MoveM   =0;if MovePM       ^=0 then MoveM   =MoveNM   /MovePM         *100;label MoveM="% persons>=1yr moved in last 1yr,Two|More Races";
if MovePH       =0 then MoveH   =0;if MovePH       ^=0 then MoveH   =MoveNH   /MovePH         *100;label MoveH="% persons>=1yr moved in last 1yr,Hispanic/Latino";
if HUnitT       =0 then VacantT =0;if HUnitT       ^=0 then VacantT =VacantNT /HUnitT         *100;label VacantT="% vacant housing units,Total";
if OHUnitT      =0 then RenterT =0;if OHUnitT      ^=0 then RenterT =RentNT   /OHUnitT        *100;label RenterT="% renter occupied housing units,Total";
if OHUnitW      =0 then RenterW =0;if OHUnitW      ^=0 then RenterW =RentNW   /OHUnitW        *100;label RenterW="% renter occupied housing units,non-Hispanic/Latino White alone";
if OHUnitB      =0 then RenterB =0;if OHUnitB      ^=0 then RenterB =RentNB   /OHUnitB        *100;label RenterB="% renter occupied housing units,Black alone";
if OHUnitA      =0 then RenterA =0;if OHUnitA      ^=0 then RenterA =RentNA   /OHUnitA        *100;label RenterA="% renter occupied housing units,Asian alone";
if OHUnitN      =0 then RenterN =0;if OHUnitN      ^=0 then RenterN =RentNN   /OHUnitN        *100;label RenterN="% renter occupied housing units,American Indian|Alaska Native alone";
if OHUnitP      =0 then RenterP =0;if OHUnitP      ^=0 then RenterP =RentNP   /OHUnitP        *100;label RenterP="% renter occupied housing units,Native Hawaiian|Other Pacific Islander alone";
if OHUnitM      =0 then RenterM =0;if OHUnitM      ^=0 then RenterM =RentNM   /OHUnitM        *100;label RenterM="% renter occupied housing units,Two|More Races";
if OHUnitH      =0 then RenterH =0;if OHUnitH      ^=0 then RenterH =RentNH   /OHUnitH        *100;label RenterH="% renter occupied housing units,Hispanic/Latino";
if CrowdPT      =0 then CrowdT  =0;if CrowdPT      ^=0 then CrowdT  =CrowdNT  /CrowdPT        *100;label CrowdT="% occupied housing units w/ 1.01+ occupants per room,Total";
if CrowdPW      =0 then CrowdW  =0;if CrowdPW      ^=0 then CrowdW  =CrowdNW  /CrowdPW        *100;label CrowdW="% occupied housing units w/ 1.01+ occupants per room,non-Hispanic/Latino White alone";
if CrowdPB      =0 then CrowdB  =0;if CrowdPB      ^=0 then CrowdB  =CrowdNB  /CrowdPB        *100;label CrowdB="% occupied housing units w/ 1.01+ occupants per room,Black alone";
if CrowdPA      =0 then CrowdA  =0;if CrowdPA      ^=0 then CrowdA  =CrowdNA  /CrowdPA        *100;label CrowdA="% occupied housing units w/ 1.01+ occupants per room,Asian alone";
if CrowdPN      =0 then CrowdN  =0;if CrowdPN      ^=0 then CrowdN  =CrowdNN  /CrowdPN        *100;label CrowdN="% occupied housing units w/ 1.01+ occupants per room,American Indian|Alaska Native alone";
if CrowdPP      =0 then CrowdP  =0;if CrowdPP      ^=0 then CrowdP  =CrowdNP  /CrowdPP        *100;label CrowdP="% occupied housing units w/ 1.01+ occupants per room,Native Hawaiian|Other Pacific Islander alone";
if CrowdPM      =0 then CrowdM  =0;if CrowdPM      ^=0 then CrowdM  =CrowdNM  /CrowdPM        *100;label CrowdM="% occupied housing units w/ 1.01+ occupants per room,Two|More Races";
if CrowdPH      =0 then CrowdH  =0;if CrowdPH      ^=0 then CrowdH  =CrowdNH  /CrowdPH        *100;label CrowdH="% occupied housing units w/ 1.01+ occupants per room,Hispanic/Latino";
if MobPT        =0 then MobileT =0;if MobPT        ^=0 then MobileT =MobNT    /MobPT          *100;label MobileT="% mobile/boat/RV/van occupied housing units,Total";
if MobPW        =0 then MobileW =0;if MobPW        ^=0 then MobileW =MobNW    /MobPW          *100;label MobileW="% mobile/boat/RV/van occupied housing units,non-Hispanic/Latino White alone";
if MobPB        =0 then MobileB =0;if MobPB        ^=0 then MobileB =MobNB    /MobPB          *100;label MobileB="% mobile/boat/RV/van occupied housing units,Black alone";
if MobPA        =0 then MobileA =0;if MobPA        ^=0 then MobileA =MobNA    /MobPA          *100;label MobileA="% mobile/boat/RV/van occupied housing units,Asian alone";
if MobPN        =0 then MobileN =0;if MobPN        ^=0 then MobileN =MobNN    /MobPN          *100;label MobileN="% mobile/boat/RV/van occupied housing units,American Indian|Alaska Native alone";
if MobPP        =0 then MobileP =0;if MobPP        ^=0 then MobileP =MobNP    /MobPP          *100;label MobileP="% mobile/boat/RV/van occupied housing units,Native Hawaiian|Other Pacific Islander alone";
if MobPM        =0 then MobileM =0;if MobPM        ^=0 then MobileM =MobNM    /MobPM          *100;label MobileM="% mobile/boat/RV/van occupied housing units,Two|More Races";
if MobPH        =0 then MobileH =0;if MobPH        ^=0 then MobileH =MobNH    /MobPH          *100;label MobileH="% mobile/boat/RV/van occupied housing units,Hispanic/Latino";
if MrtgPT       =0 then MortgT  =0;if MrtgPT       ^=0 then MortgT  =MrtgNT   /MrtgPT         *100;label MortgT="% owner-occupied housing units w/ mortgage,Total";
if DisPT        =0 then DisablT =0;if DisPT        ^=0 then DisablT =DisNT    /DisPT          *100;label DisablT="% civilian noninstitutionalized persons w/ disability,Total";
if DisPW        =0 then DisablW =0;if DisPW        ^=0 then DisablW =DisNW    /DisPW          *100;label DisablW="% civilian noninstitutionalized persons w/ disability,non-Hispanic/Latino White alone";
if DisPB        =0 then DisablB =0;if DisPB        ^=0 then DisablB =DisNB    /DisPB          *100;label DisablB="% civilian noninstitutionalized persons w/ disability,Black alone";
if DisPA        =0 then DisablA =0;if DisPA        ^=0 then DisablA =DisNA    /DisPA          *100;label DisablA="% civilian noninstitutionalized persons w/ disability,Asian alone";
if DisPN        =0 then DisablN =0;if DisPN        ^=0 then DisablN =DisNN    /DisPN          *100;label DisablN="% civilian noninstitutionalized persons w/ disability,American Indian|Alaska Native alone";
if DisPP        =0 then DisablP =0;if DisPP        ^=0 then DisablP =DisNP    /DisPP          *100;label DisablP="% civilian noninstitutionalized persons w/ disability,Native Hawaiian|Other Pacific Islander alone";
if DisPM        =0 then DisablM =0;if DisPM        ^=0 then DisablM =DisNM    /DisPM          *100;label DisablM="% civilian noninstitutionalized persons w/ disability,Two|More Races";
if DisPH        =0 then DisablH =0;if DisPH        ^=0 then DisablH =DisNH    /DisPH          *100;label DisablH="% civilian noninstitutionalized persons w/ disability,Hispanic/Latino";
if DisPTC       =0 then DisablTC=0;if DisPTC       ^=0 then DisablTC=DisNTC   /DisPTC         *100;label DisablTC="% civilian noninstitutionalized persons aged <=17yr w/ disability,Total";
if DisPWC       =0 then DisablWC=0;if DisPWC       ^=0 then DisablWC=DisNWC   /DisPWC         *100;label DisablWC="% civilian noninstitutionalized persons aged <=17yr w/ disability,non-Hispanic/Latino White alone";
if DisPBC       =0 then DisablBC=0;if DisPBC       ^=0 then DisablBC=DisNBC   /DisPBC         *100;label DisablBC="% civilian noninstitutionalized persons aged <=17yr w/ disability,Black alone";
if DisPAC       =0 then DisablAC=0;if DisPAC       ^=0 then DisablAC=DisNAC   /DisPAC         *100;label DisablAC="% civilian noninstitutionalized persons aged <=17yr w/ disability,Asian alone";
if DisPNC       =0 then DisablNC=0;if DisPNC       ^=0 then DisablNC=DisNNC   /DisPNC         *100;label DisablNC="% civilian noninstitutionalized persons aged <=17yr w/ disability,American Indian|Alaska Native alone";
if DisPPC       =0 then DisablPC=0;if DisPPC       ^=0 then DisablPC=DisNPC   /DisPPC         *100;label DisablPC="% civilian noninstitutionalized persons aged <=17yr w/ disability,Native Hawaiian|Other Pacific Islander alone";
if DisPMC       =0 then DisablMC=0;if DisPMC       ^=0 then DisablMC=DisNMC   /DisPMC         *100;label DisablMC="% civilian noninstitutionalized persons aged <=17yr w/ disability,Two|More Races";
if DisPHC       =0 then DisablHC=0;if DisPHC       ^=0 then DisablHC=DisNHC   /DisPHC         *100;label DisablHC="% civilian noninstitutionalized persons aged <=17yr w/ disability,Hispanic/Latino";
if DisPTCM      =0 then DisablTM=0;if DisPTCM      ^=0 then DisablTM=DisNTCM  /DisPTCM        *100;label DisablTM="% civilian noninstitutionalized male persons aged <=17yr w/ disability,Total";
if DisPTCF      =0 then DisablTF=0;if DisPTCF      ^=0 then DisablTF=DisNTCF  /DisPTCF        *100;label DisablTF="% civilian noninstitutionalized female persons aged <=17yr w/ disability,Total";
if DisPTA       =0 then DisablTA=0;if DisPTA       ^=0 then DisablTA=DisNTA   /DisPTA         *100;label DisablTA="% civilian noninstitutionalized persons aged 18-64yr w/ disability,Total";
if DisPWA       =0 then DisablWA=0;if DisPWA       ^=0 then DisablWA=DisNWA   /DisPWA         *100;label DisablWA="% civilian noninstitutionalized persons aged 18-64yr w/ disability,non-Hispanic/Latino White alone";
if DisPBA       =0 then DisablBA=0;if DisPBA       ^=0 then DisablBA=DisNBA   /DisPBA         *100;label DisablBA="% civilian noninstitutionalized persons aged 18-64yr w/ disability,Black alone";
if DisPAA       =0 then DisablAA=0;if DisPAA       ^=0 then DisablAA=DisNAA   /DisPAA         *100;label DisablAA="% civilian noninstitutionalized persons aged 18-64yr w/ disability,Asian alone";
if DisPNA       =0 then DisablNA=0;if DisPNA       ^=0 then DisablNA=DisNNA   /DisPNA         *100;label DisablNA="% civilian noninstitutionalized persons aged 18-64yr w/ disability,American Indian|Alaska Native alone";
if DisPPA       =0 then DisablPA=0;if DisPPA       ^=0 then DisablPA=DisNPA   /DisPPA         *100;label DisablPA="% civilian noninstitutionalized persons aged 18-64yr w/ disability,Native Hawaiian|Other Pacific Islander alone";
if DisPMA       =0 then DisablMA=0;if DisPMA       ^=0 then DisablMA=DisNMA   /DisPMA         *100;label DisablMA="% civilian noninstitutionalized persons aged 18-64yr w/ disability,Two|More Races";
if DisPHA       =0 then DisablHA=0;if DisPHA       ^=0 then DisablHA=DisNHA   /DisPHA         *100;label DisablHA="% civilian noninstitutionalized persons aged 18-64yr w/ disability,Hispanic/Latino";
if UrbanP       =0 then Urban2  =0;if UrbanP       ^=0 then Urban2  =Urban2N  /UrbanP         *100;label Urban2="% persons in urbanized area(>=50,000 population) or urban cluster(2,500-49,999 population)";
if UrbanP       =0 then Urban1  =0;if UrbanP       ^=0 then Urban1  =Urban1N  /UrbanP         *100;label Urban1="% persons in urbanized area(>=50,000 population)";
if HInsurT_d    =0 then HInsurT  =0;if HInsurT_d  ^=0 then HInsurT  =HInsurT_n  /HInsurT_d  *100;label HInsurT="% no health insurance,Total";
if HInsurTM_d   =0 then HInsurTM =0;if HInsurTM_d ^=0 then HInsurTM =HInsurTM_n /HInsurTM_d *100;label HInsurTM="% no health insurance,Total Male";
if HInsurTF_d   =0 then HInsurTF =0;if HInsurTF_d ^=0 then HInsurTF =HInsurTF_n /HInsurTF_d *100;label HInsurTF="% no health insurance,Total Female";
if HInsurTA_d   =0 then HInsurTA =0;if HInsurTA_d ^=0 then HInsurTA =HInsurTA_n /HInsurTA_d *100;label HInsurTA="% no health insurance,Total Adult(18-64yr for 2012-2016;19-64yr for 2017-2018)";
if HInsurTAM_d  =0 then HInsurTAM=0;if HInsurTAM_d^=0 then HInsurTAM=HInsurTAM_n/HInsurTAM_d*100;label HInsurTAM="% no health insurance,Total Male Adult(18-64yr for 2012-2016;19-64yr for 2017-2018)";
if HInsurTAF_d  =0 then HInsurTAF=0;if HInsurTAF_d^=0 then HInsurTAF=HInsurTAF_n/HInsurTAF_d*100;label HInsurTAF="% no health insurance,Total Female Adult(18-64yr for 2012-2016;19-64yr for 2017-2018)";
if HInsurTC_d   =0 then HInsurTC =0;if HInsurTC_d ^=0 then HInsurTC =HInsurTC_n /HInsurTC_d *100;label HInsurTC="% no health insurance,Total Child(0-17yr for 2012-2016;0-18yr for 2017-2018)";
if HInsurTCM_d  =0 then HInsurTCM=0;if HInsurTCM_d^=0 then HInsurTCM=HInsurTCM_n/HInsurTCM_d*100;label HInsurTCM="% no health insurance,Total Male Child(0-17yr for 2012-2016;0-18yr for 2017-2018)";
if HInsurTCF_d  =0 then HInsurTCF=0;if HInsurTCF_d^=0 then HInsurTCF=HInsurTCF_n/HInsurTCF_d*100;label HInsurTCF="% no health insurance,Total Female Child(0-17yr for 2012-2016;0-18yr for 2017-2018)";
if HInsurW_d    =0 then HInsurW  =0;if HInsurW_d  ^=0 then HInsurW  =HInsurW_n  /HInsurW_d  *100;label HInsurW="% no health insurance,non-Hispanic/Latino White alone";
if HInsurWA_d   =0 then HInsurWA =0;if HInsurWA_d ^=0 then HInsurWA =HInsurWA_n /HInsurWA_d *100;label HInsurWA="% no health insurance,non-Hispanic/Latino White alone Adult(18-64yr for 2012-2016;19-64yr for 2017-2018)";
if HInsurWC_d   =0 then HInsurWC =0;if HInsurWC_d ^=0 then HInsurWC =HInsurWC_n /HInsurWC_d *100;label HInsurWC="% no health insurance,non-Hispanic/Latino White alone Child(0-17yr for 2012-2016;0-18yr for 2017-2018)";
if HInsurB_d    =0 then HInsurB  =0;if HInsurB_d  ^=0 then HInsurB  =HInsurB_n  /HInsurB_d  *100;label HInsurB="% no health insurance,Black alone";
if HInsurBA_d   =0 then HInsurBA =0;if HInsurBA_d ^=0 then HInsurBA =HInsurBA_n /HInsurBA_d *100;label HInsurBA="% no health insurance,Black alone Adult(18-64yr for 2012-2016;19-64yr for 2017-2018)";
if HInsurBC_d   =0 then HInsurBC =0;if HInsurBC_d ^=0 then HInsurBC =HInsurBC_n /HInsurBC_d *100;label HInsurBC="% no health insurance,Black alone Child(0-17yr for 2012-2016;0-18yr for 2017-2018)";
if HInsurA_d    =0 then HInsurA  =0;if HInsurA_d  ^=0 then HInsurA  =HInsurA_n  /HInsurA_d  *100;label HInsurA="% no health insurance,Asian alone";
if HInsurAA_d   =0 then HInsurAA =0;if HInsurAA_d ^=0 then HInsurAA =HInsurAA_n /HInsurAA_d *100;label HInsurAA="% no health insurance,Asian alone Adult(18-64yr for 2012-2016;19-64yr for 2017-2018)";
if HInsurAC_d   =0 then HInsurAC =0;if HInsurAC_d ^=0 then HInsurAC =HInsurAC_n /HInsurAC_d *100;label HInsurAC="% no health insurance,Asian alone Child(0-17yr for 2012-2016;0-18yr for 2017-2018)";
if HInsurN_d    =0 then HInsurN  =0;if HInsurN_d  ^=0 then HInsurN  =HInsurN_n  /HInsurN_d  *100;label HInsurN="% no health insurance,American Indian|Alaska Native Alone";
if HInsurNA_d   =0 then HInsurNA =0;if HInsurNA_d ^=0 then HInsurNA =HInsurNA_n /HInsurNA_d *100;label HInsurNA="% no health insurance,American Indian|Alaska Native Alone Adult(18-64yr for 2012-2016;19-64yr for 2017-2018)";
if HInsurNC_d   =0 then HInsurNC =0;if HInsurNC_d ^=0 then HInsurNC =HInsurNC_n /HInsurNC_d *100;label HInsurNC="% no health insurance,American Indian|Alaska Native Alone Child(0-17yr for 2012-2016;0-18yr for 2017-2018)";
if HInsurP_d    =0 then HInsurP  =0;if HInsurP_d  ^=0 then HInsurP  =HInsurP_n  /HInsurP_d  *100;label HInsurP="% no health insurance,Native Hawaiian|Other Pacific Islander alone";
if HInsurPA_d   =0 then HInsurPA =0;if HInsurPA_d ^=0 then HInsurPA =HInsurPA_n /HInsurPA_d *100;label HInsurPA="% no health insurance,Native Hawaiian|Other Pacific Islander alone Adult(18-64yr for 2012-2016;19-64yr for 2017-2018)";
if HInsurPC_d   =0 then HInsurPC =0;if HInsurPC_d ^=0 then HInsurPC =HInsurPC_n /HInsurPC_d *100;label HInsurPC="% no health insurance,Native Hawaiian|Other Pacific Islander alone Child(0-17yr for 2012-2016;0-18yr for 2017-2018)";
if HInsurM_d    =0 then HInsurM  =0;if HInsurM_d  ^=0 then HInsurM  =HInsurM_n  /HInsurM_d  *100;label HInsurM="% no health insurance,Two|More Races";
if HInsurMA_d   =0 then HInsurMA =0;if HInsurMA_d ^=0 then HInsurMA =HInsurMA_n /HInsurMA_d *100;label HInsurMA="% no health insurance,Two|More Races Adult(18-64yr for 2012-2016;19-64yr for 2017-2018)";
if HInsurMC_d   =0 then HInsurMC =0;if HInsurMC_d ^=0 then HInsurMC =HInsurMC_n /HInsurMC_d *100;label HInsurMC="% no health insurance,Two|More Races Child(0-17yr for 2012-2016;0-18yr for 2017-2018)";
if HInsurH_d    =0 then HInsurH  =0;if HInsurH_d  ^=0 then HInsurH  =HInsurH_n  /HInsurH_d  *100;label HInsurH="% no health insurance,Hispanic/Latino";
if HInsurHA_d   =0 then HInsurHA =0;if HInsurHA_d ^=0 then HInsurHA =HInsurHA_n /HInsurHA_d *100;label HInsurHA="% no health insurance,Hispanic/Latino Adult(18-64yr for 2012-2016;19-64yr for 2017-2018)";
if HInsurHC_d   =0 then HInsurHC =0;if HInsurHC_d ^=0 then HInsurHC =HInsurHC_n /HInsurHC_d *100;label HInsurHC="% no health insurance,Hispanic/Latino Child(0-17yr for 2012-2016;0-18yr for 2017-2018)";
/* When aggregating counties suppressed in CAN data, for example, if IncomeTd/RPovPT < 0.8 (i.e., coverage < 80%), then IncomeT would be missing */
if IncomeTd /RPovPT         <0.8 then IncomeT =.;
if IncomeWd /RPovPW         <0.8 then IncomeW =.;
if IncomeBd /RPovPB         <0.8 then IncomeB =.;/*125 missing*/
if IncomeAd /RPovPA         <0.8 then IncomeA =.;/*211 missing*/
if IncomeNd /RPovPN         <0.8 then IncomeN =.;/*522 missing*/
if IncomePd /RPovPP         <0.8 then IncomeP =.;/*3812 missing*/
if IncomeMd /RPovPM         <0.8 then IncomeM =.;/*80 missing*/
if IncomeHd /RPovPH         <0.8 then IncomeH =.;/*30 missing*/
if GiniTd   /RPovPT         <0.8 then GiniT   =.;
if HValueTd /OwnNT          <0.8 then HValueT =.;
if MCostTd  /OHUnitT        <0.8 then MCostT  =.;
if OCostDTd /OwnNT          <0.8 then OCostDT =.;
if OCostMDTd/MrtgNT         <0.8 then OCostMDT=.;
if OCostNDTd/(MrtgPT-MrtgNT)<0.8 then OCostNDT=.;
if OCostPTd /OwnNT          <0.8 then OCostPT =.;
if OCostMPTd/MrtgNT         <0.8 then OCostMPT=.;
if OCostNPTd/(MrtgPT-MrtgNT)<0.8 then OCostNPT=.;
if MRentDTd /RentNT         <0.8 then MRentDT =.;
if MRentPTd /RentNT         <0.8 then MRentPT =.;
if UrbanPd  /PopT           <0.8 then Urban1  =.;
if UrbanPd  /PopT           <0.8 then Urban2  =.;
drop
_TYPE_ _FREQ_ CountyFlag
IncomeTw IncomeWw IncomeBw IncomeAw IncomeNw IncomePw IncomeMw IncomeHw GiniTw HValueTw MCostTw OCostDTw OCostMDTw OCostNDTw OCostPTw OCostMPTw OCostNPTw MRentDTw MRentPTw
IncomeTd IncomeWd IncomeBd IncomeAd IncomeNd IncomePd IncomeMd IncomeHd GiniTd HValueTd MCostTd OCostDTd OCostMDTd OCostNDTd OCostPTd OCostMPTd OCostNPTd MRentDTd MRentPTd;
run;
/*N=6410; 731 variables*/
/***/
/* Merging with CountyYrKey -- Inner join to exclude Census data county-years that are missing in CAN data */;
proc sort data=census4;by CountyYear;run;
data census5;merge census4(IN=A) CountyYrKey(IN=B);by CountyYear;if (A=B);drop CountyYrFlag;run; 
/*N=6153; 731 variables*/
/***/
/* Sorting columns */;
data census6;retain
CensusFlag CntyYear Density Land PopT PopW PopB PopA PopN PopP PopM PopH PopWP PopBP PopAP PopNP PopPP PopMP PopHP PopTM PopWM PopBM PopAM PopNM PopPM PopMM PopHM PopTF PopWF
PopBF PopAF PopNF PopPF PopMF PopHF CPopT CPopW CPopB CPopA CPopN CPopP CPopM CPopH CPopWP CPopBP CPopAP CPopNP CPopPP CPopMP CPopHP CPopTM CPopWM CPopBM CPopAM CPopNM CPopPM
CPopMM CPopHM CPopTF CPopWF CPopBF CPopAF CPopNF CPopPF CPopMF CPopHF CPop1 CPop2 CPop3 CPop14T CPop14W CPop14B CPop14A CPop14N CPop14P CPop14M CPop14H APopT APopW APopB APopA
APopN APopP APopM APopH ChildPT ChildPW ChildPB ChildPA ChildPN ChildPP ChildPM ChildPH CARatioT CARatioW CARatioB CARatioA CARatioN CARatioP CARatioM CARatioH MaleT MaleW MaleB
MaleA MaleN MaleP MaleM MaleH FemaleT FemaleW FemaleB FemaleA FemaleN FemaleP FemaleM FemaleH MalePT MalePW MalePB MalePA MalePN MalePP MalePM MalePH MFRatioT MFRatioW MFRatioB
MFRatioA MFRatioN MFRatioP MFRatioM MFRatioH EldPopT EldPopW EldPopB EldPopA EldPopN EldPopP EldPopM EldPopH ElderT ElderW ElderB ElderA ElderN ElderP ElderM ElderH FamHHT
FamHHW FamHHB FamHHA FamHHN FamHHP FamHHM FamHHH SingleNT SingleNW SingleNB SingleNA SingleNN SingleNP SingleNM SingleNH SingleT SingleW SingleB SingleA SingleN SingleP SingleM
SingleH FHeadNT FHeadNW FHeadNB FHeadNA FHeadNN FHeadNP FHeadNM FHeadNH FHeadT FHeadW FHeadB FHeadA FHeadN FHeadP FHeadM FHeadH HSnoPT HSnoPW HSnoPB HSnoPA HSnoPN HSnoPP HSnoPM
HSnoPH HSnoNT HSnoNW HSnoNB HSnoNA HSnoNN HSnoNP HSnoNM HSnoNH NoHighT NoHighW NoHighB NoHighA NoHighN NoHighP NoHighM NoHighH LaborT LaborW LaborB LaborA LaborN LaborP LaborM
LaborH UnempNT UnempNW UnempNB UnempNA UnempNN UnempNP UnempNM UnempNH UnempT UnempW UnempB UnempA UnempN UnempP UnempM UnempH PovPT PovPW PovPB PovPA PovPN PovPP PovPM PovPH
PovNT PovNW PovNB PovNA PovNN PovNP PovNM PovNH PovT PovW PovB PovA PovN PovP PovM PovH CPovPT CPovNT CPovPW CPovPB CPovPA CPovPN CPovPP CPovPM CPovPH CPovNW CPovNB CPovNA
CPovNN CPovNP CPovNM CPovNH CPovT CPovW CPovB CPovA CPovN CPovP CPovM CPovH P00PT P50NT P150NT Pov50T Pov150T CPovP1 CPovP2 CPovP3 CPovN1 CPovN2 CPovN3 CPov1 CPov2 CPov3 CP00PT
CP50NT CP100NT CP125NT CP150NT CP175NT CP185NT CP200NT CPov50T CPov100T CPov125T CPov150T CPov175T CPov185T CPov200T CP00P1 CP00P2 CP00P3 CP50N1 CP50N2 CP50N3 CP100N1 CP100N2
CP100N3 CP125N1 CP125N2 CP125N3 CP150N1 CP150N2 CP150N3 CP175N1 CP175N2 CP175N3 CP185N1 CP185N2 CP185N3 CP200N1 CP200N2 CP200N3 CPov501 CPov502 CPov503 CPov1001 CPov1002
CPov1003 CPov1251 CPov1252 CPov1253 CPov1501 CPov1502 CPov1503 CPov1751 CPov1752 CPov1753 CPov1851 CPov1852 CPov1853 CPov2001 CPov2002 CPov2003 RPovPT RPovPW RPovPB RPovPA
RPovPN RPovPP RPovPM RPovPH RPovNT RPovNW RPovNB RPovNA RPovNN RPovNP RPovNM RPovNH RPovT RPovW RPovB RPovA RPovN RPovP RPovM RPovH PubAsPT PubAsNT PubAsT WelfarPT WelfarNT
WelfarT SnapPT SnapPW SnapPB SnapPA SnapPN SnapPP SnapPM SnapPH SnapNT SnapNW SnapNB SnapNA SnapNN SnapNP SnapNM SnapNH SnapT SnapW SnapB SnapA SnapN SnapP SnapM SnapH IncomeT
IncomeW IncomeB IncomeA IncomeN IncomeP IncomeM IncomeH GiniT HValueT MCostT OCostDT OCostMDT OCostNDT OCostPT OCostMPT OCostNPT MRentDT MRentPT MrtgPT MrtgNT MortgT LangPT
LangPW LangPB LangPA LangPN LangPP LangPM LangPH LangANT LangANW LangANB LangANA LangANN LangANP LangANM LangANH LangBNT LangBNW LangBNB LangBNA LangBNN LangBNP LangBNM LangBNH
LangCNT LangAPT LangAPW LangAPB LangAPA LangAPN LangAPP LangAPM LangAPH LangBPT LangBPW LangBPB LangBPA LangBPN LangBPP LangBPM LangBPH LangCPT NatTPT NatTPW NatTPB NatTPA
NatTPN NatTPP NatTPM NatTPH NatOST NatOSW NatOSB NatOSA NatOSN NatOSP NatOSM NatOSH NatFBT NatFBW NatFBB NatFBA NatFBN NatFBP NatFBM NatFBH NatNCT NatNCW NatNCB NatNCA NatNCN
NatNCP NatNCM NatNCH OutUsT OutUsW OutUsB OutUsA OutUsN OutUsP OutUsM OutUsH FBornT FBornW FBornB FBornA FBornN FBornP FBornM FBornH NotCtzT NotCtzW NotCtzB NotCtzA NotCtzN
NotCtzP NotCtzM NotCtzH MovePT MovePW MovePB MovePA MovePN MovePP MovePM MovePH MoveNT MoveNW MoveNB MoveNA MoveNN MoveNP MoveNM MoveNH MoveT MoveW MoveB MoveA MoveN MoveP MoveM
MoveH HUnitT VacantNT VacantT OHUnitT OHUnitW OHUnitB OHUnitA OHUnitN OHUnitP OHUnitM OHUnitH OwnNT OwnNW OwnNB OwnNA OwnNN OwnNP OwnNM OwnNH RentNT RentNW RentNB RentNA RentNN
RentNP RentNM RentNH RenterT RenterW RenterB RenterA RenterN RenterP RenterM RenterH CrowdPT CrowdPW CrowdPB CrowdPA CrowdPN CrowdPP CrowdPM CrowdPH CrowdNT CrowdNW CrowdNB
CrowdNA CrowdNN CrowdNP CrowdNM CrowdNH CrowdT CrowdW CrowdB CrowdA CrowdN CrowdP CrowdM CrowdH MobPT MobPW MobPB MobPA MobPN MobPP MobPM MobPH MobNT MobNW MobNB MobNA MobNN
MobNP  MobNM MobNH MobileT MobileW MobileB MobileA MobileN MobileP MobileM MobileH DisPT DisPW DisPB DisPA DisPN DisPP DisPM DisPH DisNT DisNW DisNB DisNA DisNN DisNP DisNM
DisNH DisPTC DisPTCM DisPTCF DisPWC DisPBC DisPAC DisPNC DisPPC DisPMC DisPHC DisNTC DisNTCM DisNTCF DisNWC DisNBC DisNAC DisNNC DisNPC DisNMC DisNHC DisPTA DisPWA DisPBA DisPAA
DisPNA DisPPA DisPMA DisPHA DisNTA DisNWA DisNBA DisNAA DisNNA DisNPA DisNMA DisNHA DisablT DisablW DisablB DisablA DisablN DisablP DisablM DisablH DisablTC DisablWC DisablBC
DisablAC DisablNC DisablPC DisablMC DisablHC DisablTM DisablTF DisablTA DisablWA DisablBA DisablAA DisablNA DisablPA DisablMA DisablHA HInsurT_d HInsurTM_d HInsurTF_d HInsurTA_d
HInsurTAM_d HInsurTAF_d HInsurTC_d HInsurTCM_d HInsurTCF_d HInsurW_d HInsurWA_d HInsurWC_d HInsurB_d HInsurBA_d HInsurBC_d HInsurA_d HInsurAA_d HInsurAC_d HInsurN_d HInsurNA_d
HInsurNC_d HInsurP_d HInsurPA_d HInsurPC_d HInsurM_d HInsurMA_d HInsurMC_d HInsurH_d HInsurHA_d HInsurHC_d HInsurT_n HInsurTM_n HInsurTF_n HInsurTA_n HInsurTAM_n HInsurTAF_n 
HInsurTC_n HInsurTCM_n HInsurTCF_n HInsurW_n HInsurWA_n HInsurWC_n HInsurB_n HInsurBA_n HInsurBC_n HInsurA_n HInsurAA_n HInsurAC_n HInsurN_n HInsurNA_n HInsurNC_n HInsurP_n 
HInsurPA_n HInsurPC_n HInsurM_n HInsurMA_n HInsurMC_n HInsurH_n HInsurHA_n HInsurHC_n HInsurT HInsurTM HInsurTF HInsurTA HInsurTAM HInsurTAF HInsurTC HInsurTCM HInsurTCF HInsurW
HInsurWA HInsurWC HInsurB HInsurBA HInsurBC HInsurA HInsurAA HInsurAC HInsurN HInsurNA HInsurNC HInsurP HInsurPA HInsurPC HInsurM HInsurMA HInsurMC HInsurH HInsurHA HInsurHC 
UrbanP Urban1N Urban2N Urban1 Urban2;
set census5;CensusFlag=1;run;
/*N=6153; 822 variables*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* A01: Merging CAN data and Census data & Computing CAN rates *********************************************************************************/
/********************************* A01: Merging CAN data and Census data & Computing CAN rates *********************************************************************************/
/********************************* A01: Merging CAN data and Census data & Computing CAN rates *********************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/***/;
proc sort data=CAN    ;by CountyYear;run; /*N=6153,  27 variables*/
proc sort data=census6;by CountyYear;run; /*N=6153; 732 variables*/
data A01;merge CAN census6;by CountyYear;
if CPopT =0 then RptTr=0;if CPopT ^=0 then RptTr=RptT/CPopT *1000;label RptTr="CAN report rate per 1k children,Total";
if CPopW =0 then RptWr=0;if CPopW ^=0 then RptWr=RptW/CPopW *1000;label RptWr="CAN report rate per 1k children,non-Hispanic/Latino White alone";
if CPopB =0 then RptBr=0;if CPopB ^=0 then RptBr=RptB/CPopB *1000;label RptBr="CAN report rate per 1k children,Black alone";
if CPopA =0 then RptAr=0;if CPopA ^=0 then RptAr=RptA/CPopA *1000;label RptAr="CAN report rate per 1k children,Asian alone";
if CPopN =0 then RptIr=0;if CPopN ^=0 then RptIr=RptI/CPopN *1000;label RptIr="CAN report rate per 1k children,American Indian/Alaska Native alone";
if CPopP =0 then RptPr=0;if CPopP ^=0 then RptPr=RptP/CPopP *1000;label RptPr="CAN report rate per 1k children,Native Hawaiian/Other Pacific Islander alone";
if CPopM =0 then RptUr=0;if CPopM ^=0 then RptUr=RptU/CPopM *1000;label RptUr="CAN report rate per 1k children,Two or more races";
if CPopH =0 then RptHr=0;if CPopH ^=0 then RptHr=RptH/CPopH *1000;label RptHr="CAN report rate per 1k children,Hispanic/Latino";
if CPopTM=0 then RptMr=0;if CPopTM^=0 then RptMr=RptM/CPopTM*1000;label RptMr="CAN report rate per 1k male children";
if CPopTF=0 then RptFr=0;if CPopTF^=0 then RptFr=RptF/CPopTF*1000;label RptFr="CAN report rate per 1k female children";
if CPop1 =0 then Rpt1r=0;if CPop1 ^=0 then Rpt1r=Rpt1/CPop1 *1000;label Rpt1r="CAN report rate per 1k children aged 0-5 years";
if CPop2 =0 then Rpt2r=0;if CPop2 ^=0 then Rpt2r=Rpt2/CPop2 *1000;label Rpt2r="CAN report rate per 1k children aged 6-11 years";
if CPop3 =0 then Rpt3r=0;if CPop3 ^=0 then Rpt3r=Rpt3/CPop3 *1000;label Rpt3r="CAN report rate per 1k children aged 12-17 years";
if CPopT =0 then NegTr=0;if CPopT ^=0 then NegTr=NegT/CPopT *1000;label NegTr="Neglect report rate per 1k children";
if CPopT =0 then PhyTr=0;if CPopT ^=0 then PhyTr=PhyT/CPopT *1000;label PhyTr="Physical abuse report rate per 1k children";
if CPopT =0 then SexTr=0;if CPopT ^=0 then SexTr=SexT/CPopT *1000;label SexTr="Sexual abuse report rate per 1k children";
if CPopT =0 then EmoTr=0;if CPopT ^=0 then EmoTr=EmoT/CPopT *1000;label EmoTr="Emotional abuse report rate per 1k children";
if CPopT =0 then VicTr=0;if CPopT ^=0 then VicTr=VicT/CPopT *1000;label VicTr="Substantiated CAN report rate per 1k children";
if CPopT =0 then RprTr=0;if CPopT ^=0 then RprTr=RprT/CPopT *1000;label RprTr="Professional-source CAN report rate per 1k children";
if CPopT =0 then RnpTr=0;if CPopT ^=0 then RnpTr=RnpT/CPopT *1000;label RnpTr="Nonprofessional-source CAN report rate per 1k children";
run;
/*N=6153; 778 variables*/
/* Sorting Columns */;
data A01;
retain StateFIPS CountyFIPS Year StateYear CountyYear CANFlag RptT RptW RptB RptA RptI RptP RptU RptH RptM RptF Rpt1 Rpt2 Rpt3 NegT PhyT SexT EmoT VicT RprT RnpT RptTr RptWr
RptBr RptAr RptIr RptPr RptUr RptHr RptMr RptFr Rpt1r Rpt2r Rpt3r NegTr PhyTr SexTr EmoTr VicTr RprTr RnpTr;
set A01;run;
/*N=6153; 778 variables*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Birth data **********************************************************************************************************************************/
/********************************* Birth data **********************************************************************************************************************************/
/********************************* Birth data **********************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/***/
/* Importing Birth Data; Selecting data in study years (2009-2018) */;
data BIR1;set c.Birth;if 2008<Year<2019;run; 
/*N=6280, 123 variables*/
/***/
/* Creating BIRKey to aggregate female teen(15-19yr) population from Census data for counties unidentified in Birth data (w/ a total population < 100k) */;
data BIRKey;set BIR1;BIRKey=1;keep CountyYear BIRKey;run; 
/*N=6280, 2 variables*/
/***/
/* Importing female teen(15-19yr) population from Census data */;
data Teen1;set b.census(rename=(CntyYear=CountyYear));keep Year CountyYear TeenBPT TeenBPW TeenBPB TeenBPA TeenBPN TeenBPP TeenBPM TeenBPH;run; 
/*N=32205, 10 variables*/
/***/
/* Merging female teen(15-19yr) population data and BIRKey */;
proc sort data=BIRKey;by CountyYear;run;                    /*N= 6280,  2 variables*/
proc sort data=Teen1 ;by CountyYear;run;                    /*N=32205, 10 variables*/
data Teen2;merge Teen1(IN=A) BIRKey;by CountyYear;if A;run; /*N=32205, 11 variables*/
/***/
/* Aggregating female teen(15-19yr) population data for counties unidentified in Birth data (w/ a total population < 100k) */;
data Teen3;set Teen2;if BIRKey=. then CountyYear=INT(CountyYear/10000000)*10000000+9990000+Year;drop Year BIRKey;run; 
/*N=32205, 9 variables */;
proc summary data=Teen3 nway;class CountyYear;var _all_;output out=Teen4 sum=;run; 
/*N=6290, 11 variables*/
/***/
/* Merging Birth data and female teen(15-19yr) population data - Left join to exclude 10 Puerto Rico county-years (72999XXXX) in female teen population data */;
proc sort data=BIR1 ;by CountyYear;run;                                     /*N=6280, 123 variables*/
proc sort data=Teen4;by CountyYear;run;                                     /*N=6290 -- 10 Puerto Rico county-years, 11 variables */
data BIR2;merge BIR1(IN=A) Teen4;by CountyYear;if A;drop _TYPE_ _FREQ_;run; /*N=6280, 131 variables*/
/***/
/* Aggregating counties that are suppressed in CAN data -- converting CountyYear of Birth data into SS999YYYY for counties suppressed in CAN data */
proc sort data=BIR2;by CountyFIPS;run;                                                             /*N=6280, 131 variables*/
data BIR3;merge BIR2(IN=A) CountyKey;by CountyFIPS;if A;run;                                       /*N=6280, 132 variables*/
data BIR4;set BIR3;if CountyFlag=. then CountyYear=INT(CountyFIPS/1000)*10000000+9990000+Year;run; /*N=6280, 132 variables*/
/***/
/* While counties with total population > 100k are identified in Birth data (i.e., not in XX999), birth counts < 10 are suppressed (i.e., missing) for confidentiality.
   THREE RULES for aggregating counties suppressed in CAN data:
     (1) If a county identified in Birth data but with a suppressed birth count for either numerator (eg., # LBW births) or denominator (eg, # births) is identified in CAN data,
         the birth variable (eg, LBW rate) would be missing for the county.
     (2) If a county identified in Birth data but with a suppressed birth count for either numerator or denominator is suppressed in CAN data,
         the county would be aggregated into a combined county (XX999) while making both numerator and denomiantor of the county zero.
     (3) Many counties have a suppressed numerator (eg, # LBW births) but an unsuppressed denominator (eg, # births) as numerator < denominator.
         When the sum of denominators of counties with suppressed numerators is over 20% of the sum of denominators of all counties within the combined county,
         then, the birth variable (eg, LBW rate) of the combined county would be missing.
   These rules are achived by the following STEPS:
     (1) Creating denominator1 that replaces a missing denominator with zero
     (2) Creating denominator2 that replaces a missing denominator with zero and further replaces a denominator with zero when a numerator is missing
     (3) Creating numerator1 that replaces a missing numerator with zero
     (4) Aggregating counties suppressed in CAN data (i.e., summing numerators and denominators)
     (5) Caculating birth variables (eg, LBW rate) by "numerator1/denominator2"
         For identified counties in CAN, birth variables will be missing for counties with an missing original numerator since denominator2 is zero for those counties.
         For suppressed counties in CAN, birth variables will be calculated based on counties with valid numerators and denominators.
     (6) Making birth variables missing for counties with "denominator2/denominator1" < 0.8 -- this is for RULE (3). */
/***/
/***** STEP (1) through (3) *****/;
data BIR5;set BIR4;
/******** STEP (1) ********/
if BIRT1  =. then BIRT1  =0;
if BIRM1  =. then BIRM1  =0;
if BIRF1  =. then BIRF1  =0;
if BIRW1  =. then BIRW1  =0;
if BIRB1  =. then BIRB1  =0;
if BIRA1  =. then BIRA1  =0;
if BIRN1  =. then BIRN1  =0;
if BIRP1  =. then BIRP1  =0;
if BIRO1  =. then BIRO1  =0;
if BIRH1  =. then BIRH1  =0;
if BIRT5  =. then BIRT5  =0;
if BIRM5  =. then BIRM5  =0;
if BIRF5  =. then BIRF5  =0;
if BIRW5  =. then BIRW5  =0;
if BIRB5  =. then BIRB5  =0;
if BIRA5  =. then BIRA5  =0;
if BIRN5  =. then BIRN5  =0;
if BIRP5  =. then BIRP5  =0;
if BIRO5  =. then BIRO5  =0;
if BIRH5  =. then BIRH5  =0;
if TeenBPT=. then TeenBPT=0;
if TeenBPW=. then TeenBPW=0;
if TeenBPB=. then TeenBPB=0;
if TeenBPA=. then TeenBPA=0;
if TeenBPN=. then TeenBPN=0;
if TeenBPP=. then TeenBPP=0;
if TeenBPM=. then TeenBPM=0;
if TeenBPH=. then TeenBPH=0;
/************** STEP (2) **************/    /****** STEP (3) ******/
LBWT1d=BIRT1  ;if LBWT1=. then LBWT1d=0;    if LBWT1=. then LBWT1=0;
LBWM1d=BIRM1  ;if LBWM1=. then LBWM1d=0;    if LBWM1=. then LBWM1=0;
LBWF1d=BIRF1  ;if LBWF1=. then LBWF1d=0;    if LBWF1=. then LBWF1=0;
LBWW1d=BIRW1  ;if LBWW1=. then LBWW1d=0;    if LBWW1=. then LBWW1=0;
LBWB1d=BIRB1  ;if LBWB1=. then LBWB1d=0;    if LBWB1=. then LBWB1=0;
LBWA1d=BIRA1  ;if LBWA1=. then LBWA1d=0;    if LBWA1=. then LBWA1=0;
LBWN1d=BIRN1  ;if LBWN1=. then LBWN1d=0;    if LBWN1=. then LBWN1=0;
LBWP1d=BIRP1  ;if LBWP1=. then LBWP1d=0;    if LBWP1=. then LBWP1=0;
LBWO1d=BIRO1  ;if LBWO1=. then LBWO1d=0;    if LBWO1=. then LBWO1=0;
LBWH1d=BIRH1  ;if LBWH1=. then LBWH1d=0;    if LBWH1=. then LBWH1=0;
PTBT1d=BIRT1  ;if PTBT1=. then PTBT1d=0;    if PTBT1=. then PTBT1=0;
PTBM1d=BIRM1  ;if PTBM1=. then PTBM1d=0;    if PTBM1=. then PTBM1=0;
PTBF1d=BIRF1  ;if PTBF1=. then PTBF1d=0;    if PTBF1=. then PTBF1=0;
PTBW1d=BIRW1  ;if PTBW1=. then PTBW1d=0;    if PTBW1=. then PTBW1=0;
PTBB1d=BIRB1  ;if PTBB1=. then PTBB1d=0;    if PTBB1=. then PTBB1=0;
PTBA1d=BIRA1  ;if PTBA1=. then PTBA1d=0;    if PTBA1=. then PTBA1=0;
PTBN1d=BIRN1  ;if PTBN1=. then PTBN1d=0;    if PTBN1=. then PTBN1=0;
PTBP1d=BIRP1  ;if PTBP1=. then PTBP1d=0;    if PTBP1=. then PTBP1=0;
PTBO1d=BIRO1  ;if PTBO1=. then PTBO1d=0;    if PTBO1=. then PTBO1=0;
PTBH1d=BIRH1  ;if PTBH1=. then PTBH1d=0;    if PTBH1=. then PTBH1=0;
PNCT1d=BIRT1  ;if PNCT1=. then PNCT1d=0;    if PNCT1=. then PNCT1=0;
PNCM1d=BIRM1  ;if PNCM1=. then PNCM1d=0;    if PNCM1=. then PNCM1=0;
PNCF1d=BIRF1  ;if PNCF1=. then PNCF1d=0;    if PNCF1=. then PNCF1=0;
PNCW1d=BIRW1  ;if PNCW1=. then PNCW1d=0;    if PNCW1=. then PNCW1=0;
PNCB1d=BIRB1  ;if PNCB1=. then PNCB1d=0;    if PNCB1=. then PNCB1=0;
PNCA1d=BIRA1  ;if PNCA1=. then PNCA1d=0;    if PNCA1=. then PNCA1=0;
PNCN1d=BIRN1  ;if PNCN1=. then PNCN1d=0;    if PNCN1=. then PNCN1=0;
PNCP1d=BIRP1  ;if PNCP1=. then PNCP1d=0;    if PNCP1=. then PNCP1=0;
PNCO1d=BIRO1  ;if PNCO1=. then PNCO1d=0;    if PNCO1=. then PNCO1=0;
PNCH1d=BIRH1  ;if PNCH1=. then PNCH1d=0;    if PNCH1=. then PNCH1=0;
TBBT1d=BIRT1  ;if TBBT1=. then TBBT1d=0;    if TBBT1=. then TBBT1=0;
TBBM1d=BIRM1  ;if TBBM1=. then TBBM1d=0;    if TBBM1=. then TBBM1=0;
TBBF1d=BIRF1  ;if TBBF1=. then TBBF1d=0;    if TBBF1=. then TBBF1=0;
TBBW1d=BIRW1  ;if TBBW1=. then TBBW1d=0;    if TBBW1=. then TBBW1=0;
TBBB1d=BIRB1  ;if TBBB1=. then TBBB1d=0;    if TBBB1=. then TBBB1=0;
TBBA1d=BIRA1  ;if TBBA1=. then TBBA1d=0;    if TBBA1=. then TBBA1=0;
TBBN1d=BIRN1  ;if TBBN1=. then TBBN1d=0;    if TBBN1=. then TBBN1=0;
TBBP1d=BIRP1  ;if TBBP1=. then TBBP1d=0;    if TBBP1=. then TBBP1=0;
TBBO1d=BIRO1  ;if TBBO1=. then TBBO1d=0;    if TBBO1=. then TBBO1=0;
TBBH1d=BIRH1  ;if TBBH1=. then TBBH1d=0;    if TBBH1=. then TBBH1=0;
TBTT1d=TeenBPT;if TBTT1=. then TBTT1d=0;    if TBTT1=. then TBTT1=0;
TBTM1d=TeenBPT;if TBTM1=. then TBTM1d=0;    if TBTM1=. then TBTM1=0;
TBTF1d=TeenBPT;if TBTF1=. then TBTF1d=0;    if TBTF1=. then TBTF1=0;
TBTW1d=TeenBPW;if TBTW1=. then TBTW1d=0;    if TBTW1=. then TBTW1=0;
TBTB1d=TeenBPB;if TBTB1=. then TBTB1d=0;    if TBTB1=. then TBTB1=0;
TBTA1d=TeenBPA;if TBTA1=. then TBTA1d=0;    if TBTA1=. then TBTA1=0;
TBTN1d=TeenBPN;if TBTN1=. then TBTN1d=0;    if TBTN1=. then TBTN1=0;
TBTP1d=TeenBPP;if TBTP1=. then TBTP1d=0;    if TBTP1=. then TBTP1=0;
TBTO1d=TeenBPM;if TBTO1=. then TBTO1d=0;    if TBTO1=. then TBTO1=0;
TBTH1d=TeenBPH;if TBTH1=. then TBTH1d=0;    if TBTH1=. then TBTH1=0;
LBWT5d=BIRT5  ;if LBWT5=. then LBWT5d=0;    if LBWT5=. then LBWT5=0;
LBWM5d=BIRM5  ;if LBWM5=. then LBWM5d=0;    if LBWM5=. then LBWM5=0;
LBWF5d=BIRF5  ;if LBWF5=. then LBWF5d=0;    if LBWF5=. then LBWF5=0;
LBWW5d=BIRW5  ;if LBWW5=. then LBWW5d=0;    if LBWW5=. then LBWW5=0;
LBWB5d=BIRB5  ;if LBWB5=. then LBWB5d=0;    if LBWB5=. then LBWB5=0;
LBWA5d=BIRA5  ;if LBWA5=. then LBWA5d=0;    if LBWA5=. then LBWA5=0;
LBWN5d=BIRN5  ;if LBWN5=. then LBWN5d=0;    if LBWN5=. then LBWN5=0;
LBWP5d=BIRP5  ;if LBWP5=. then LBWP5d=0;    if LBWP5=. then LBWP5=0;
LBWO5d=BIRO5  ;if LBWO5=. then LBWO5d=0;    if LBWO5=. then LBWO5=0;
LBWH5d=BIRH5  ;if LBWH5=. then LBWH5d=0;    if LBWH5=. then LBWH5=0;
PTBT5d=BIRT5  ;if PTBT5=. then PTBT5d=0;    if PTBT5=. then PTBT5=0;
PTBM5d=BIRM5  ;if PTBM5=. then PTBM5d=0;    if PTBM5=. then PTBM5=0;
PTBF5d=BIRF5  ;if PTBF5=. then PTBF5d=0;    if PTBF5=. then PTBF5=0;
PTBW5d=BIRW5  ;if PTBW5=. then PTBW5d=0;    if PTBW5=. then PTBW5=0;
PTBB5d=BIRB5  ;if PTBB5=. then PTBB5d=0;    if PTBB5=. then PTBB5=0;
PTBA5d=BIRA5  ;if PTBA5=. then PTBA5d=0;    if PTBA5=. then PTBA5=0;
PTBN5d=BIRN5  ;if PTBN5=. then PTBN5d=0;    if PTBN5=. then PTBN5=0;
PTBP5d=BIRP5  ;if PTBP5=. then PTBP5d=0;    if PTBP5=. then PTBP5=0;
PTBO5d=BIRO5  ;if PTBO5=. then PTBO5d=0;    if PTBO5=. then PTBO5=0;
PTBH5d=BIRH5  ;if PTBH5=. then PTBH5d=0;    if PTBH5=. then PTBH5=0;
PNCT5d=BIRT5  ;if PNCT5=. then PNCT5d=0;    if PNCT5=. then PNCT5=0;
PNCM5d=BIRM5  ;if PNCM5=. then PNCM5d=0;    if PNCM5=. then PNCM5=0;
PNCF5d=BIRF5  ;if PNCF5=. then PNCF5d=0;    if PNCF5=. then PNCF5=0;
PNCW5d=BIRW5  ;if PNCW5=. then PNCW5d=0;    if PNCW5=. then PNCW5=0;
PNCB5d=BIRB5  ;if PNCB5=. then PNCB5d=0;    if PNCB5=. then PNCB5=0;
PNCA5d=BIRA5  ;if PNCA5=. then PNCA5d=0;    if PNCA5=. then PNCA5=0;
PNCN5d=BIRN5  ;if PNCN5=. then PNCN5d=0;    if PNCN5=. then PNCN5=0;
PNCP5d=BIRP5  ;if PNCP5=. then PNCP5d=0;    if PNCP5=. then PNCP5=0;
PNCO5d=BIRO5  ;if PNCO5=. then PNCO5d=0;    if PNCO5=. then PNCO5=0;
PNCH5d=BIRH5  ;if PNCH5=. then PNCH5d=0;    if PNCH5=. then PNCH5=0;
TBBT5d=BIRT5  ;if TBBT5=. then TBBT5d=0;    if TBBT5=. then TBBT5=0;
TBBM5d=BIRM5  ;if TBBM5=. then TBBM5d=0;    if TBBM5=. then TBBM5=0;
TBBF5d=BIRF5  ;if TBBF5=. then TBBF5d=0;    if TBBF5=. then TBBF5=0;
TBBW5d=BIRW5  ;if TBBW5=. then TBBW5d=0;    if TBBW5=. then TBBW5=0;
TBBB5d=BIRB5  ;if TBBB5=. then TBBB5d=0;    if TBBB5=. then TBBB5=0;
TBBA5d=BIRA5  ;if TBBA5=. then TBBA5d=0;    if TBBA5=. then TBBA5=0;
TBBN5d=BIRN5  ;if TBBN5=. then TBBN5d=0;    if TBBN5=. then TBBN5=0;
TBBP5d=BIRP5  ;if TBBP5=. then TBBP5d=0;    if TBBP5=. then TBBP5=0;
TBBO5d=BIRO5  ;if TBBO5=. then TBBO5d=0;    if TBBO5=. then TBBO5=0;
TBBH5d=BIRH5  ;if TBBH5=. then TBBH5d=0;    if TBBH5=. then TBBH5=0;
TBTT5d=TeenBPT;if TBTT5=. then TBTT5d=0;    if TBTT5=. then TBTT5=0;
TBTM5d=TeenBPT;if TBTM5=. then TBTM5d=0;    if TBTM5=. then TBTM5=0;
TBTF5d=TeenBPT;if TBTF5=. then TBTF5d=0;    if TBTF5=. then TBTF5=0;
TBTW5d=TeenBPW;if TBTW5=. then TBTW5d=0;    if TBTW5=. then TBTW5=0;
TBTB5d=TeenBPB;if TBTB5=. then TBTB5d=0;    if TBTB5=. then TBTB5=0;
TBTA5d=TeenBPA;if TBTA5=. then TBTA5d=0;    if TBTA5=. then TBTA5=0;
TBTN5d=TeenBPN;if TBTN5=. then TBTN5d=0;    if TBTN5=. then TBTN5=0;
TBTP5d=TeenBPP;if TBTP5=. then TBTP5d=0;    if TBTP5=. then TBTP5=0;
TBTO5d=TeenBPM;if TBTO5=. then TBTO5d=0;    if TBTO5=. then TBTO5=0;
TBTH5d=TeenBPH;if TBTH5=. then TBTH5d=0;    if TBTH5=. then TBTH5=0;
run;
/*N=6280, 232 variables*/
/***/
/***** STEP (4) *****/;
proc summary data=BIR5 nway;class CountyYear;var _numeric_;output out=BIR6 sum=;run; 
/*N=5140, 234 variables*/
/***/
/***** STEP (5) and (6) *****/;
data BIR7;set BIR6;
/****** STEP (5) *******/    /************ STEP (6) *************/
LBWT1r=LBWT1/LBWT1d*100 ;    if  LBWT1d/BIRT1  <0.8 then LBWT1r=.;
LBWM1r=LBWM1/LBWM1d*100 ;    if  LBWM1d/BIRM1  <0.8 then LBWM1r=.;
LBWF1r=LBWF1/LBWF1d*100 ;    if  LBWF1d/BIRF1  <0.8 then LBWF1r=.;
LBWW1r=LBWW1/LBWW1d*100 ;    if  LBWW1d/BIRW1  <0.8 then LBWW1r=.;
LBWB1r=LBWB1/LBWB1d*100 ;    if  LBWB1d/BIRB1  <0.8 then LBWB1r=.;
LBWA1r=LBWA1/LBWA1d*100 ;    if  LBWA1d/BIRA1  <0.8 then LBWA1r=.;
LBWN1r=LBWN1/LBWN1d*100 ;    if  LBWN1d/BIRN1  <0.8 then LBWN1r=.;
LBWP1r=LBWP1/LBWP1d*100 ;    if  LBWP1d/BIRP1  <0.8 then LBWP1r=.;
LBWO1r=LBWO1/LBWO1d*100 ;    if  LBWO1d/BIRO1  <0.8 then LBWO1r=.;
LBWH1r=LBWH1/LBWH1d*100 ;    if  LBWH1d/BIRH1  <0.8 then LBWH1r=.;
PTBT1r=PTBT1/PTBT1d*100 ;    if  PTBT1d/BIRT1  <0.8 then PTBT1r=.;
PTBM1r=PTBM1/PTBM1d*100 ;    if  PTBM1d/BIRM1  <0.8 then PTBM1r=.;
PTBF1r=PTBF1/PTBF1d*100 ;    if  PTBF1d/BIRF1  <0.8 then PTBF1r=.;
PTBW1r=PTBW1/PTBW1d*100 ;    if  PTBW1d/BIRW1  <0.8 then PTBW1r=.;
PTBB1r=PTBB1/PTBB1d*100 ;    if  PTBB1d/BIRB1  <0.8 then PTBB1r=.;
PTBA1r=PTBA1/PTBA1d*100 ;    if  PTBA1d/BIRA1  <0.8 then PTBA1r=.;
PTBN1r=PTBN1/PTBN1d*100 ;    if  PTBN1d/BIRN1  <0.8 then PTBN1r=.;
PTBP1r=PTBP1/PTBP1d*100 ;    if  PTBP1d/BIRP1  <0.8 then PTBP1r=.;
PTBO1r=PTBO1/PTBO1d*100 ;    if  PTBO1d/BIRO1  <0.8 then PTBO1r=.;
PTBH1r=PTBH1/PTBH1d*100 ;    if  PTBH1d/BIRH1  <0.8 then PTBH1r=.;
PNCT1r=PNCT1/PNCT1d*100 ;    if  PNCT1d/BIRT1  <0.8 then PNCT1r=.;
PNCM1r=PNCM1/PNCM1d*100 ;    if  PNCM1d/BIRM1  <0.8 then PNCM1r=.;
PNCF1r=PNCF1/PNCF1d*100 ;    if  PNCF1d/BIRF1  <0.8 then PNCF1r=.;
PNCW1r=PNCW1/PNCW1d*100 ;    if  PNCW1d/BIRW1  <0.8 then PNCW1r=.;
PNCB1r=PNCB1/PNCB1d*100 ;    if  PNCB1d/BIRB1  <0.8 then PNCB1r=.;
PNCA1r=PNCA1/PNCA1d*100 ;    if  PNCA1d/BIRA1  <0.8 then PNCA1r=.;
PNCN1r=PNCN1/PNCN1d*100 ;    if  PNCN1d/BIRN1  <0.8 then PNCN1r=.;
PNCP1r=PNCP1/PNCP1d*100 ;    if  PNCP1d/BIRP1  <0.8 then PNCP1r=.;
PNCO1r=PNCO1/PNCO1d*100 ;    if  PNCO1d/BIRO1  <0.8 then PNCO1r=.;
PNCH1r=PNCH1/PNCH1d*100 ;    if  PNCH1d/BIRH1  <0.8 then PNCH1r=.;
TBBT1r=TBBT1/TBBT1d*100 ;    if  TBBT1d/BIRT1  <0.8 then TBBT1r=.;
TBBM1r=TBBM1/TBBM1d*100 ;    if  TBBM1d/BIRM1  <0.8 then TBBM1r=.;
TBBF1r=TBBF1/TBBF1d*100 ;    if  TBBF1d/BIRF1  <0.8 then TBBF1r=.;
TBBW1r=TBBW1/TBBW1d*100 ;    if  TBBW1d/BIRW1  <0.8 then TBBW1r=.;
TBBB1r=TBBB1/TBBB1d*100 ;    if  TBBB1d/BIRB1  <0.8 then TBBB1r=.;
TBBA1r=TBBA1/TBBA1d*100 ;    if  TBBA1d/BIRA1  <0.8 then TBBA1r=.;
TBBN1r=TBBN1/TBBN1d*100 ;    if  TBBN1d/BIRN1  <0.8 then TBBN1r=.;
TBBP1r=TBBP1/TBBP1d*100 ;    if  TBBP1d/BIRP1  <0.8 then TBBP1r=.;
TBBO1r=TBBO1/TBBO1d*100 ;    if  TBBO1d/BIRO1  <0.8 then TBBO1r=.;
TBBH1r=TBBH1/TBBH1d*100 ;    if  TBBH1d/BIRH1  <0.8 then TBBH1r=.;
TBTT1r=TBTT1/TBTT1d*1000;    if  TBTT1d/TeenBPT<0.8 then TBTT1r=.;
TBTM1r=TBTM1/TBTM1d*1000;    if  TBTM1d/TeenBPT<0.8 then TBTM1r=.;
TBTF1r=TBTF1/TBTF1d*1000;    if  TBTF1d/TeenBPT<0.8 then TBTF1r=.;
TBTW1r=TBTW1/TBTW1d*1000;    if  TBTW1d/TeenBPW<0.8 then TBTW1r=.;
TBTB1r=TBTB1/TBTB1d*1000;    if  TBTB1d/TeenBPB<0.8 then TBTB1r=.;
TBTA1r=TBTA1/TBTA1d*1000;    if  TBTA1d/TeenBPA<0.8 then TBTA1r=.;
TBTN1r=TBTN1/TBTN1d*1000;    if  TBTN1d/TeenBPN<0.8 then TBTN1r=.;
TBTP1r=TBTP1/TBTP1d*1000;    if  TBTP1d/TeenBPP<0.8 then TBTP1r=.;
TBTO1r=TBTO1/TBTO1d*1000;    if  TBTO1d/TeenBPM<0.8 then TBTO1r=.;
TBTH1r=TBTH1/TBTH1d*1000;    if  TBTH1d/TeenBPH<0.8 then TBTH1r=.;
LBWT5r=LBWT5/LBWT5d*100 ;    if  LBWT5d/BIRT5  <0.8 then LBWT5r=.;
LBWM5r=LBWM5/LBWM5d*100 ;    if  LBWM5d/BIRM5  <0.8 then LBWM5r=.;
LBWF5r=LBWF5/LBWF5d*100 ;    if  LBWF5d/BIRF5  <0.8 then LBWF5r=.;
LBWW5r=LBWW5/LBWW5d*100 ;    if  LBWW5d/BIRW5  <0.8 then LBWW5r=.;
LBWB5r=LBWB5/LBWB5d*100 ;    if  LBWB5d/BIRB5  <0.8 then LBWB5r=.;
LBWA5r=LBWA5/LBWA5d*100 ;    if  LBWA5d/BIRA5  <0.8 then LBWA5r=.;
LBWN5r=LBWN5/LBWN5d*100 ;    if  LBWN5d/BIRN5  <0.8 then LBWN5r=.;
LBWP5r=LBWP5/LBWP5d*100 ;    if  LBWP5d/BIRP5  <0.8 then LBWP5r=.;
LBWO5r=LBWO5/LBWO5d*100 ;    if  LBWO5d/BIRO5  <0.8 then LBWO5r=.;
LBWH5r=LBWH5/LBWH5d*100 ;    if  LBWH5d/BIRH5  <0.8 then LBWH5r=.;
PTBT5r=PTBT5/PTBT5d*100 ;    if  PTBT5d/BIRT5  <0.8 then PTBT5r=.;
PTBM5r=PTBM5/PTBM5d*100 ;    if  PTBM5d/BIRM5  <0.8 then PTBM5r=.;
PTBF5r=PTBF5/PTBF5d*100 ;    if  PTBF5d/BIRF5  <0.8 then PTBF5r=.;
PTBW5r=PTBW5/PTBW5d*100 ;    if  PTBW5d/BIRW5  <0.8 then PTBW5r=.;
PTBB5r=PTBB5/PTBB5d*100 ;    if  PTBB5d/BIRB5  <0.8 then PTBB5r=.;
PTBA5r=PTBA5/PTBA5d*100 ;    if  PTBA5d/BIRA5  <0.8 then PTBA5r=.;
PTBN5r=PTBN5/PTBN5d*100 ;    if  PTBN5d/BIRN5  <0.8 then PTBN5r=.;
PTBP5r=PTBP5/PTBP5d*100 ;    if  PTBP5d/BIRP5  <0.8 then PTBP5r=.;
PTBO5r=PTBO5/PTBO5d*100 ;    if  PTBO5d/BIRO5  <0.8 then PTBO5r=.;
PTBH5r=PTBH5/PTBH5d*100 ;    if  PTBH5d/BIRH5  <0.8 then PTBH5r=.;
PNCT5r=PNCT5/PNCT5d*100 ;    if  PNCT5d/BIRT5  <0.8 then PNCT5r=.;
PNCM5r=PNCM5/PNCM5d*100 ;    if  PNCM5d/BIRM5  <0.8 then PNCM5r=.;
PNCF5r=PNCF5/PNCF5d*100 ;    if  PNCF5d/BIRF5  <0.8 then PNCF5r=.;
PNCW5r=PNCW5/PNCW5d*100 ;    if  PNCW5d/BIRW5  <0.8 then PNCW5r=.;
PNCB5r=PNCB5/PNCB5d*100 ;    if  PNCB5d/BIRB5  <0.8 then PNCB5r=.;
PNCA5r=PNCA5/PNCA5d*100 ;    if  PNCA5d/BIRA5  <0.8 then PNCA5r=.;
PNCN5r=PNCN5/PNCN5d*100 ;    if  PNCN5d/BIRN5  <0.8 then PNCN5r=.;
PNCP5r=PNCP5/PNCP5d*100 ;    if  PNCP5d/BIRP5  <0.8 then PNCP5r=.;
PNCO5r=PNCO5/PNCO5d*100 ;    if  PNCO5d/BIRO5  <0.8 then PNCO5r=.;
PNCH5r=PNCH5/PNCH5d*100 ;    if  PNCH5d/BIRH5  <0.8 then PNCH5r=.;
TBBT5r=TBBT5/TBBT5d*100 ;    if  TBBT5d/BIRT5  <0.8 then TBBT5r=.;
TBBM5r=TBBM5/TBBM5d*100 ;    if  TBBM5d/BIRM5  <0.8 then TBBM5r=.;
TBBF5r=TBBF5/TBBF5d*100 ;    if  TBBF5d/BIRF5  <0.8 then TBBF5r=.;
TBBW5r=TBBW5/TBBW5d*100 ;    if  TBBW5d/BIRW5  <0.8 then TBBW5r=.;
TBBB5r=TBBB5/TBBB5d*100 ;    if  TBBB5d/BIRB5  <0.8 then TBBB5r=.;
TBBA5r=TBBA5/TBBA5d*100 ;    if  TBBA5d/BIRA5  <0.8 then TBBA5r=.;
TBBN5r=TBBN5/TBBN5d*100 ;    if  TBBN5d/BIRN5  <0.8 then TBBN5r=.;
TBBP5r=TBBP5/TBBP5d*100 ;    if  TBBP5d/BIRP5  <0.8 then TBBP5r=.;
TBBO5r=TBBO5/TBBO5d*100 ;    if  TBBO5d/BIRO5  <0.8 then TBBO5r=.;
TBBH5r=TBBH5/TBBH5d*100 ;    if  TBBH5d/BIRH5  <0.8 then TBBH5r=.;
TBTT5r=TBTT5/TBTT5d*1000;    if  TBTT5d/TeenBPT<0.8 then TBTT5r=.;
TBTM5r=TBTM5/TBTM5d*1000;    if  TBTM5d/TeenBPT<0.8 then TBTM5r=.;
TBTF5r=TBTF5/TBTF5d*1000;    if  TBTF5d/TeenBPT<0.8 then TBTF5r=.;
TBTW5r=TBTW5/TBTW5d*1000;    if  TBTW5d/TeenBPW<0.8 then TBTW5r=.;
TBTB5r=TBTB5/TBTB5d*1000;    if  TBTB5d/TeenBPB<0.8 then TBTB5r=.;
TBTA5r=TBTA5/TBTA5d*1000;    if  TBTA5d/TeenBPA<0.8 then TBTA5r=.;
TBTN5r=TBTN5/TBTN5d*1000;    if  TBTN5d/TeenBPN<0.8 then TBTN5r=.;
TBTP5r=TBTP5/TBTP5d*1000;    if  TBTP5d/TeenBPP<0.8 then TBTP5r=.;
TBTO5r=TBTO5/TBTO5d*1000;    if  TBTO5d/TeenBPM<0.8 then TBTO5r=.;
TBTH5r=TBTH5/TBTH5d*1000;    if  TBTH5d/TeenBPH<0.8 then TBTH5r=.;
label
BIRT1 ="# live births,1-year estimates,Total"
BIRT5="# live births,5-year estimates,Total"
LBWT1r="% low birth weight(<2.5kg) among live births,1-year estimates,Total"
LBWM1r="% low birth weight(<2.5kg) among live births,1-year estimates,Male baby"
LBWF1r="% low birth weight(<2.5kg) among live births,1-year estimates,Female baby"
LBWW1r="% low birth weight(<2.5kg) among live births,1-year estimates,non-Hispanic/Latino White alone mother"
LBWB1r="% low birth weight(<2.5kg) among live births,1-year estimates,Black alone mother"
LBWA1r="% low birth weight(<2.5kg) among live births,1-year estimates,Asian alone mother"
LBWN1r="% low birth weight(<2.5kg) among live births,1-year estimates,American Indian/Alaska Native alone mother"
LBWP1r="% low birth weight(<2.5kg) among live births,1-year estimates,Native Hawaiian/Other Pacific Islander alone mother"
LBWO1r="% low birth weight(<2.5kg) among live births,1-year estimates,Two or more races mother"
LBWH1r="% low birth weight(<2.5kg) among live births,1-year estimates,Hispanic/Latino mother"
PTBT1r="% preterm(OE gestation<37weeks) among live births,1-year estimates,Total"
PTBM1r="% preterm(OE gestation<37weeks) among live births,1-year estimates,Male baby"
PTBF1r="% preterm(OE gestation<37weeks) among live births,1-year estimates,Female baby"
PTBW1r="% preterm(OE gestation<37weeks) among live births,1-year estimates,non-Hispanic/Latino White alone mother"
PTBB1r="% preterm(OE gestation<37weeks) among live births,1-year estimates,Black alone mother"
PTBA1r="% preterm(OE gestation<37weeks) among live births,1-year estimates,Asian alone mother"
PTBN1r="% preterm(OE gestation<37weeks) among live births,1-year estimates,American Indian/Alaska Native alone mother"
PTBP1r="% preterm(OE gestation<37weeks) among live births,1-year estimates,Native Hawaiian/Other Pacific Islander alone mother"
PTBO1r="% preterm(OE gestation<37weeks) among live births,1-year estimates,Two or more races mother"
PTBH1r="% preterm(OE gestation<37weeks) among live births,1-year estimates,Hispanic/Latino mother"
PNCT1r="% beginning prenatal care in 1st trimester among live births,1-year estimates,Total"
PNCM1r="% beginning prenatal care in 1st trimester among live births,1-year estimates,Male baby"
PNCF1r="% beginning prenatal care in 1st trimester among live births,1-year estimates,Female baby"
PNCW1r="% beginning prenatal care in 1st trimester among live births,1-year estimates,non-Hispanic/Latino White alone mother"
PNCB1r="% beginning prenatal care in 1st trimester among live births,1-year estimates,Black alone mother"
PNCA1r="% beginning prenatal care in 1st trimester among live births,1-year estimates,Asian alone mother"
PNCN1r="% beginning prenatal care in 1st trimester among live births,1-year estimates,American Indian/Alaska Native alone mother"
PNCP1r="% beginning prenatal care in 1st trimester among live births,1-year estimates,Native Hawaiian/Other Pacific Islander alone mother"
PNCO1r="% beginning prenatal care in 1st trimester among live births,1-year estimates,Two or more races mother"
PNCH1r="% beginning prenatal care in 1st trimester among live births,1-year estimates,Hispanic/Latino mother"
TBBT1r="% births to teen mothers(<20yr) among live births,1-year estimates,Total"
TBBM1r="% births to teen mothers(<20yr) among live births,1-year estimates,Male baby"
TBBF1r="% births to teen mothers(<20yr) among live births,1-year estimates,Female baby"
TBBW1r="% births to teen mothers(<20yr) among live births,1-year estimates,non-Hispanic/Latino White alone mother"
TBBB1r="% births to teen mothers(<20yr) among live births,1-year estimates,Black alone mother"
TBBA1r="% births to teen mothers(<20yr) among live births,1-year estimates,Asian alone mother"
TBBN1r="% births to teen mothers(<20yr) among live births,1-year estimates,American Indian/Alaska Native alone mother"
TBBP1r="% births to teen mothers(<20yr) among live births,1-year estimates,Native Hawaiian/Other Pacific Islander alone mother"
TBBO1r="% births to teen mothers(<20yr) among live births,1-year estimates,Two or more races mother"
TBBH1r="% births to teen mothers(<20yr) among live births,1-year estimates,Hispanic/Latino mother"
TBTT1r="birth rate per 1k females aged 15-19,1-year estimates,Total"
TBTM1r="birth rate per 1k females aged 15-19,1-year estimates,Male baby"
TBTF1r="birth rate per 1k females aged 15-19,1-year estimates,Female baby"
TBTW1r="birth rate per 1k females aged 15-19,1-year estimates,non-Hispanic/Latino White alone mother"
TBTB1r="birth rate per 1k females aged 15-19,1-year estimates,Black alone mother"
TBTA1r="birth rate per 1k females aged 15-19,1-year estimates,Asian alone mother"
TBTN1r="birth rate per 1k females aged 15-19,1-year estimates,American Indian/Alaska Native alone mother"
TBTP1r="birth rate per 1k females aged 15-19,1-year estimates,Native Hawaiian/Other Pacific Islander alone mother"
TBTO1r="birth rate per 1k females aged 15-19,1-year estimates,Two or more races mother"
TBTH1r="birth rate per 1k females aged 15-19,1-year estimates,Hispanic/Latino mother"
LBWT5r="% low birth weight(<2.5kg) among live births,5-year estimates,Total"
LBWM5r="% low birth weight(<2.5kg) among live births,5-year estimates,Male baby"
LBWF5r="% low birth weight(<2.5kg) among live births,5-year estimates,Female baby"
LBWW5r="% low birth weight(<2.5kg) among live births,5-year estimates,non-Hispanic/Latino White alone mother"
LBWB5r="% low birth weight(<2.5kg) among live births,5-year estimates,Black alone mother"
LBWA5r="% low birth weight(<2.5kg) among live births,5-year estimates,Asian alone mother"
LBWN5r="% low birth weight(<2.5kg) among live births,5-year estimates,American Indian/Alaska Native alone mother"
LBWP5r="% low birth weight(<2.5kg) among live births,5-year estimates,Native Hawaiian/Other Pacific Islander alone mother"
LBWO5r="% low birth weight(<2.5kg) among live births,5-year estimates,Two or more races mother"
LBWH5r="% low birth weight(<2.5kg) among live births,5-year estimates,Hispanic/Latino mother"
PTBT5r="% preterm(OE gestation<37weeks) among live births,5-year estimates,Total"
PTBM5r="% preterm(OE gestation<37weeks) among live births,5-year estimates,Male baby"
PTBF5r="% preterm(OE gestation<37weeks) among live births,5-year estimates,Female baby"
PTBW5r="% preterm(OE gestation<37weeks) among live births,5-year estimates,non-Hispanic/Latino White alone mother"
PTBB5r="% preterm(OE gestation<37weeks) among live births,5-year estimates,Black alone mother"
PTBA5r="% preterm(OE gestation<37weeks) among live births,5-year estimates,Asian alone mother"
PTBN5r="% preterm(OE gestation<37weeks) among live births,5-year estimates,American Indian/Alaska Native alone mother"
PTBP5r="% preterm(OE gestation<37weeks) among live births,5-year estimates,Native Hawaiian/Other Pacific Islander alone mother"
PTBO5r="% preterm(OE gestation<37weeks) among live births,5-year estimates,Two or more races mother"
PTBH5r="% preterm(OE gestation<37weeks) among live births,5-year estimates,Hispanic/Latino mother"
PNCT5r="% beginning prenatal care in 1st trimester among live births,5-year estimates,Total"
PNCM5r="% beginning prenatal care in 1st trimester among live births,5-year estimates,Male baby"
PNCF5r="% beginning prenatal care in 1st trimester among live births,5-year estimates,Female baby"
PNCW5r="% beginning prenatal care in 1st trimester among live births,5-year estimates,non-Hispanic/Latino White alone mother"
PNCB5r="% beginning prenatal care in 1st trimester among live births,5-year estimates,Black alone mother"
PNCA5r="% beginning prenatal care in 1st trimester among live births,5-year estimates,Asian alone mother"
PNCN5r="% beginning prenatal care in 1st trimester among live births,5-year estimates,American Indian/Alaska Native alone mother"
PNCP5r="% beginning prenatal care in 1st trimester among live births,5-year estimates,Native Hawaiian/Other Pacific Islander alone mother"
PNCO5r="% beginning prenatal care in 1st trimester among live births,5-year estimates,Two or more races mother"
PNCH5r="% beginning prenatal care in 1st trimester among live births,5-year estimates,Hispanic/Latino mother"
TBBT5r="% births to teen mothers(<20yr) among live births,5-year estimates,Total"
TBBM5r="% births to teen mothers(<20yr) among live births,5-year estimates,Male baby"
TBBF5r="% births to teen mothers(<20yr) among live births,5-year estimates,Female baby"
TBBW5r="% births to teen mothers(<20yr) among live births,5-year estimates,non-Hispanic/Latino White alone mother"
TBBB5r="% births to teen mothers(<20yr) among live births,5-year estimates,Black alone mother"
TBBA5r="% births to teen mothers(<20yr) among live births,5-year estimates,Asian alone mother"
TBBN5r="% births to teen mothers(<20yr) among live births,5-year estimates,American Indian/Alaska Native alone mother"
TBBP5r="% births to teen mothers(<20yr) among live births,5-year estimates,Native Hawaiian/Other Pacific Islander alone mother"
TBBO5r="% births to teen mothers(<20yr) among live births,5-year estimates,Two or more races mother"
TBBH5r="% births to teen mothers(<20yr) among live births,5-year estimates,Hispanic/Latino mother"
TBTT5r="birth rate per 1k females aged 15-19,5-year estimates,Total"
TBTM5r="birth rate per 1k females aged 15-19,5-year estimates,Male baby"
TBTF5r="birth rate per 1k females aged 15-19,5-year estimates,Female baby"
TBTW5r="birth rate per 1k females aged 15-19,5-year estimates,non-Hispanic/Latino White alone mother"
TBTB5r="birth rate per 1k females aged 15-19,5-year estimates,Black alone mother"
TBTA5r="birth rate per 1k females aged 15-19,5-year estimates,Asian alone mother"
TBTN5r="birth rate per 1k females aged 15-19,5-year estimates,American Indian/Alaska Native alone mother"
TBTP5r="birth rate per 1k females aged 15-19,5-year estimates,Native Hawaiian/Other Pacific Islander alone mother"
TBTO5r="birth rate per 1k females aged 15-19,5-year estimates,Two or more races mother"
TBTH5r="birth rate per 1k females aged 15-19,5-year estimates,Hispanic/Latino mother";
keep
CountyYear BIRT1 BIRW1 BIRB1 BIRH1 BIRT5 BIRW5 BIRB5 BIRH5
LBWT1r LBWM1r LBWF1r LBWW1r LBWB1r LBWA1r LBWN1r LBWP1r LBWO1r LBWH1r PTBT1r PTBM1r PTBF1r PTBW1r PTBB1r PTBA1r PTBN1r PTBP1r PTBO1r PTBH1r PNCT1r PNCM1r PNCF1r PNCW1r PNCB1r
PNCA1r PNCN1r PNCP1r PNCO1r PNCH1r TBBT1r TBBM1r TBBF1r TBBW1r TBBB1r TBBA1r TBBN1r TBBP1r TBBO1r TBBH1r TBTT1r TBTM1r TBTF1r TBTW1r TBTB1r TBTA1r TBTN1r TBTP1r TBTO1r TBTH1r
LBWT5r LBWM5r LBWF5r LBWW5r LBWB5r LBWA5r LBWN5r LBWP5r LBWO5r LBWH5r PTBT5r PTBM5r PTBF5r PTBW5r PTBB5r PTBA5r PTBN5r PTBP5r PTBO5r PTBH5r PNCT5r PNCM5r PNCF5r PNCW5r PNCB5r
PNCA5r PNCN5r PNCP5r PNCO5r PNCH5r TBBT5r TBBM5r TBBF5r TBBW5r TBBB5r TBBA5r TBBN5r TBBP5r TBBO5r TBBH5r TBTT5r TBTM5r TBTF5r TBTW5r TBTB5r TBTA5r TBTN5r TBTP5r TBTO5r TBTH5r;
run;
/*N=5140, 109 variables*/
/***/
/* Merging with CountyYrKey -- Inner join to exclude Census data county-years that are missing in CAN data */
proc sort data=BIR7;by CountyYear;run; /*N=5140, 109 variables*/
data BIR8;retain BIRFlag;merge BIR7(IN=A) CountyYrKey(IN=B);by CountyYear;if (A=B);drop CountyYrFlag;BIRFlag=1;run; /*N=4935; 110 variables*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* A02: Merging A01 and Birth Data *************************************************************************************************************/
/********************************* A02: Merging A01 and Birth Data *************************************************************************************************************/
/********************************* A02: Merging A01 and Birth Data *************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/***/;
proc sort data=A01 ;by CountyYear;run;     /*N=6153; 778 variables*/
proc sort data=BIR8;by CountyYear;run;     /*N=4935; 110 variables*/
data A02;merge A01 BIR8;by CountyYear;run; /*N=6153; 887 variables*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Opioid Prescription data ********************************************************************************************************************/
/********************************* Opioid Prescription data ********************************************************************************************************************/
/********************************* Opioid Prescription data ********************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/***/
/* Importing Opioid data */;
data Opioid1;set d.Opioid;CountyYear=CountyFIPS*10000+Year;run; 
/*N=30980, 4 variables*/
/***/
/* Merging with census data (total population) to weight opioid prescription rate (per 100 persons) by total population before aggregating counties suppressed in CAN data */;
proc sort data=Opioid1;by CountyYear;run; 
proc sort data=census1;by CountyYear;run; 
data Opioid2;merge Opioid1(IN=A) census1(IN=B);by CountyYear;if (A=B);
Opioidw=Opioid*PopT;label Opioidw="Retail opioid prescription rate per 100 persons * total population (PopT)";
keep Year CountyYear CountyFIPS Opioidw PopT;run; 
/*N=30973, 5 variables*/
/***/
/* Merging with CountyKey to aggregate Opioid data counties that are suppressed in CAN data */;
proc sort data=Opioid2;by CountyFIPS;run; /*N=30973, 5 variables*/
data Opioid3;merge Opioid2(IN=A) CountyKey;by CountyFIPS;if A;
if CountyFlag=. then CountyYear=INT(CountyFIPS/1000)*10000000+9990000+Year;
keep CountyYear Opioidw PopT;run; 
/*N=30973, 3 variables*/;
proc summary data=Opioid3 nway;class CountyYear;var Opioidw PopT;output out=Opioid4 sum=;run; 
/*N=6410, 5 variables*/
/***/
/* Merging with CountyYrKey -- Inner join to exclude Opioid data county-years that are missing in CAN data */;
proc sort data=Opioid4;by CountyYear;run;
data Opioid5;retain OpioidFlag;merge Opioid4(IN=A) CountyYrKey(IN=B);by CountyYear;if (A=B);OpioidFlag=1;drop CountyYrFlag _TYPE_ _FREQ_;run; 
/*N=6153; 4 variables*/
/***/
/* All counties identified in CAN data exist in Opioid data. However, some counties suppressed in CAN data (and aggregated into combined counties) are missing in Opioid data.
   If a combined county in Opioid data covers less than 80% of a combined county in CAN data in terms of total population,
     Opioid prescription rate would be missing for that county. */;
proc sort data=Opioid5;by CountyYear;run; /*N=6153,   4 variables*/
proc sort data=A02    ;by CountyYear;run; /*N=6153, 887 variables*/
data Opioid6;merge Opioid5 A02(rename=(PopT=PopT2));by CountyYear;
Opioid=Opioidw/PopT;
if PopT/PopT2<0.8 then Opioid=.; /* This code changes nothing as coverage is over 80% for all combined counties */
label Opioid="Retail opioid prescription rate per 100 persons";
;keep OpioidFlag CountyYear Opioid;run; 
/*N=6153, 3 variables*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* A03: Merging A02 and Opioid Data *************************************************************************************************************/
/********************************* A03: Merging A02 and Opioid Data *************************************************************************************************************/
/********************************* A03: Merging A02 and Opioid Data *************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/***/;
proc sort data=A02    ;by CountyYear;run;     /*N=6153; 887 variables*/
proc sort data=Opioid6;by CountyYear;run;     /*N=6153,   3 variables*/
data A03;merge A02 Opioid6;by CountyYear;run; /*N=6153, 889 variables*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Urban/Rural Code data ***********************************************************************************************************************/
/********************************* Urban/Rural Code data ***********************************************************************************************************************/
/********************************* Urban/Rural Code data ***********************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/***/
/***/
/***/
/* NCHS_RUC */
/* NCHS_RUC */
/* NCHS_RUC */
/* Importing URCode data & Weighting URCode by county resident population before aggregating counties that are suppressed in CAN data */;
data NCHS1;set e1.NCHS_RUC;NCHS_RUC0w=NCHS_RUC0*ctypop;keep CountyFIPS NCHS_RUC0w ctypop;run; 
/*N=3149, 3 variables*/
/* Aggregating counties suppressed in CAN data */;
proc sort data=NCHS1;by CountyFIPS;run;
data NCHS2;merge NCHS1(IN=A) CountyKey;by CountyFIPS;if A;if CountyFlag=. then CountyFIPS=INT(CountyFIPS/1000)*1000+999;run; 
/*N=3149, 4 variables*/;
proc summary data=NCHS2 nway;class CountyFIPS;var NCHS_RUC0w ctypop;output out=NCHS3 sum=;run; 
/*N=641, 5 variables*/
/* Computing population-weighted URCode for combined counties */;
data NCHS4;set NCHS3;
NCHS_RUCFlag=1;
NCHS_RUC0=round(NCHS_RUC0w/ctypop);
if NCHS_RUC0 in (1 2) then NCHS_RUC=1;
if NCHS_RUC0 in (3 4) then NCHS_RUC=2;
if NCHS_RUC0 in (5 6) then NCHS_RUC=3;
label
NCHS_RUC0="NCHS 2013 RUC: 1=large central metro;2=large fringe metro;3=medium metro;4=small metro;5=micropolitan;6=noncore"
NCHS_RUC="NCHS 2013 RUC-collapsed: 1=large central/fringe metro; 2=medium/small metro; 3=micropolitan/noncore";
keep CountyFIPS NCHS_RUCFlag NCHS_RUC0 NCHS_RUC;
run; 
/*N=641, 4 variables*/
/***/
/***/
/***/
/* USDA_RUC */
/* USDA_RUC */
/* USDA_RUC */
/* Importing URCode data & Weighting URCode by county resident population before aggregating counties that are suppressed in CAN data */;
data USDA1;set e2.USDA_RUC;USDA_RUC0w=USDA_RUC0*Population_2010;keep CountyFIPS USDA_RUC0w Population_2010;run; 
/*N=3149, 3 variables*/
/* Aggregating counties suppressed in CAN data */;
proc sort data=USDA1;by CountyFIPS;run;
data USDA2;merge USDA1(IN=A) CountyKey;by CountyFIPS;if A;if CountyFlag=. then CountyFIPS=INT(CountyFIPS/1000)*1000+999;run; 
/*N=3149, 4 variables*/;
proc summary data=USDA2 nway;class CountyFIPS;var USDA_RUC0w Population_2010;output out=USDA3 sum=;run; 
/*N=641, 5 variables*/
/* Computing population-weighted URCode for combined counties */;
data USDA4;set USDA3;
USDA_RUCFlag=1;
USDA_RUC0=round(USDA_RUC0w/Population_2010);
if   USDA_RUC0=1 then USDA_RUC=1;
if 1<USDA_RUC0<4 then USDA_RUC=2;
if 3<USDA_RUC0   then USDA_RUC=3;
label
USDA_RUC0="USDA 2013 RUC: 1-3=Metro;4-9=Nonmetro;(1)>=1M;(2)250K-1M;(3)<250K;(4)adjacent to metro(AM),>=20K;(5)not AM,>=20K;(6)AM,2.5K-19,999;(7)not AM,2.5K-19,999;(8)AM,<2.5K;(9)not AM,<2.5K"
USDA_RUC="USDA 2013 RUC-collapsed: 1=large urban(USDA code1);2=small urban(USDA code2-3);3=rural(USDA code4-9)";
keep CountyFIPS USDA_RUCFlag USDA_RUC0 USDA_RUC;
run; 
/*N=641, 4 variables*/
/***/
/***/
/***/
proc sort data=NCHS4;by CountyFIPS;run;
proc sort data=USDA4;by CountyFIPS;run;
data RUC1;merge NCHS4(IN=A) USDA4(IN=A);run;/*N=641, 7 variables*/
/* Consistency between NCHS and USDA codes */
/* proc freq data=RUC1;tables NCHS_RUC*USDA_RUC;run;
   Consistent  : 97.04%
   Inconsistent:  2.96% */





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* A04: Merging A03 and URCode Data ************************************************************************************************************/
/********************************* A04: Merging A03 and URCode Data ************************************************************************************************************/
/********************************* A04: Merging A03 and URCode Data ************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
proc sort data=A03 ;by CountyFIPS;run;                /*N=6153, 889 variables*/
proc sort data=RUC1;by CountyFIPS;run;                /*N= 641,   7 variables*/
data A04;merge A03(IN=A) RUC1;by CountyFIPS;if A;run; /*N=6153, 895 variables*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Spatial Data ********************************************************************************************************************************/
/********************************* Spatial Data ********************************************************************************************************************************/
/********************************* Spatial Data ********************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/***/
/* Importing Spatial Data */;
data GAZ1;set f.GAZ;CountyYear=CountyFIPS*10000+Year;run; 
/*N=32205, 5 variables*/
/* Merging with CountyKey to aggregate Spatial data counties that are suppressed in CAN data */;
proc sort data=GAZ1;by CountyFIPS;run;
data GAZ2;merge GAZ1(IN=A) CountyKey;by CountyFIPS;if A;
if CountyFlag=. then CountyYear=INT(CountyFIPS/1000)*10000000+9990000+Year;
keep CountyYear Latitude Longitude;run; 
/*N=32205, 3 variables*/;
proc summary data=GAZ2 nway;class CountyYear;var Latitude Longitude;output out=GAZ3 mean=;run; 
/*N=6420, 5 variables*/
/* Merging with CountyYrKey -- Inner join to exclude Spatial data county-years that are missing in CAN data */;
proc sort data=GAZ3;by CountyYear;run;
data GAZ4;retain GAZFlag;merge GAZ3(IN=A) CountyYrKey(IN=B);by CountyYear;if (A=B);GAZFlag=1;
Latitude=round(Latitude,.000001);Longitude=round(Longitude,.000001);
drop CountyYrFlag _TYPE_ _FREQ_;run; 
/*N=6153; 4 variables*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* A05: Merging A04 and URCode Data ************************************************************************************************************/
/********************************* A05: Merging A04 and URCode Data ************************************************************************************************************/
/********************************* A05: Merging A04 and URCode Data ************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/***/;
proc sort data=A04 ;by CountyYear;run;     /*N=6153, 895 variables*/
proc sort data=GAZ4;by CountyYear;run;     /*N=6153,   4 variables*/
data A05;merge A04 GAZ4;by CountyYear;run; /*N=6153, 898 variables*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* County Health Rankings Data *****************************************************************************************************************/
/********************************* County Health Rankings Data *****************************************************************************************************************/
/********************************* County Health Rankings Data *****************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/***/
/* Importing CHR data */;
data CHR01;set g.CHR(rename=(CountyFIPS=CountyFIPS2));if 2008<Year<2019;CountyFIPS=CountyFIPS2+0;CountyYear=CountyFIPS*10000+Year;
keep 
CountyFIPS
Year
CountyYear
ChdDeath_n
ChdDeath_d
ChdDeathB	
ChdDeathH	
ChdDeathW	
Dentist_n
Dentist_d
Diabet	
DrugOd_n
DrugOd_d
DrugOdB	
DrugOdH	
DrugOdW	
DWIDeath_n
DWIDeath_d
Edrink	
FastFood_n
FastFood_d
FoodEnv	
FoodIns	
FrLunch_n
FrLunch_d
GunDeath_n
GunDeath_d
GunDeathB	
GunDeathW	
Gym	
Gym2	
HousCost_n
HousCost_d
HousCosts	
HousCrowd	
Housing_n
Housing_d
HousPlumb	
Inactive	
InfDeath_n
InfDeath_d
InfDeathB	
InfDeathH	
InfDeathW	
Injury_n
Injury_d
InjuryB	
InjuryH	
InjuryW	
Insured_n
Insured_d
InsuredA_n
InsuredA_d
InsuredC_n
InsuredC_d
JuvArr
JuvArr_d
LAccFood	
LifeExp	
LifeExpB	
LifeExpH	
LifeExpW	
LongComm
LongComm_d
LowBW_n
LowBW_d
LowBWB	
LowBWH	
LowBWW	
Mental	
MHPrvd_n
MHPrvd_d
Murder_n
Murder_d
Obesity	
PCP_n
PCP_d
PCP2_n
PCP2_d
Physical	
PoorHlth	
PoorMH	
PoorPhy	
PrmDeath
PrmDeath_d
PrmDeath_n
PrmDeath_d
PrmDeath2
PrmDeath2_d
PrmDeath2_n
PrmDeath2_d
PrmDeath2B	
PrmDeath2H	
PrmDeath2W	
PrmDeathB	
PrmDeathH	
PrmDeathW	
PrvtHosp	
PrvtHospB	
PrvtHospH	
PrvtHospW	
SegBW	
SegNW	
Sleep	
Smoke	
SocAsso_n
SocAsso_d
SocSupp	
STD_CT	
Suicide_n
Suicide_d
TeenBth_n
TeenBth_d
TeenBthB	
TeenBthH	
TeenBthW	
Violent_n
Violent_d
;run;
/*N=31442, 116 variables*/
/***/
/* Importing census data and birth data (to get population data for weighting while aggregating counties suppressed/combined in CAN data) */;
data CHRd1;set b.census(rename=(CntyYear=CountyYear));
keep CountyYear APopT CPop2 CPop3 CPopB CPopH CPopT CPopW EldPopB EldPopH EldPopT EldPopW PopB PopH PopT PopW RPovPT TeenBPB TeenBPH TeenBPT TeenBPW;run;
/*N=32205, 21 variables*/;
proc sort data=CHR01;by CountyYear;run;                    /*N=31442, 116 variables*/
proc sort data=CHRd1;by CountyYear;run;                    /*N=32205,  21 variables*/
data CHR02;merge CHR01 CHRd1(IN=A);by CountyYear;if A;run; /*N=32205, 136 variables*/
/***/
/* Calculating Rates */;
data CHR03;set CHR02;
/* Calculating rates */
ChdDeath  =ChdDeath_n /ChdDeath_d *100000;label ChdDeath  ="Child mortality: # deaths among children under age 18 per 100k population";
Dentist   =Dentist_n  /Dentist_d  *100000;label Dentist   ="Dentists: # dentists per 100k population";
DrugOd    =DrugOd_n   /DrugOd_d   *100000;label DrugOd    ="Drug overdose deaths: # drug poisoning deaths per 100k population";
DWIDeath  =DWIDeath_n /DWIDeath_d *   100;label DWIDeath  ="Alcohol-impaired driving deaths: % driving deaths with alcohol involvement";
FastFood  =FastFood_n /FastFood_d *   100;label FastFood  ="Fast food restaurants: % restaurants that are fast food restaurants";
FrLunch   =FrLunch_n  /FrLunch_d  *   100;label FrLunch   ="Children eligible for free lunch: % children (in public schools) eligible for free lunch";
GunDeath  =GunDeath_n /GunDeath_d *100000;label GunDeath  ="Firearm fatalities: # deaths due to firearms per 100k population";
HousCost  =HousCost_n /HousCost_d *   100;label HousCost  ="Severe housing cost burden: % households that spend 50% or more of their household income on housing";
Housing   =Housing_n  /Housing_d  *   100;label Housing   ="Severe housing problems: % households with at least 1 of 4 housing problems: overcrowding, high housing costs, or lack of kitchen or plumbing facilities";
InfDeath  =InfDeath_n /InfDeath_d *  1000;label InfDeath  ="Infant mortality: # all infant deaths (within 1 year), per 1k live births";
Injury    =Injury_n   /Injury_d   *100000;label Injury    ="Injury deaths: # deaths due to injury per 100k population";
Insured   =Insured_n  /Insured_d  *   100;label Insured   ="Uninsured: % population < age 65 without health insurance";
InsuredA  =InsuredA_n /InsuredA_d *   100;label InsuredA  ="Uninsured adults: % adults 18-64 without health insurance";
InsuredC  =InsuredC_n /InsuredC_d *   100;label InsuredC  ="Uninsured children: % children < age 19 without health insurance";
LowBW     =LowBW_n    /LowBW_d    *   100;label LowBW     ="Low birthweight: % births with low birth weight (<2.5kg)";
MHPrvd    =MHPrvd_n   /MHPrvd_d   *100000;label MHPrvd    ="Mental health providers: # Mental Health Providers per 100k population";
Murder    =Murder_n   /Murder_d   *100000;label Murder    ="Homicides: # deaths from assaults per 100k population";
PCP       =PCP_n      /PCP_d      *100000;label PCP       ="Primary care physicians: Primary care physicians in patient care per 100k population";
PCP2      =PCP2_n     /PCP2_d     *100000;label PCP2      ="Other primary care providers: Primary care providers other than physicians (ie, nurse practitioners, physician assistants, clinical nurse specialists) per 100k population";
PrmDeathc =PrmDeath_n /PrmDeath_d *100000;label PrmDeathc ="Premature death: Crude Years of Potential Life Lost (YPLL) before age 75 per 100k population";
PrmDeath2c=PrmDeath2_n/PrmDeath2_d*100000;label PrmDeath2c="Premature crude mortality: # deaths among residents under age 75 per 100k population (age-adjusted)";
SocAsso   =SocAsso_n  /SocAsso_d  * 10000;label SocAsso   ="Social associations: # membership associations per 10k population";
Suicide   =Suicide_n  /Suicide_d  *100000;label Suicide   ="Suicides: # deaths due to suicide per 100k population";
TeenBth   =TeenBth_n  /TeenBth_d  *  1000;label TeenBth   ="Teen births: # births per 1k females ages 15-19";
Violent   =Violent_n  /Violent_d  *100000;label Violent   ="Violent crime: # reported violent crime offenses per 100k population";
/* Converting decimal (0 to 1) into percentage (0 to 100) */
LAccFood  =LAccFood *100;
PoorHlth  =PoorHlth *100;
Smoke     =Smoke    *100;
SocSupp   =SocSupp  *100;
Obesity   =Obesity  *100;
Diabet    =Diabet   *100;
Inactive  =Inactive *100;
EDrink    =EDrink   *100;
FoodIns   =FoodIns  *100;
Gym2      =Gym2     *100;
LongComm  =LongComm *100;
Physical  =Physical *100;
Mental    =Mental   *100;
Sleep     =Sleep    *100;
HousCosts =HousCosts*100;
HousCrowd =HousCrowd*100;
HousPlumb =HousPlumb*100;
LowBWW    =LowBWW   *100;
LowBWB    =LowBWB   *100;
LowBWH    =LowBWH   *100;
/* Handling over 100% values - ceiling to 100% */
if FrLunch>100 then FrLunch=100;
run;
/*N=32205, 161 variables*/
/***/
/* Weighting Rates */;
data CHR04;set CHR03;
/*POP=population*/
/*IF POP=. THEN POP=0************/
if APopT     =. then APopT     =0;
if CPop2     =. then CPop2     =0;
if CPop3     =. then CPop3     =0;
if CPopB     =. then CPopB     =0;
if CPopH     =. then CPopH     =0;
if CPopT     =. then CPopT     =0;
if CPopW     =. then CPopW     =0;
if EldPopB   =. then EldPopB   =0;
if EldPopH   =. then EldPopH   =0;
if EldPopT   =. then EldPopT   =0;
if EldPopW   =. then EldPopW   =0;
if PopB      =. then PopB      =0;
if PopH      =. then PopH      =0;
if PopT      =. then PopT      =0;
if PopW      =. then PopW      =0;
if RPovPT    =. then RPovPT    =0;
if TeenBPB   =. then TeenBPB   =0;
if TeenBPH   =. then TeenBPH   =0;
if TeenBPT   =. then TeenBPT   =0;
if TeenBPW   =. then TeenBPW   =0;
if DWIDeath_d=. then DWIDeath_d=0;
if FastFood_d=. then FastFood_d=0;
if LongComm_d=. then LongComm_d=0;
/*DEN=denominator (=population)*/
/*Creating DEN for weighting****//*IF Rate=. THEN DEN=0**************//*IF Rate=. THEN Rate=0**********//*Weighting Rate by DEN**************/    
ChdDeath_d2  =CPopT             ;if ChdDeath  =. then ChdDeath_d2  =0;if ChdDeath  =. then ChdDeath  =0;ChdDeath_w  =ChdDeath  *ChdDeath_d2  ;
ChdDeathB_d2 =CPopB             ;if ChdDeathB =. then ChdDeathB_d2 =0;if ChdDeathB =. then ChdDeathB =0;ChdDeathB_w =ChdDeathB *ChdDeathB_d2 ;
ChdDeathH_d2 =CPopH             ;if ChdDeathH =. then ChdDeathH_d2 =0;if ChdDeathH =. then ChdDeathH =0;ChdDeathH_w =ChdDeathH *ChdDeathH_d2 ;
ChdDeathW_d2 =CPopW             ;if ChdDeathW =. then ChdDeathW_d2 =0;if ChdDeathW =. then ChdDeathW =0;ChdDeathW_w =ChdDeathW *ChdDeathW_d2 ;
Dentist_d2   =PopT              ;if Dentist   =. then Dentist_d2   =0;if Dentist   =. then Dentist   =0;Dentist_w   =Dentist   *Dentist_d2   ;
Diabet_d2    =APopT             ;if Diabet    =. then Diabet_d2    =0;if Diabet    =. then Diabet    =0;Diabet_w    =Diabet    *Diabet_d2    ;
DrugOd_d2    =PopT              ;if DrugOd    =. then DrugOd_d2    =0;if DrugOd    =. then DrugOd    =0;DrugOd_w    =DrugOd    *DrugOd_d2    ;
DrugOdB_d2   =PopB              ;if DrugOdB   =. then DrugOdB_d2   =0;if DrugOdB   =. then DrugOdB   =0;DrugOdB_w   =DrugOdB   *DrugOdB_d2   ;
DrugOdH_d2   =PopH              ;if DrugOdH   =. then DrugOdH_d2   =0;if DrugOdH   =. then DrugOdH   =0;DrugOdH_w   =DrugOdH   *DrugOdH_d2   ;
DrugOdW_d2   =PopW              ;if DrugOdW   =. then DrugOdW_d2   =0;if DrugOdW   =. then DrugOdW   =0;DrugOdW_w   =DrugOdW   *DrugOdW_d2   ;
DWIDeath_d2  =DWIDeath_d        ;if DWIDeath  =. then DWIDeath_d2  =0;if DWIDeath  =. then DWIDeath  =0;DWIDeath_w  =DWIDeath  *DWIDeath_d2  ;
Edrink_d2    =PopT-CPopT        ;if Edrink    =. then Edrink_d2    =0;if Edrink    =. then Edrink    =0;Edrink_w    =Edrink    *Edrink_d2    ;
FastFood_d2  =FastFood_d        ;if FastFood  =. then FastFood_d2  =0;if FastFood  =. then FastFood  =0;FastFood_w  =FastFood  *FastFood_d2  ;
FoodEnv_d2   =PopT              ;if FoodEnv   =. then FoodEnv_d2   =0;if FoodEnv   =. then FoodEnv   =0;FoodEnv_w   =FoodEnv   *FoodEnv_d2   ;
FoodIns_d2   =PopT              ;if FoodIns   =. then FoodIns_d2   =0;if FoodIns   =. then FoodIns   =0;FoodIns_w   =FoodIns   *FoodIns_d2   ;
FrLunch_d2   =CPop2+CPop3       ;if FrLunch   =. then FrLunch_d2   =0;if FrLunch   =. then FrLunch   =0;FrLunch_w   =FrLunch   *FrLunch_d2   ;
GunDeath_d2  =PopT              ;if GunDeath  =. then GunDeath_d2  =0;if GunDeath  =. then GunDeath  =0;GunDeath_w  =GunDeath  *GunDeath_d2  ;
GunDeathB_d2 =PopB              ;if GunDeathB =. then GunDeathB_d2 =0;if GunDeathB =. then GunDeathB =0;GunDeathB_w =GunDeathB *GunDeathB_d2 ;
GunDeathW_d2 =PopW              ;if GunDeathW =. then GunDeathW_d2 =0;if GunDeathW =. then GunDeathW =0;GunDeathW_w =GunDeathW *GunDeathW_d2 ;
Gym_d2       =PopT              ;if Gym       =. then Gym_d2       =0;if Gym       =. then Gym       =0;Gym_w       =Gym       *Gym_d2       ;
Gym2_d2      =PopT              ;if Gym2      =. then Gym2_d2      =0;if Gym2      =. then Gym2      =0;Gym2_w      =Gym2      *Gym2_d2      ;
HousCost_d2  =RPovPT            ;if HousCost  =. then HousCost_d2  =0;if HousCost  =. then HousCost  =0;HousCost_w  =HousCost  *HousCost_d2  ;
HousCosts_d2 =RPovPT            ;if HousCosts =. then HousCosts_d2 =0;if HousCosts =. then HousCosts =0;HousCosts_w =HousCosts *HousCosts_d2 ;
HousCrowd_d2 =RPovPT            ;if HousCrowd =. then HousCrowd_d2 =0;if HousCrowd =. then HousCrowd =0;HousCrowd_w =HousCrowd *HousCrowd_d2 ;
Housing_d2   =RPovPT            ;if Housing   =. then Housing_d2   =0;if Housing   =. then Housing   =0;Housing_w   =Housing   *Housing_d2   ;
HousPlumb_d2 =RPovPT            ;if HousPlumb =. then HousPlumb_d2 =0;if HousPlumb =. then HousPlumb =0;HousPlumb_w =HousPlumb *HousPlumb_d2 ;
Inactive_d2  =APopT             ;if Inactive  =. then Inactive_d2  =0;if Inactive  =. then Inactive  =0;Inactive_w  =Inactive  *Inactive_d2  ;
InfDeath_d2  =CPopT             ;if InfDeath  =. then InfDeath_d2  =0;if InfDeath  =. then InfDeath  =0;InfDeath_w  =InfDeath  *InfDeath_d2  ;
InfDeathB_d2 =CPopB             ;if InfDeathB =. then InfDeathB_d2 =0;if InfDeathB =. then InfDeathB =0;InfDeathB_w =InfDeathB *InfDeathB_d2 ;
InfDeathH_d2 =CPopH             ;if InfDeathH =. then InfDeathH_d2 =0;if InfDeathH =. then InfDeathH =0;InfDeathH_w =InfDeathH *InfDeathH_d2 ;
InfDeathW_d2 =CPopW             ;if InfDeathW =. then InfDeathW_d2 =0;if InfDeathW =. then InfDeathW =0;InfDeathW_w =InfDeathW *InfDeathW_d2 ;
Injury_d2    =PopT              ;if Injury    =. then Injury_d2    =0;if Injury    =. then Injury    =0;Injury_w    =Injury    *Injury_d2    ;
InjuryB_d2   =PopB              ;if InjuryB   =. then InjuryB_d2   =0;if InjuryB   =. then InjuryB   =0;InjuryB_w   =InjuryB   *InjuryB_d2   ;
InjuryH_d2   =PopH              ;if InjuryH   =. then InjuryH_d2   =0;if InjuryH   =. then InjuryH   =0;InjuryH_w   =InjuryH   *InjuryH_d2   ;
InjuryW_d2   =PopW              ;if InjuryW   =. then InjuryW_d2   =0;if InjuryW   =. then InjuryW   =0;InjuryW_w   =InjuryW   *InjuryW_d2   ;
Insured_d2   =PopT-EldPopT      ;if Insured   =. then Insured_d2   =0;if Insured   =. then Insured   =0;Insured_w   =Insured   *Insured_d2   ;
InsuredA_d2  =PopT-CPopT-EldPopT;if InsuredA  =. then InsuredA_d2  =0;if InsuredA  =. then InsuredA  =0;InsuredA_w  =InsuredA  *InsuredA_d2  ;
InsuredC_d2  =CPopT             ;if InsuredC  =. then InsuredC_d2  =0;if InsuredC  =. then InsuredC  =0;InsuredC_w  =InsuredC  *InsuredC_d2  ;
JuvArr_d2    =CPop3             ;if JuvArr    =. then JuvArr_d2    =0;if JuvArr    =. then JuvArr    =0;JuvArr_w    =JuvArr    *JuvArr_d2    ;
LAccFood_d2  =PopT              ;if LAccFood  =. then LAccFood_d2  =0;if LAccFood  =. then LAccFood  =0;LAccFood_w  =LAccFood  *LAccFood_d2  ;
LifeExp_d2   =PopT              ;if LifeExp   =. then LifeExp_d2   =0;if LifeExp   =. then LifeExp   =0;LifeExp_w   =LifeExp   *LifeExp_d2   ;
LifeExpB_d2  =PopB              ;if LifeExpB  =. then LifeExpB_d2  =0;if LifeExpB  =. then LifeExpB  =0;LifeExpB_w  =LifeExpB  *LifeExpB_d2  ;
LifeExpH_d2  =PopH              ;if LifeExpH  =. then LifeExpH_d2  =0;if LifeExpH  =. then LifeExpH  =0;LifeExpH_w  =LifeExpH  *LifeExpH_d2  ;
LifeExpW_d2  =PopW              ;if LifeExpW  =. then LifeExpW_d2  =0;if LifeExpW  =. then LifeExpW  =0;LifeExpW_w  =LifeExpW  *LifeExpW_d2  ;
LongComm_d2  =LongComm_d        ;if LongComm  =. then LongComm_d2  =0;if LongComm  =. then LongComm  =0;LongComm_w  =LongComm  *LongComm_d2  ;
LowBW_d2     =CPopT             ;if LowBW     =. then LowBW_d2     =0;if LowBW     =. then LowBW     =0;LowBW_w     =LowBW     *LowBW_d2     ;
LowBWB_d2    =CPopB             ;if LowBWB    =. then LowBWB_d2    =0;if LowBWB    =. then LowBWB    =0;LowBWB_w    =LowBWB    *LowBWB_d2    ;
LowBWH_d2    =CPopH             ;if LowBWH    =. then LowBWH_d2    =0;if LowBWH    =. then LowBWH    =0;LowBWH_w    =LowBWH    *LowBWH_d2    ;
LowBWW_d2    =CPopW             ;if LowBWW    =. then LowBWW_d2    =0;if LowBWW    =. then LowBWW    =0;LowBWW_w    =LowBWW    *LowBWW_d2    ;
Mental_d2    =PopT-CPopT        ;if Mental    =. then Mental_d2    =0;if Mental    =. then Mental    =0;Mental_w    =Mental    *Mental_d2    ;
MHPrvd_d2    =PopT              ;if MHPrvd    =. then MHPrvd_d2    =0;if MHPrvd    =. then MHPrvd    =0;MHPrvd_w    =MHPrvd    *MHPrvd_d2    ;
Murder_d2    =PopT              ;if Murder    =. then Murder_d2    =0;if Murder    =. then Murder    =0;Murder_w    =Murder    *Murder_d2    ;
Obesity_d2   =APopT             ;if Obesity   =. then Obesity_d2   =0;if Obesity   =. then Obesity   =0;Obesity_w   =Obesity   *Obesity_d2   ;
PCP_d2       =PopT              ;if PCP       =. then PCP_d2       =0;if PCP       =. then PCP       =0;PCP_w       =PCP       *PCP_d2       ;
PCP2_d2      =PopT              ;if PCP2      =. then PCP2_d2      =0;if PCP2      =. then PCP2      =0;PCP2_w      =PCP2      *PCP2_d2      ;
Physical_d2  =PopT-CPopT        ;if Physical  =. then Physical_d2  =0;if Physical  =. then Physical  =0;Physical_w  =Physical  *Physical_d2  ;
PoorHlth_d2  =PopT-CPopT        ;if PoorHlth  =. then PoorHlth_d2  =0;if PoorHlth  =. then PoorHlth  =0;PoorHlth_w  =PoorHlth  *PoorHlth_d2  ;
PoorMH_d2    =PopT-CPopT        ;if PoorMH    =. then PoorMH_d2    =0;if PoorMH    =. then PoorMH    =0;PoorMH_w    =PoorMH    *PoorMH_d2    ;
PoorPhy_d2   =PopT-CPopT        ;if PoorPhy   =. then PoorPhy_d2   =0;if PoorPhy   =. then PoorPhy   =0;PoorPhy_w   =PoorPhy   *PoorPhy_d2   ;
PrmDeath_d2  =PopT              ;if PrmDeath  =. then PrmDeath_d2  =0;if PrmDeath  =. then PrmDeath  =0;PrmDeath_w  =PrmDeath  *PrmDeath_d2  ;
PrmDeathc_d2 =PopT              ;if PrmDeathc =. then PrmDeathc_d2 =0;if PrmDeathc =. then PrmDeathc =0;PrmDeathc_w =PrmDeathc *PrmDeathc_d2 ;
PrmDeath2_d2 =PopT              ;if PrmDeath2 =. then PrmDeath2_d2 =0;if PrmDeath2 =. then PrmDeath2 =0;PrmDeath2_w =PrmDeath2 *PrmDeath2_d2 ;
PrmDeath2c_d2=PopT              ;if PrmDeath2c=. then PrmDeath2c_d2=0;if PrmDeath2c=. then PrmDeath2c=0;PrmDeath2c_w=PrmDeath2c*PrmDeath2c_d2;
PrmDeath2B_d2=PopB              ;if PrmDeath2B=. then PrmDeath2B_d2=0;if PrmDeath2B=. then PrmDeath2B=0;PrmDeath2B_w=PrmDeath2B*PrmDeath2B_d2;
PrmDeath2H_d2=PopH              ;if PrmDeath2H=. then PrmDeath2H_d2=0;if PrmDeath2H=. then PrmDeath2H=0;PrmDeath2H_w=PrmDeath2H*PrmDeath2H_d2;
PrmDeath2W_d2=PopW              ;if PrmDeath2W=. then PrmDeath2W_d2=0;if PrmDeath2W=. then PrmDeath2W=0;PrmDeath2W_w=PrmDeath2W*PrmDeath2W_d2;
PrmDeathB_d2 =PopB              ;if PrmDeathB =. then PrmDeathB_d2 =0;if PrmDeathB =. then PrmDeathB =0;PrmDeathB_w =PrmDeathB *PrmDeathB_d2 ;
PrmDeathH_d2 =PopH              ;if PrmDeathH =. then PrmDeathH_d2 =0;if PrmDeathH =. then PrmDeathH =0;PrmDeathH_w =PrmDeathH *PrmDeathH_d2 ;
PrmDeathW_d2 =PopW              ;if PrmDeathW =. then PrmDeathW_d2 =0;if PrmDeathW =. then PrmDeathW =0;PrmDeathW_w =PrmDeathW *PrmDeathW_d2 ;
PrvtHosp_d2  =EldPopT           ;if PrvtHosp  =. then PrvtHosp_d2  =0;if PrvtHosp  =. then PrvtHosp  =0;PrvtHosp_w  =PrvtHosp  *PrvtHosp_d2  ;
PrvtHospB_d2 =EldPopB           ;if PrvtHospB =. then PrvtHospB_d2 =0;if PrvtHospB =. then PrvtHospB =0;PrvtHospB_w =PrvtHospB *PrvtHospB_d2 ;
PrvtHospH_d2 =EldPopH           ;if PrvtHospH =. then PrvtHospH_d2 =0;if PrvtHospH =. then PrvtHospH =0;PrvtHospH_w =PrvtHospH *PrvtHospH_d2 ;
PrvtHospW_d2 =EldPopW           ;if PrvtHospW =. then PrvtHospW_d2 =0;if PrvtHospW =. then PrvtHospW =0;PrvtHospW_w =PrvtHospW *PrvtHospW_d2 ;
SegBW_d2     =PopT              ;if SegBW     =. then SegBW_d2     =0;if SegBW     =. then SegBW     =0;SegBW_w     =SegBW     *SegBW_d2     ;
SegNW_d2     =PopT              ;if SegNW     =. then SegNW_d2     =0;if SegNW     =. then SegNW     =0;SegNW_w     =SegNW     *SegNW_d2     ;
Sleep_d2     =PopT-CPopT        ;if Sleep     =. then Sleep_d2     =0;if Sleep     =. then Sleep     =0;Sleep_w     =Sleep     *Sleep_d2     ;
Smoke_d2     =PopT-CPopT        ;if Smoke     =. then Smoke_d2     =0;if Smoke     =. then Smoke     =0;Smoke_w     =Smoke     *Smoke_d2     ;
SocAsso_d2   =PopT              ;if SocAsso   =. then SocAsso_d2   =0;if SocAsso   =. then SocAsso   =0;SocAsso_w   =SocAsso   *SocAsso_d2   ;
SocSupp_d2   =PopT-CPopT        ;if SocSupp   =. then SocSupp_d2   =0;if SocSupp   =. then SocSupp   =0;SocSupp_w   =SocSupp   *SocSupp_d2   ;
STD_CT_d2    =PopT              ;if STD_CT    =. then STD_CT_d2    =0;if STD_CT    =. then STD_CT    =0;STD_CT_w    =STD_CT    *STD_CT_d2    ;
Suicide_d2   =PopT              ;if Suicide   =. then Suicide_d2   =0;if Suicide   =. then Suicide   =0;Suicide_w   =Suicide   *Suicide_d2   ;
TeenBth_d2   =TeenBPT           ;if TeenBth   =. then TeenBth_d2   =0;if TeenBth   =. then TeenBth   =0;TeenBth_w   =TeenBth   *TeenBth_d2   ;
TeenBthB_d2  =TeenBPB           ;if TeenBthB  =. then TeenBthB_d2  =0;if TeenBthB  =. then TeenBthB  =0;TeenBthB_w  =TeenBthB  *TeenBthB_d2  ;
TeenBthH_d2  =TeenBPH           ;if TeenBthH  =. then TeenBthH_d2  =0;if TeenBthH  =. then TeenBthH  =0;TeenBthH_w  =TeenBthH  *TeenBthH_d2  ;
TeenBthW_d2  =TeenBPW           ;if TeenBthW  =. then TeenBthW_d2  =0;if TeenBthW  =. then TeenBthW  =0;TeenBthW_w  =TeenBthW  *TeenBthW_d2  ;
Violent_d2   =PopT              ;if Violent   =. then Violent_d2   =0;if Violent   =. then Violent   =0;Violent_w   =Violent   *Violent_d2   ;
drop
ChdDeath  
ChdDeathB 
ChdDeathH 
ChdDeathW 
Dentist   
Diabet    
DrugOd    
DrugOdB   
DrugOdH   
DrugOdW   
DWIDeath  
Edrink    
FastFood  
FoodEnv   
FoodIns   
FrLunch   
GunDeath  
GunDeathB 
GunDeathW 
Gym       
Gym2      
HousCost  
HousCosts 
HousCrowd 
Housing   
HousPlumb 
Inactive  
InfDeath  
InfDeathB 
InfDeathH 
InfDeathW 
Injury    
InjuryB   
InjuryH   
InjuryW   
Insured   
InsuredA  
InsuredC  
JuvArr    
LAccFood  
LifeExp   
LifeExpB  
LifeExpH  
LifeExpW  
LongComm  
LowBW     
LowBWB    
LowBWH    
LowBWW    
Mental    
MHPrvd    
Murder    
Obesity   
PCP       
PCP2      
Physical  
PoorHlth  
PoorMH    
PoorPhy   
PrmDeath  
PrmDeathc  
PrmDeath2 
PrmDeath2c 
PrmDeath2B
PrmDeath2H
PrmDeath2W
PrmDeathB 
PrmDeathH 
PrmDeathW 
PrvtHosp  
PrvtHospB 
PrvtHospH 
PrvtHospW 
SegBW     
SegNW     
Sleep     
Smoke     
SocAsso   
SocSupp   
STD_CT       
Suicide   
TeenBth   
TeenBthB  
TeenBthH  
TeenBthW  
Violent   
;run;
/*N=32205, 247 variables*/
/***/
/* Merging with CountyKey to aggregate CHR data counties suppressed/combined in CAN data */;
proc sort data=CHR04;by CountyFIPS;run; /*N=32205, 247 variables*/
data CHR05;merge CHR04(IN=A) CountyKey;by CountyFIPS;if A;
if CountyFlag=. then CountyYear=INT(CountyFIPS/1000)*10000000+9990000+Year;run; 
/*N=32205, 248 variables*/
/***/
/* Aggregating CHR data counties suppressed/combined in CAN data */;
proc summary data=CHR05 nway;class CountyYear;var _numeric_;output out=CHR06 sum=;run; 
/*N=6410, 250 variables*/
/***/
/*Computing Rates and Making Missing When Coverage < 0.8 for Aggregated Counties*/;
data CHR07;
retain
CHR_Flag
CountyYear
ChdDeath
ChdDeathB
ChdDeathH
ChdDeathW
Dentist
Diabet
DrugOd
DrugOdB
DrugOdH
DrugOdW
DWIDeath
EDrink
FastFood
FoodEnv
FoodIns
FrLunch
GunDeath
GunDeathB
GunDeathW
Gym
Gym2
HousCost
HousCosts
HousCrowd
Housing
HousPlumb
Inactive
InfDeath
InfDeathB
InfDeathH
InfDeathW
Injury
InjuryB
InjuryH
InjuryW
Insured
InsuredA
InsuredC
JuvArr
LAccFood
LifeExp
LifeExpB
LifeExpH
LifeExpW
LongComm
LowBW
LowBWB
LowBWH
LowBWW
Mental
MHPrvd
Murder
Obesity
PCP
PCP2
Physical
PoorHlth
PoorMH
PoorPhy
PrmDeath
PrmDeathc
PrmDeath2
PrmDeath2c
PrmDeath2B
PrmDeath2H
PrmDeath2W
PrmDeathB
PrmDeathH
PrmDeathW
PrvtHosp
PrvtHospB
PrvtHospH
PrvtHospW
SegBW
SegNW
Sleep
Smoke
SocAsso
SocSupp
STD_CT
Suicide
TeenBth
TeenBthB
TeenBthH
TeenBthW
Violent
;
set CHR06;
CHR_Flag=1;
/*Computing rates********************//*IF coverage < 0.8 THEN missing***************************/
ChdDeath  =ChdDeath_w  /ChdDeath_d2  ;if ChdDeath_d2  /(CPopT             )<0.8 then ChdDeath  =.;
ChdDeathB =ChdDeathB_w /ChdDeathB_d2 ;if ChdDeathB_d2 /(CPopB             )<0.8 then ChdDeathB =.;
ChdDeathH =ChdDeathH_w /ChdDeathH_d2 ;if ChdDeathH_d2 /(CPopH             )<0.8 then ChdDeathH =.;
ChdDeathW =ChdDeathW_w /ChdDeathW_d2 ;if ChdDeathW_d2 /(CPopW             )<0.8 then ChdDeathW =.;
Dentist   =Dentist_w   /Dentist_d2   ;if Dentist_d2   /(PopT              )<0.8 then Dentist   =.;
Diabet    =Diabet_w    /Diabet_d2    ;if Diabet_d2    /(APopT             )<0.8 then Diabet    =.;
DrugOd    =DrugOd_w    /DrugOd_d2    ;if DrugOd_d2    /(PopT              )<0.8 then DrugOd    =.;
DrugOdB   =DrugOdB_w   /DrugOdB_d2   ;if DrugOdB_d2   /(PopB              )<0.8 then DrugOdB   =.;
DrugOdH   =DrugOdH_w   /DrugOdH_d2   ;if DrugOdH_d2   /(PopH              )<0.8 then DrugOdH   =.;
DrugOdW   =DrugOdW_w   /DrugOdW_d2   ;if DrugOdW_d2   /(PopW              )<0.8 then DrugOdW   =.;
DWIDeath  =DWIDeath_w  /DWIDeath_d2  ;if DWIDeath_d2  /(DWIDeath_d        )<0.8 then DWIDeath  =.;
Edrink    =Edrink_w    /Edrink_d2    ;if Edrink_d2    /(PopT-CPopT        )<0.8 then Edrink    =.;
FastFood  =FastFood_w  /FastFood_d2  ;if FastFood_d2  /(FastFood_d        )<0.8 then FastFood  =.;
FoodEnv   =FoodEnv_w   /FoodEnv_d2   ;if FoodEnv_d2   /(PopT              )<0.8 then FoodEnv   =.;
FoodIns   =FoodIns_w   /FoodIns_d2   ;if FoodIns_d2   /(PopT              )<0.8 then FoodIns   =.;
FrLunch   =FrLunch_w   /FrLunch_d2   ;if FrLunch_d2   /(CPop2+CPop3       )<0.8 then FrLunch   =.;
GunDeath  =GunDeath_w  /GunDeath_d2  ;if GunDeath_d2  /(PopT              )<0.8 then GunDeath  =.;
GunDeathB =GunDeathB_w /GunDeathB_d2 ;if GunDeathB_d2 /(PopB              )<0.8 then GunDeathB =.;
GunDeathW =GunDeathW_w /GunDeathW_d2 ;if GunDeathW_d2 /(PopW              )<0.8 then GunDeathW =.;
Gym       =Gym_w       /Gym_d2       ;if Gym_d2       /(PopT              )<0.8 then Gym       =.;
Gym2      =Gym2_w      /Gym2_d2      ;if Gym2_d2      /(PopT              )<0.8 then Gym2      =.;
HousCost  =HousCost_w  /HousCost_d2  ;if HousCost_d2  /(RPovPT            )<0.8 then HousCost  =.;
HousCosts =HousCosts_w /HousCosts_d2 ;if HousCosts_d2 /(RPovPT            )<0.8 then HousCosts =.;
HousCrowd =HousCrowd_w /HousCrowd_d2 ;if HousCrowd_d2 /(RPovPT            )<0.8 then HousCrowd =.;
Housing   =Housing_w   /Housing_d2   ;if Housing_d2   /(RPovPT            )<0.8 then Housing   =.;
HousPlumb =HousPlumb_w /HousPlumb_d2 ;if HousPlumb_d2 /(RPovPT            )<0.8 then HousPlumb =.;
Inactive  =Inactive_w  /Inactive_d2  ;if Inactive_d2  /(APopT             )<0.8 then Inactive  =.;
InfDeath  =InfDeath_w  /InfDeath_d2  ;if InfDeath_d2  /(CPopT             )<0.8 then InfDeath  =.;
InfDeathB =InfDeathB_w /InfDeathB_d2 ;if InfDeathB_d2 /(CPopB             )<0.8 then InfDeathB =.;
InfDeathH =InfDeathH_w /InfDeathH_d2 ;if InfDeathH_d2 /(CPopH             )<0.8 then InfDeathH =.;
InfDeathW =InfDeathW_w /InfDeathW_d2 ;if InfDeathW_d2 /(CPopW             )<0.8 then InfDeathW =.;
Injury    =Injury_w    /Injury_d2    ;if Injury_d2    /(PopT              )<0.8 then Injury    =.;
InjuryB   =InjuryB_w   /InjuryB_d2   ;if InjuryB_d2   /(PopB              )<0.8 then InjuryB   =.;
InjuryH   =InjuryH_w   /InjuryH_d2   ;if InjuryH_d2   /(PopH              )<0.8 then InjuryH   =.;
InjuryW   =InjuryW_w   /InjuryW_d2   ;if InjuryW_d2   /(PopW              )<0.8 then InjuryW   =.;
Insured   =Insured_w   /Insured_d2   ;if Insured_d2   /(PopT-EldPopT      )<0.8 then Insured   =.;
InsuredA  =InsuredA_w  /InsuredA_d2  ;if InsuredA_d2  /(PopT-CPopT-EldPopT)<0.8 then InsuredA  =.;
InsuredC  =InsuredC_w  /InsuredC_d2  ;if InsuredC_d2  /(CPopT             )<0.8 then InsuredC  =.;
JuvArr    =JuvArr_w    /JuvArr_d2    ;if JuvArr_d2    /(CPop3             )<0.8 then JuvArr    =.;
LAccFood  =LAccFood_w  /LAccFood_d2  ;if LAccFood_d2  /(PopT              )<0.8 then LAccFood  =.;
LifeExp   =LifeExp_w   /LifeExp_d2   ;if LifeExp_d2   /(PopT              )<0.8 then LifeExp   =.;
LifeExpB  =LifeExpB_w  /LifeExpB_d2  ;if LifeExpB_d2  /(PopB              )<0.8 then LifeExpB  =.;
LifeExpH  =LifeExpH_w  /LifeExpH_d2  ;if LifeExpH_d2  /(PopH              )<0.8 then LifeExpH  =.;
LifeExpW  =LifeExpW_w  /LifeExpW_d2  ;if LifeExpW_d2  /(PopW              )<0.8 then LifeExpW  =.;
LongComm  =LongComm_w  /LongComm_d2  ;if LongComm_d2  /(LongComm_d        )<0.8 then LongComm  =.;
LowBW     =LowBW_w     /LowBW_d2     ;if LowBW_d2     /(CPopT             )<0.8 then LowBW     =.;
LowBWB    =LowBWB_w    /LowBWB_d2    ;if LowBWB_d2    /(CPopB             )<0.8 then LowBWB    =.;
LowBWH    =LowBWH_w    /LowBWH_d2    ;if LowBWH_d2    /(CPopH             )<0.8 then LowBWH    =.;
LowBWW    =LowBWW_w    /LowBWW_d2    ;if LowBWW_d2    /(CPopW             )<0.8 then LowBWW    =.;
Mental    =Mental_w    /Mental_d2    ;if Mental_d2    /(PopT-CPopT        )<0.8 then Mental    =.;
MHPrvd    =MHPrvd_w    /MHPrvd_d2    ;if MHPrvd_d2    /(PopT              )<0.8 then MHPrvd    =.;
Murder    =Murder_w    /Murder_d2    ;if Murder_d2    /(PopT              )<0.8 then Murder    =.;
Obesity   =Obesity_w   /Obesity_d2   ;if Obesity_d2   /(APopT             )<0.8 then Obesity   =.;
PCP       =PCP_w       /PCP_d2       ;if PCP_d2       /(PopT              )<0.8 then PCP       =.;
PCP2      =PCP2_w      /PCP2_d2      ;if PCP2_d2      /(PopT              )<0.8 then PCP2      =.;
Physical  =Physical_w  /Physical_d2  ;if Physical_d2  /(PopT-CPopT        )<0.8 then Physical  =.;
PoorHlth  =PoorHlth_w  /PoorHlth_d2  ;if PoorHlth_d2  /(PopT-CPopT        )<0.8 then PoorHlth  =.;
PoorMH    =PoorMH_w    /PoorMH_d2    ;if PoorMH_d2    /(PopT-CPopT        )<0.8 then PoorMH    =.;
PoorPhy   =PoorPhy_w   /PoorPhy_d2   ;if PoorPhy_d2   /(PopT-CPopT        )<0.8 then PoorPhy   =.;
PrmDeath  =PrmDeath_w  /PrmDeath_d2  ;if PrmDeath_d2  /(PopT              )<0.8 then PrmDeath  =.;
PrmDeathc =PrmDeathc_w /PrmDeathc_d2 ;if PrmDeathc_d2 /(PopT              )<0.8 then PrmDeathc =.;
PrmDeath2 =PrmDeath2_w /PrmDeath2_d2 ;if PrmDeath2_d2 /(PopT              )<0.8 then PrmDeath2 =.;
PrmDeath2c=PrmDeath2c_w/PrmDeath2c_d2;if PrmDeath2c_d2/(PopT              )<0.8 then PrmDeath2c=.;
PrmDeath2B=PrmDeath2B_w/PrmDeath2B_d2;if PrmDeath2B_d2/(PopB              )<0.8 then PrmDeath2B=.;
PrmDeath2H=PrmDeath2H_w/PrmDeath2H_d2;if PrmDeath2H_d2/(PopH              )<0.8 then PrmDeath2H=.;
PrmDeath2W=PrmDeath2W_w/PrmDeath2W_d2;if PrmDeath2W_d2/(PopW              )<0.8 then PrmDeath2W=.;
PrmDeathB =PrmDeathB_w /PrmDeathB_d2 ;if PrmDeathB_d2 /(PopB              )<0.8 then PrmDeathB =.;
PrmDeathH =PrmDeathH_w /PrmDeathH_d2 ;if PrmDeathH_d2 /(PopH              )<0.8 then PrmDeathH =.;
PrmDeathW =PrmDeathW_w /PrmDeathW_d2 ;if PrmDeathW_d2 /(PopW              )<0.8 then PrmDeathW =.;
PrvtHosp  =PrvtHosp_w  /PrvtHosp_d2  ;if PrvtHosp_d2  /(EldPopT           )<0.8 then PrvtHosp  =.;
PrvtHospB =PrvtHospB_w /PrvtHospB_d2 ;if PrvtHospB_d2 /(EldPopB           )<0.8 then PrvtHospB =.;
PrvtHospH =PrvtHospH_w /PrvtHospH_d2 ;if PrvtHospH_d2 /(EldPopH           )<0.8 then PrvtHospH =.;
PrvtHospW =PrvtHospW_w /PrvtHospW_d2 ;if PrvtHospW_d2 /(EldPopW           )<0.8 then PrvtHospW =.;
SegBW     =SegBW_w     /SegBW_d2     ;if SegBW_d2     /(PopT              )<0.8 then SegBW     =.;
SegNW     =SegNW_w     /SegNW_d2     ;if SegNW_d2     /(PopT              )<0.8 then SegNW     =.;
Sleep     =Sleep_w     /Sleep_d2     ;if Sleep_d2     /(PopT-CPopT        )<0.8 then Sleep     =.;
Smoke     =Smoke_w     /Smoke_d2     ;if Smoke_d2     /(PopT-CPopT        )<0.8 then Smoke     =.;
SocAsso   =SocAsso_w   /SocAsso_d2   ;if SocAsso_d2   /(PopT              )<0.8 then SocAsso   =.;
SocSupp   =SocSupp_w   /SocSupp_d2   ;if SocSupp_d2   /(PopT-CPopT        )<0.8 then SocSupp   =.;
STD       =STD_CT_w    /STD_CT_d2    ;if STD_CT_d2    /(PopT              )<0.8 then STD       =.;
Suicide   =Suicide_w   /Suicide_d2   ;if Suicide_d2   /(PopT              )<0.8 then Suicide   =.;
TeenBth   =TeenBth_w   /TeenBth_d2   ;if TeenBth_d2   /(TeenBPT           )<0.8 then TeenBth   =.;
TeenBthB  =TeenBthB_w  /TeenBthB_d2  ;if TeenBthB_d2  /(TeenBPB           )<0.8 then TeenBthB  =.;
TeenBthH  =TeenBthH_w  /TeenBthH_d2  ;if TeenBthH_d2  /(TeenBPH           )<0.8 then TeenBthH  =.;
TeenBthW  =TeenBthW_w  /TeenBthW_d2  ;if TeenBthW_d2  /(TeenBPW           )<0.8 then TeenBthW  =.;
Violent   =Violent_w   /Violent_d2   ;if Violent_d2   /(PopT              )<0.8 then Violent   =.;
label
ChdDeath="Child mortality: # deaths among children under age 18 per 100k population"
ChdDeathB="Child mortality: # deaths among children under age 18 per 100k population, Black"
ChdDeathH="Child mortality: # deaths among children under age 18 per 100k population, Hispanic"
ChdDeathW="Child mortality: # deaths among children under age 18 per 100k population, White"
Dentist="Dentists: # dentists per 100k population"
Diabet="Diabetes prevalence: % adults >= age 20 with diagnosed diabetes"
DrugOd="Drug overdose deaths: # drug poisoning deaths per 100k population"
DrugOdB="Drug overdose deaths: # drug poisoning deaths per 100k Blacks"
DrugOdH="Drug overdose deaths: # drug poisoning deaths per 100k Hispanics"
DrugOdW="Drug overdose deaths: # drug poisoning deaths per 100k Whites"
DWIDeath="Alcohol-impaired driving deaths: % driving deaths with alcohol involvement"
Edrink="Excessive drinking: % adults reporting excessive (binge or heavy) drinking in past 30 days"
FastFood="Fast food restaurants: % restaurants that are fast food restaurants"
FoodEnv="Food environment index: Indicator of access to healthy foods - 0 is worst, 10 is best"
FoodIns="Food insecurity: % population who lack adequate access to food"
FrLunch="Children eligible for free lunch: % children (in public schools) eligible for free lunch"
GunDeath="Firearm fatalities: # deaths due to firearms per 100k population"
GunDeathB="Firearm fatalities: # deaths due to firearms per 100k population, Black"
GunDeathW="Firearm fatalities: # deaths due to firearms per 100k population, White"
Gym="Access to recreational facilities: Recreational facility access rate per 100K population"
Gym2="Access to exercise opportunities: % population with adequate access to locations for physical activity"
HousCost="Severe housing cost burden: % households that spend 50% or more of their household income on housing"
HousCosts="Housing problem: high housing costs: % households with high housing costs"
HousCrowd="Housing problem: overcrowding: % households with overcrowding"
Housing="Severe housing problems: % households with at least 1 of 4 housing problems: overcrowding, high housing costs, or lack of kitchen or plumbing facilities"
HousPlumb="Housing problem: lack of kitchen or plumbing facilities: % households with lack of kitchen or plumbing facilities"
Inactive="Physical inactivity: % adults >= age 20 reporting no leisure time physical activity"
InfDeath="Infant mortality: # all infant deaths (within 1 year), per 1k live births"
InfDeathB="Infant mortality: # all infant deaths (within 1 year), per 1k live births, Black"
InfDeathH="Infant mortality: # all infant deaths (within 1 year), per 1k live births, Hispanic"
InfDeathW="Infant mortality: # all infant deaths (within 1 year), per 1k live births, White"
Injury="Injury deaths: # deaths due to injury per 100k population"
InjuryB="Injury deaths: # deaths due to injury per 100k for non-Hispanic Blacks"
InjuryH="Injury deaths: # deaths due to injury per 100k for Hispanics"
InjuryW="Injury deaths: # deaths due to injury per 100k for non-Hispanic Whites"
Insured="Uninsured: % population < age 65 without health insurance"
InsuredA="Uninsured adults: % adults 18-64 without health insurance"
InsuredC="Uninsured children: % children < age 19 without health insurance"
JuvArr="Juvenile arrests: Rate of delinquency cases per 1k juveniles"
LAccFood="Limited access to healthy foods: % population living in poverty and more than 1 or 10 miles from a grocery store"
LifeExp="Life expectancy: Average # of years a person can expect to live"
LifeExpB="Life expectancy: Average # of years a person can expect to live, Black"
LifeExpH="Life expectancy: Average # of years a person can expect to live, Hispanic"
LifeExpW="Life expectancy: Average # of years a person can expect to live, White"
LongComm="Long commute - driving alone: % commuting > 30 minutes among workers commuting in their car alone"
LowBW="Low birthweight: % births with low birth weight (<2.5kg)"
LowBWB="Low birthweight: % births with low birth weight (<2.5kg) for non-Hispanic Blacks"
LowBWH="Low birthweight: % births with low birth weight (<2.5kg) for Hispanics"
LowBWW="Low birthweight: % births with low birth weight (<2.5kg) for non-Hispanic Whites"
Mental="Frequent mental distress: % adults reporting >= 14 days of poor mental health per month"
MHPrvd="Mental health providers: # Mental Health Providers per 100k population"
Murder="Homicides: # deaths from assaults per 100k population"
Obesity="Adult obesity: % adults reporting BMI >= 30"
PCP="Primary care physicians: Primary care physicians in patient care per 100k population"
PCP2="Other primary care providers: Primary care providers other than physicians (ie, nurse practitioners, physician assistants, clinical nurse specialists) per 100k population"
Physical="Frequent physical distress: % adults reporting >= 14 days of poor physical health per month"
PoorHlth="Poor or fair health: % adults reporting fair or poor health (age-adjusted)"
PoorMH="Poor mental health days: Average # mentally unhealthy days reported in past 30 days (age-adjusted)"
PoorPhy="Poor physical health days: Average # physically unhealthy days reported in past 30 days (age-adjusted)"
PrmDeath="Premature death: Age-adjusted Years of Potential Life Lost (YPLL) before age 75 per 100k population"
PrmDeathc="Premature death: Crude Years of Potential Life Lost (YPLL) before age 75 per 100k population"
PrmDeath2="Premature age-adjusted mortality: # deaths among residents under age 75 per 100k population (age-adjusted)"
PrmDeath2c="Premature crude mortality: # deaths among residents under age 75 per 100k population (age-adjusted)"
PrmDeath2B="Premature age-adjusted mortality: # deaths among residents under age 75 per 100k population (age-adjusted), Black"
PrmDeath2H="Premature age-adjusted mortality: # deaths among residents under age 75 per 100k population (age-adjusted), Hispanic"
PrmDeath2W="Premature age-adjusted mortality: # deaths among residents under age 75 per 100k population (age-adjusted), White"
PrmDeathB="Premature death: Age-adjusted YPLL before age 75 per 100k non-Hispanic Blacks"
PrmDeathH="Premature death: Age-adjusted YPLL before age 75 per 100k Hispanics"
PrmDeathW="Premature death: Age-adjusted YPLL before age 75 per 100k non-Hispanic Whites"
PrvtHosp="Preventable hospital stays: # hospital stays for ambulatory-care sensitive conditions per 1k Medicare enrollees (per 100k after 2018)"
PrvtHospB="Preventable hospital stays: # hospital stays for ambulatory-care sensitive conditions per 1k Medicare enrollees for Blacks"
PrvtHospH="Preventable hospital stays: # hospital stays for ambulatory-care sensitive conditions per 1k Medicare enrollees for Hispanics"
PrvtHospW="Preventable hospital stays: # hospital stays for ambulatory-care sensitive conditions per 1k Medicare enrollees for Whites"
SegBW="Residential segregation - black/white: Index of dissimilarity (higher values = greater residential segregation b/w Black & White residents)"
SegNW="Residential segregation - non-white/white: Index of dissimilarity (higher values=greater residential segregation b/w non-White & White residents)"
Sleep="Insufficient sleep: % adults reporting < 7 hours of sleep on average"
Smoke="Adult smoking: % adults reporting currently smoking"
SocAsso="Social associations: # membership associations per 10k population"
SocSupp="Inadequate social support: % adults reporting not getting social/emotional support"
STD_CT="Chlamydia rate: # newly diagnosed chlamydia cases per 100k population"
Suicide="Suicides: # deaths due to suicide per 100k population"
TeenBth="Teen births: # births per 1k females ages 15-19"
TeenBthB="Teen births: # births per 1k females ages 15-19 for Black non-Hispanic mothers"
TeenBthH="Teen births: # births per 1k females ages 15-19 for Hispanic mothers"
TeenBthW="Teen births: # births per 1k females ages 15-19 for White non-Hispanic mothers"
Violent="Violent crime: # reported violent crime offenses per 100k population";
keep
CHR_Flag
CountyYear
ChdDeath
ChdDeathB
ChdDeathH
ChdDeathW
Dentist
Diabet
DrugOd
DrugOdB
DrugOdH
DrugOdW
DWIDeath
EDrink
FastFood
FoodEnv
FoodIns
FrLunch
GunDeath
GunDeathB
GunDeathW
Gym
Gym2
HousCost
HousCosts
HousCrowd
Housing
HousPlumb
Inactive
InfDeath
InfDeathB
InfDeathH
InfDeathW
Injury
InjuryB
InjuryH
InjuryW
Insured
InsuredA
InsuredC
JuvArr
LAccFood
LifeExp
LifeExpB
LifeExpH
LifeExpW
LongComm
LowBW
LowBWB
LowBWH
LowBWW
Mental
MHPrvd
Murder
Obesity
PCP
PCP2
Physical
PoorHlth
PoorMH
PoorPhy
PrmDeath
PrmDeathc
PrmDeath2
PrmDeath2c
PrmDeath2B
PrmDeath2H
PrmDeath2W
PrmDeathB
PrmDeathH
PrmDeathW
PrvtHosp
PrvtHospB
PrvtHospH
PrvtHospW
SegBW
SegNW
Sleep
Smoke
SocAsso
SocSupp
STD_CT
Suicide
TeenBth
TeenBthB
TeenBthH
TeenBthW
Violent
;run;
/*N=6410, 87 variables*/
/***/
/* Merging with CountyYrKey -- Inner join to exclude CHR data county-years that are missing in CAN data */;
proc sort data=CHR07;by CountyYear;run; /*N=6410, 87 variables*/
data CHR08;merge CHR07(IN=A) CountyYrKey(IN=B);by CountyYear;if (A=B);drop CountyYrFlag;run; 
/*N=6153, 87 variables*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* A06: Merging A05 and CHR Data ***************************************************************************************************************/
/********************************* A06: Merging A05 and CHR Data ***************************************************************************************************************/
/********************************* A06: Merging A05 and CHR Data ***************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/***/;
proc sort data=A05  ;by CountyYear;run;     /*N=6153, 898 variables*/
proc sort data=CHR08;by CountyYear;run;     /*N=6153,  87 variables*/
data A06;merge A05 CHR08;by CountyYear;run; /*N=6153, 984 variables*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* MIECHV Data *********************************************************************************************************************************/
/********************************* MIECHV Data *********************************************************************************************************************************/
/********************************* MIECHV Data *********************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/***/
/* Importing MIECHV data & Excluding Puerto Rico data */;
data MHV1;set i.MIECHV;if int(CountyFIPS/1000)^=72;drop NAME;run; 
/*N=12568, 4 variables */
/***/
/* Merging with census data (child population) to weight MIECHV provision (1=county served by MIECHV) by child population before aggregating counties suppressed in CAN data */;
proc sort data=MHV1   ;by CountyYear;run; /*N=12568*/
proc sort data=census1;by CountyYear;run; /*N=31425*/
data MHV2;merge MHV1(IN=A) census1;by CountyYear;if A;
MIECHVw=MIECHV*CPopT;label MIECHVw="# children living in a county served by MIECHV";
keep Year CountyYear CountyFIPS MIECHV MIECHVw CPopT;run;
/*N=12568, 6 variables*/
/***/
/* Merging with CountyKey to aggregate MIECHV data counties that are suppressed in CAN data */;
proc sort data=MHV2;by CountyFIPS;run; /*N=12568, 6 variables*/
data MHV3;merge MHV2(IN=A) CountyKey;by CountyFIPS;if A;
if CountyFlag=. then CountyYear=INT(CountyFIPS/1000)*10000000+9990000+Year;
keep CountyYear MIECHVw CPopT;run; 
/*N=12568, 3 variables*/
proc summary data=MHV3 nway;class CountyYear;var MIECHVw CPopT;output out=MHV4 sum=;run;
/*N=2564, 5 variables*/
/* Merging with CountyYrKey -- Inner join to exclude MIECHV data county-years that are missing in CAN data */;
proc sort data=MHV4;by CountyYear;run;
data MHV5;retain MHVFlag;merge MHV4(IN=A) CountyYrKey(IN=B);by CountyYear;if (A=B);MHVFlag=1;
MIECHV=MIECHVw/CPopT;
label MIECHV="For combined counties:% children residing in a county served by MIECHV; For identified counties:1=county served by MIECHV,0=otherwise";
keep MHVFlag CountyYear MIECHV;
run;
/*N=2556, 3 variables*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* A07: Merging A06 and MIECHV Data ************************************************************************************************************/
/********************************* A07: Merging A06 and MIECHV Data ************************************************************************************************************/
/********************************* A07: Merging A06 and MIECHV Data ************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/***/;
proc sort data=A06 ;by CountyYear;run;     /*N=6153, 984 variables*/
proc sort data=MHV5;by CountyYear;run;     /*N=2556,   3 variables*/
data A07;merge A06 MHV5;by CountyYear;run; /*N=6153, 986 variables*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* NHVRC: Evidence-Based Early Childhood Home Visiting Data ************************************************************************************/
/********************************* NHVRC: Evidence-Based Early Childhood Home Visiting Data ************************************************************************************/
/********************************* NHVRC: Evidence-Based Early Childhood Home Visiting Data ************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/***/
/* "Counties with at least one local home visiting agency offering evidence-based home visiting."
   ***
   Fiscal Year Data:
   ***
   2016 Data (https://www.nhvrc.org/wp-content/uploads/NHVRC_Data-Supplement_FINAL.pdf)
   "Estimates are based on data collected from 14 evidence-based model developers on the locations of their local agencies. The 14 models that provided location data are 
    Attachment and Biobehavioral Catch-Up (ABC), Child First, Early Head Start Home-Based Option (EHS), Family Check-Up, Family Spirit, Health Access Nurturing Development 
    Services (HANDS), Healthy Families America (HFA), Home Instruction for Parents of Preschool Youngsters (HIPPY), Maternal Early Childhood Sustained Home-Visiting (MECSH), 
    Minding the Baby, Nurse-Family Partnership (NFP), Parents as Teachers (PAT), Play and Learning Strategies (PALS), and SafeCare."
   ***
   2017 Data (https://www.nhvrc.org/wp-content/uploads/NHVRC_Yearbook_2018_FINAL.pdf)
   "Estimates are based on data collected from 15 evidence-based model developers on the locations of their local agencies. The 15 models that provided location data are 
    Attachment and Biobehavioral Catch-Up (ABC), Child First, Early Head Start Home-Based Option (EHS), Family Check-Up (FCU), Family Connects, Family Spirit, Health Access 
    Nurturing Development Services (HANDS), Healthy Families America (HFA), Home Instruction for Parents of Preschool Youngsters (HIPPY), Maternal Early Childhood Sustained 
    Home-Visiting (MECSH), Minding the Baby, Nurse-Family Partnership (NFP), Parents as Teachers (PAT), Play and Learning Strategies (PALS), and SafeCare."
   ***
   2018 Data (https://nhvrc.org/yearbook/2019-yearbook/about-home-visiting/)
   "Estimates are based on data collected from 13 evidence-based model developers on the locations of their local agencies. The 13 models that provided location data are 
    Attachment and Biobehavioral Catch-Up (ABC), Child First, Early Head Start Home-Based Option (EHS), Family Connects, Family Spirit, Health Access Nurturing Development 
    Services (HANDS), Healthy Families America (HFA), Home Instruction for Parents of Preschool Youngsters (HIPPY), Maternal Early Childhood Sustained Home-Visiting (MECSH), 
    Minding the Baby, Nurse-Family Partnership (NFP), Parents as Teachers (PAT), and SafeCare. While data in previous yearbooks included agencies implementing the PAT curriculum, 
    the 2018 data are limited to agencies fully implementing the PAT home visiting model."
/***/
/* Importing NHVRC data */;
data NHV1;set i.NHVRC;if Year<2019;keep CountyYear NHVRC;run; 
/*N=4760, 4 variables */
/***/
/* Merging with census data (child population) to weight evidence-based home visiting provision by child population before aggregating counties suppressed in CAN data */;
data Cen1;set census1;if 2015<Year;keep CountyYear CountyFIPS Year CPopT;run;
proc sort data=NHV1;by CountyYear;run;
proc sort data=Cen1;by CountyYear;run;
data NHV2;merge NHV1 Cen1(IN=A);by CountyYear;if A;
if NHVRC=. then NHVRC=0;
NHVRCw=NHVRC*CPopT;label NHVRCw="# children living in a county with a local agency offering evidence-based home visiting(NHVRC data)";
keep Year CountyYear CountyFIPS NHVRC NHVRCw CPopT;run;
/*N=9426, 6 variables*/
/***/
/* Merging with CountyKey to aggregate NHVRC data counties that are suppressed in CAN data */;
proc sort data=NHV2;by CountyFIPS;run; /*N=9426, 6 variables*/
data NHV3;merge NHV2(IN=A) CountyKey;by CountyFIPS;if A;
if CountyFlag=. then CountyYear=INT(CountyFIPS/1000)*10000000+9990000+Year;
keep CountyYear NHVRCw CPopT;run; 
/*N=9427, 3 variables*/
proc summary data=NHV3 nway;class CountyYear;var NHVRCw CPopT;output out=NHV4 sum=;run;
/*N=1665, 5 variables*/
/* Merging with CountyYrKey -- Inner join to exclude NHVRC data county-years that are missing in CAN data */;
proc sort data=NHV4;by CountyYear;run;
data NHV5;retain NHVFlag;merge NHV4(IN=A) CountyYrKey(IN=B);by CountyYear;if (A=B);NHVFlag=1;
NHVRC=NHVRCw/CPopT;
label NHVRC="For combined counties:% children residing in county with local agency offering EB-home visiting; For identified counties:1=county with local agency offering EB-home visiting(NHVRC data)";
keep NHVFlag CountyYear NHVRC;
run;
/*N=1659, 3 variables*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* A08: Merging A07 and NHVRC Data *************************************************************************************************************/
/********************************* A08: Merging A07 and NHVRC Data *************************************************************************************************************/
/********************************* A08: Merging A07 and NHVRC Data *************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/***/;
proc sort data=A07 ;by CountyYear;run;     /*N=6153, 986 variables*/
proc sort data=NHV5;by CountyYear;run;     /*N=1659,   3 variables*/
data A08;merge A07 NHV5;by CountyYear;run; /*N=6153, 988 variables*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Food Insecurity data ************************************************************************************************************************/
/********************************* Food Insecurity data ************************************************************************************************************************/
/********************************* Food Insecurity data ************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/***/
/* Importing data */;
data Food1;set h.Food;keep Year CountyFIPS CountyYear FoodInsN TPop;run;
/*N=34537, 5 variables*/
/***/
/* Merging with CountyKey to aggregate Opioid data counties that are suppressed in CAN data */;
proc sort data=Food1;by CountyFIPS;run;
data Food2;merge Food1(IN=A) CountyKey;by CountyFIPS;if A;
if CountyFlag=. then CountyYear=INT(CountyFIPS/1000)*10000000+9990000+Year;
keep CountyYear FoodInsN TPop;run; 
/*N=34537, 3 variables*/;
proc summary data=Food2 nway;class CountyYear;var FoodInsN TPop;output out=Food3 sum=;run; /*N=7051, 5 variables*/
data Food3;set Food3;
FoodInsecure=FoodInsN/TPop*100;
label FoodInsecure="% persons experienced food insecurity at some point during the year (Feeding America)";
keep CountyYear FoodInsecure;
run;
/*N=7051, 2 variables*/
/***/
/* Merging with CountyYrKey -- Inner join to exclude Opioid data county-years that are missing in CAN data */;
proc sort data=Food3;by CountyYear;run;
data Food4;retain FoodFlag;merge Food3(IN=A) CountyYrKey(IN=B);by CountyYear;if (A=B);
FoodFlag=1;
keep FoodFlag CountyYear FoodInsecure;
run;
/*N=6153, 3 variables*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* A09: Merging A08 and Food Insecurity Data ***************************************************************************************************/
/********************************* A09: Merging A08 and Food Insecurity Data ***************************************************************************************************/
/********************************* A09: Merging A08 and Food Insecurity Data ***************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/***/;
proc sort data=A08  ;by CountyYear;run;     /*N=6153, 988 variables*/
proc sort data=Food4;by CountyYear;run;     /*N=6153,   3 variables*/
data A09;merge A08 Food4;by CountyYear;run; /*N=6153, 990 variables*/





/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/********************************* Saving Permanent Data ***********************************************************************************************************************/
/********************************* Saving Permanent Data ***********************************************************************************************************************/
/********************************* Saving Permanent Data ***********************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
/*******************************************************************************************************************************************************************************/
data z.CDCK01County;set A09;run;
proc contents data=z.CDCK01County varnum;run;






